package org.ffd2.skeletonx.austenx.packrat.library;
import org.ffd2.skeletonx.austenx.lexi.tokens.*;
import org.ffd2.skeletonx.austenx.peg.base.*;
import org.ffd2.skeletonx.austenx.packrat.impl.*;
public final class SkeletonPackrat {
	private final org.ffd2.solar.general.Source<SkeletonToken> allTokens_;
	public SkeletonPackrat(org.ffd2.solar.general.Source<SkeletonToken> allTokens) {
		allTokens_ = allTokens;
	}
	private final SkeletonPackrat.Table createTable() {
		return new SkeletonPackrat.Table(allTokens_, this);
	}
	public static final org.ffd2.austenx.runtime.BuildStats quickAndSimpleBuildFile(org.ffd2.solar.language.CharacterSource fileText, SkeletonParser parser, FileRootBuilderForSkeleton target, org.ffd2.austenx.runtime.ParserErrorCatcher errorCatcher) {
		return quickBuildFile(fileText, parser, target, errorCatcher, errorCatcher);
	}
	public static final org.ffd2.austenx.runtime.BuildStats quickBuildFile(org.ffd2.solar.language.CharacterSource fileText, SkeletonParser parser, FileRootBuilderForSkeleton target, org.ffd2.austenx.runtime.LexErrorCatcher lexErrorCatcher, org.ffd2.austenx.runtime.PackratErrorCatcher packratErrorCatcher) {
		org.ffd2.solar.general.SimpleVector<SkeletonToken> tokens = new org.ffd2.solar.general.SimpleVector<SkeletonToken>();
		org.ffd2.austenx.runtime.ErrorCatcherTool errorCatcher = new org.ffd2.austenx.runtime.ErrorCatcherTool(lexErrorCatcher, packratErrorCatcher);
		parser.doParse(tokens, fileText, errorCatcher);
		if(!errorCatcher.isInError()) {
			SkeletonPackrat builder = new SkeletonPackrat(tokens);
			return builder.buildFile(target, errorCatcher);
		} else {
			return null;
		}
	}
	public final org.ffd2.austenx.runtime.BuildStats buildFile(FileRootBuilderForSkeleton builder, org.ffd2.austenx.runtime.PackratErrorCatcher errorCatcher) {
		SkeletonPackrat.Table table = createTable();
		org.ffd2.austenx.runtime.PackratElement base = table.getResult(0, 1);
		org.ffd2.austenx.runtime.ResolvedPackratElement resolved = base.getResolved();
		int tableWidth = table.getTableWidth();
		org.ffd2.austenx.runtime.ErrorInfo errorInfo = table.getErrorHintInfo();
		if(resolved == null) {
			if(errorInfo == null) {
				errorCatcher.failedParse(table.getMaximumAccessedToken());
			} else {
				errorCatcher.failedParseWithErrorHint(table.getMaximumAccessedToken(), errorInfo.getMessage());
			}
		} else {
			if(tableWidth != resolved.getWidth()) {
				if(errorInfo == null) {
					errorCatcher.incompleteParse(table.getTableToken(resolved.getWidth() - 1), table.getMaximumAccessedToken());
				} else {
					errorCatcher.incompleteParseWithErrorHint(table.getTableToken(resolved.getWidth() - 1), table.getMaximumAccessedToken(), errorInfo.getMessage());
				}
			} else {
				FilePatternPeer child = builder.buildFile();
				if(child != null) {
					resolved.updateConstruction(new AllDecodersSkeleton.FileDecoder(child));
					child.end();
				}
			}
		}
		return table.buildStats();
	}
	public static final org.ffd2.austenx.runtime.BuildStats quickAndSimpleBuildJavaImplementationIncludeFile(org.ffd2.solar.language.CharacterSource fileText, SkeletonParser parser, JavaImplementationIncludeFileRootBuilderForSkeleton target, org.ffd2.austenx.runtime.ParserErrorCatcher errorCatcher) {
		return quickBuildJavaImplementationIncludeFile(fileText, parser, target, errorCatcher, errorCatcher);
	}
	public static final org.ffd2.austenx.runtime.BuildStats quickBuildJavaImplementationIncludeFile(org.ffd2.solar.language.CharacterSource fileText, SkeletonParser parser, JavaImplementationIncludeFileRootBuilderForSkeleton target, org.ffd2.austenx.runtime.LexErrorCatcher lexErrorCatcher, org.ffd2.austenx.runtime.PackratErrorCatcher packratErrorCatcher) {
		org.ffd2.solar.general.SimpleVector<SkeletonToken> tokens = new org.ffd2.solar.general.SimpleVector<SkeletonToken>();
		org.ffd2.austenx.runtime.ErrorCatcherTool errorCatcher = new org.ffd2.austenx.runtime.ErrorCatcherTool(lexErrorCatcher, packratErrorCatcher);
		parser.doParse(tokens, fileText, errorCatcher);
		if(!errorCatcher.isInError()) {
			SkeletonPackrat builder = new SkeletonPackrat(tokens);
			return builder.buildJavaImplementationIncludeFile(target, errorCatcher);
		} else {
			return null;
		}
	}
	public final org.ffd2.austenx.runtime.BuildStats buildJavaImplementationIncludeFile(JavaImplementationIncludeFileRootBuilderForSkeleton builder, org.ffd2.austenx.runtime.PackratErrorCatcher errorCatcher) {
		SkeletonPackrat.Table table = createTable();
		org.ffd2.austenx.runtime.PackratElement base = table.getResult(0, 11);
		org.ffd2.austenx.runtime.ResolvedPackratElement resolved = base.getResolved();
		int tableWidth = table.getTableWidth();
		org.ffd2.austenx.runtime.ErrorInfo errorInfo = table.getErrorHintInfo();
		if(resolved == null) {
			if(errorInfo == null) {
				errorCatcher.failedParse(table.getMaximumAccessedToken());
			} else {
				errorCatcher.failedParseWithErrorHint(table.getMaximumAccessedToken(), errorInfo.getMessage());
			}
		} else {
			if(tableWidth != resolved.getWidth()) {
				if(errorInfo == null) {
					errorCatcher.incompleteParse(table.getTableToken(resolved.getWidth() - 1), table.getMaximumAccessedToken());
				} else {
					errorCatcher.incompleteParseWithErrorHint(table.getTableToken(resolved.getWidth() - 1), table.getMaximumAccessedToken(), errorInfo.getMessage());
				}
			} else {
				JavaImplementationIncludeFilePatternPeer child = builder.buildJavaImplementationIncludeFile();
				if(child != null) {
					resolved.updateConstruction(new AllDecodersSkeleton.JavaImplementationIncludeFileDecoder(child));
					child.end();
				}
			}
		}
		return table.buildStats();
	}
	public static final class Table {
		private final org.ffd2.austenx.runtime.ElementTableInterface concreteTable_;
		private final org.ffd2.solar.general.Source<SkeletonToken> allTokens_;
		private final int numberOfTokens_;
		private final ErrorToken errorToken_;
		private int maximumAccessedTokenIndex_ = 0;
		private java.lang.String maxErrorHint_;
		private int maxErrorTokenIndex_ = 0;
		private final SkeletonPackrat.BaseReader[] readers_;
		private SkeletonPackrat.Column columnPool_ = null;
		private int numberOfColumnObjects_ = 0;
		private final int[] memorisationUseCounts_;
		private int numberOfTableAccesses_ = 0;
		public Table(org.ffd2.solar.general.Source<SkeletonToken> allTokens, SkeletonPackrat parent) {
			allTokens_ = allTokens;
			errorToken_ = new ErrorToken();
			int numberOfTokens = allTokens.size();
			numberOfTokens_ = numberOfTokens;
			concreteTable_ = new org.ffd2.austenx.runtime.MatrixElementTable(numberOfTokens, 70);
			readers_ = new SkeletonPackrat.BaseReader[70];
			readers_[0] = new ImportReader(parent);
			readers_[1] = new FileReader(parent);
			readers_[2] = new PackagePathElementReader(parent);
			readers_[3] = new DesignBlockReader(parent);
			readers_[41] = new FixedArgValueReader(parent);
			readers_[42] = new DesignExpressionReader(parent);
			readers_[4] = new BlockElementReader(parent);
			readers_[5] = new TemplateElementReader(parent);
			readers_[43] = new ChainElementReader(parent);
			readers_[44] = new DesignTypeReader(parent);
			readers_[6] = new JavaExternalBlockReader(parent);
			readers_[7] = new JavaExternalElementReader(parent);
			readers_[8] = new LabelingSubsReader(parent);
			readers_[9] = new GenericsReader(parent);
			readers_[10] = new JavaImplementatonBlockReader(parent);
			readers_[11] = new JavaImplementationIncludeFileReader(parent);
			readers_[12] = new JavaImplementationSpecificsBlockReader(parent);
			readers_[45] = new SpecificsBlockElementReader(parent);
			readers_[13] = new JavaImplementationElementReader(parent);
			readers_[14] = new JavaMacroBlockReader(parent);
			readers_[46] = new ArgValsBlockBaseReader(parent);
			readers_[47] = new ArgTypesBlockBaseReader(parent);
			readers_[15] = new MacroElementReader(parent);
			readers_[48] = new TargetTypeElementReader(parent);
			readers_[49] = new TargetTypeListReader(parent);
			readers_[50] = new TargetTypeLinkReader(parent);
			readers_[51] = new SetsListReader(parent);
			readers_[16] = new JavaClassReader(parent);
			readers_[17] = new JavaInterfaceReader(parent);
			readers_[18] = new ChainHookListReader(parent);
			readers_[52] = new ChainHookElementReader(parent);
			readers_[19] = new JavaClassInterfaceElementReader(parent);
			readers_[53] = new FindDefinitionReader(parent);
			readers_[54] = new FindTargetReader(parent);
			readers_[55] = new SearchQueryReader(parent);
			readers_[56] = new GlobalElementReader(parent);
			readers_[57] = new GlobalMethodDefinitionReader(parent);
			readers_[58] = new GlobalClassDefinitionReader(parent);
			readers_[59] = new JavaPrototypeReader(parent);
			readers_[60] = new JavaMethodReader(parent);
			readers_[61] = new JavaConstructorReader(parent);
			readers_[20] = new JavaCodeBlockReader(parent);
			readers_[21] = new ForInitialStatementReader(parent);
			readers_[22] = new JavaStatementReader(parent);
			readers_[23] = new GeneralMacroCallReader(parent);
			readers_[62] = new GeneralSymbolReader(parent);
			readers_[24] = new JavaExpressionReader(parent);
			readers_[63] = new JavaInstanceVariableReader(parent);
			readers_[25] = new TargetTypeReferenceReader(parent);
			readers_[64] = new TargetTypeReferenceWithoutArrayReader(parent);
			readers_[26] = new BaseTargetTypeReferenceReader(parent);
			readers_[27] = new JavaCallChainReader(parent);
			readers_[65] = new JavaCallChainSectionReader(parent);
			readers_[28] = new JavaMethodCallReader(parent);
			readers_[29] = new TargetCallArgumentsReader(parent);
			readers_[30] = new TargetCallComponentReader(parent);
			readers_[66] = new GeneralTypeReader(parent);
			readers_[31] = new NameReader(parent);
			readers_[32] = new NameValueReader(parent);
			readers_[33] = new BuilderVariableChainReader(parent);
			readers_[34] = new LinkChainReader(parent);
			readers_[35] = new BuilderExpressionReader(parent);
			readers_[36] = new TargetParameterReader(parent);
			readers_[37] = new ParameterBlockReader(parent);
			readers_[67] = new ParameterReader(parent);
			readers_[68] = new MacroParameterBlockReader(parent);
			readers_[69] = new MacroCallParameterBlockReader(parent);
			readers_[38] = new MacroParameterReader(parent);
			readers_[39] = new MacroCallParameterReader(parent);
			readers_[40] = new SimpleParameterReader(parent);
			memorisationUseCounts_ = new int[41];
		}
		public final org.ffd2.austenx.runtime.PackratElement getResult(int column, int ruleIndex) {
			numberOfTableAccesses_++;
			if(column >= numberOfTokens_) {
				return org.ffd2.austenx.runtime.ErrorElement.getInstance();
			}
			if(ruleIndex < 41) {
				org.ffd2.austenx.runtime.PackratElement result = concreteTable_.getResult(column, ruleIndex);
				if(result == null) {
					SkeletonPackrat.Column c = allocateColumn(column);
					c.addRule(ruleIndex);
					c.doResolutions();
					result = concreteTable_.getResult(column, ruleIndex);
					deallocateColumn(c);
				} else {
					memorisationUseCounts_[ruleIndex]++;
				}
				return result;
			} else {
				SkeletonPackrat.Column c2 = allocateColumn(column);
				c2.addRule(ruleIndex);
				c2.doResolutions();
				org.ffd2.austenx.runtime.PackratElement result_1 = c2.getResult(0, ruleIndex);
				deallocateColumn(c2);
				return result_1;
			}
		}
		public final int getTableWidth() {
			return numberOfTokens_;
		}
		public final org.ffd2.austenx.runtime.ErrorInfo getErrorHintInfo() {
			return new org.ffd2.austenx.runtime.ErrorInfo(maxErrorHint_, allTokens_.get(maxErrorTokenIndex_), allTokens_.get(maximumAccessedTokenIndex_));
		}
		public final SkeletonToken getMaximumAccessedToken() {
			return getTableToken(maximumAccessedTokenIndex_);
		}
		public final SkeletonToken getTableToken(int column) {
			if(column >= numberOfTokens_) {
				return errorToken_;
			} else {
				if(column > maximumAccessedTokenIndex_) {
					maximumAccessedTokenIndex_ = column;
				}
				if(column < 0) {
					return errorToken_;
				}
				return allTokens_.get(column);
			}
		}
		public final org.ffd2.austenx.runtime.BuildStats buildStats() {
			java.lang.String[] allRuleNames = new java.lang.String[70];
			allRuleNames[0] = "Import";
			allRuleNames[1] = "File";
			allRuleNames[2] = "PackagePathElement";
			allRuleNames[3] = "DesignBlock";
			allRuleNames[41] = "FixedArgValue";
			allRuleNames[42] = "DesignExpression";
			allRuleNames[4] = "BlockElement";
			allRuleNames[5] = "TemplateElement";
			allRuleNames[43] = "ChainElement";
			allRuleNames[44] = "DesignType";
			allRuleNames[6] = "JavaExternalBlock";
			allRuleNames[7] = "JavaExternalElement";
			allRuleNames[8] = "LabelingSubs";
			allRuleNames[9] = "Generics";
			allRuleNames[10] = "JavaImplementatonBlock";
			allRuleNames[11] = "JavaImplementationIncludeFile";
			allRuleNames[12] = "JavaImplementationSpecificsBlock";
			allRuleNames[45] = "SpecificsBlockElement";
			allRuleNames[13] = "JavaImplementationElement";
			allRuleNames[14] = "JavaMacroBlock";
			allRuleNames[46] = "ArgValsBlockBase";
			allRuleNames[47] = "ArgTypesBlockBase";
			allRuleNames[15] = "MacroElement";
			allRuleNames[48] = "TargetTypeElement";
			allRuleNames[49] = "TargetTypeList";
			allRuleNames[50] = "TargetTypeLink";
			allRuleNames[51] = "SetsList";
			allRuleNames[16] = "JavaClass";
			allRuleNames[17] = "JavaInterface";
			allRuleNames[18] = "ChainHookList";
			allRuleNames[52] = "ChainHookElement";
			allRuleNames[19] = "JavaClassInterfaceElement";
			allRuleNames[53] = "FindDefinition";
			allRuleNames[54] = "FindTarget";
			allRuleNames[55] = "SearchQuery";
			allRuleNames[56] = "GlobalElement";
			allRuleNames[57] = "GlobalMethodDefinition";
			allRuleNames[58] = "GlobalClassDefinition";
			allRuleNames[59] = "JavaPrototype";
			allRuleNames[60] = "JavaMethod";
			allRuleNames[61] = "JavaConstructor";
			allRuleNames[20] = "JavaCodeBlock";
			allRuleNames[21] = "ForInitialStatement";
			allRuleNames[22] = "JavaStatement";
			allRuleNames[23] = "GeneralMacroCall";
			allRuleNames[62] = "GeneralSymbol";
			allRuleNames[24] = "JavaExpression";
			allRuleNames[63] = "JavaInstanceVariable";
			allRuleNames[25] = "TargetTypeReference";
			allRuleNames[64] = "TargetTypeReferenceWithoutArray";
			allRuleNames[26] = "BaseTargetTypeReference";
			allRuleNames[27] = "JavaCallChain";
			allRuleNames[65] = "JavaCallChainSection";
			allRuleNames[28] = "JavaMethodCall";
			allRuleNames[29] = "TargetCallArguments";
			allRuleNames[30] = "TargetCallComponent";
			allRuleNames[66] = "GeneralType";
			allRuleNames[31] = "Name";
			allRuleNames[32] = "NameValue";
			allRuleNames[33] = "BuilderVariableChain";
			allRuleNames[34] = "LinkChain";
			allRuleNames[35] = "BuilderExpression";
			allRuleNames[36] = "TargetParameter";
			allRuleNames[37] = "ParameterBlock";
			allRuleNames[67] = "Parameter";
			allRuleNames[68] = "MacroParameterBlock";
			allRuleNames[69] = "MacroCallParameterBlock";
			allRuleNames[38] = "MacroParameter";
			allRuleNames[39] = "MacroCallParameter";
			allRuleNames[40] = "SimpleParameter";
			return new org.ffd2.austenx.runtime.BuildStats(numberOfTokens_, numberOfColumnObjects_, numberOfTableAccesses_, memorisationUseCounts_, allRuleNames, 41);
		}
		public final void setErrorHint(java.lang.String message, int tokenIndex) {
			if(maxErrorTokenIndex_ <= tokenIndex) {
				maxErrorTokenIndex_ = tokenIndex;
				maxErrorHint_ = message;
			}
		}
		public final void clearError() {
			maxErrorHint_ = null;
			maxErrorTokenIndex_ = 0;
		}
		public final java.lang.String getErrorHint() {
			return maxErrorHint_;
		}
		public final SkeletonToken getErrorHintToken() {
			return getTableToken(maxErrorTokenIndex_);
		}
		public final SkeletonToken getTableTokenOrLast(int column) {
			if(column >= numberOfTokens_) {
				return getTableToken(numberOfTokens_ - 1);
			} else {
				if(column < 0) {
					return getTableToken(0);
				} else {
					return getTableToken(column);
				}
			}
		}
		public final boolean isTokenAt(int column) {
			return column >= 0 && column < numberOfTokens_;
		}
		public final org.ffd2.austenx.runtime.PackratElement checkResult(int column, int ruleIndex) {
			return concreteTable_.getResult(column, ruleIndex);
		}
		public final void updateResult(int column, int ruleIndex, org.ffd2.austenx.runtime.PackratElement result) {
			concreteTable_.setResult(column, ruleIndex, result);
		}
		public final SkeletonPackrat.BaseReader getReader(int ruleIndex) {
			return readers_[ruleIndex];
		}
		private final SkeletonPackrat.Column allocateColumn(int column) {
			SkeletonPackrat.Column c;
			if(columnPool_ != null) {
				c = columnPool_;
				columnPool_ = c.getPrevious();
				c.resetColumn(column);
			} else {
				c = new SkeletonPackrat.Column(this, column);
				numberOfColumnObjects_++;
			}
			return c;
		}
		private final void deallocateColumn(SkeletonPackrat.Column c) {
			c.setPrevious(columnPool_);
			columnPool_ = c;
		}
	}
	public static final class Column {
		private final SkeletonPackrat.Table baseTable_;
		private int column_;
		private final org.ffd2.austenx.runtime.PackratElement[] transientResults_;
		private final org.ffd2.solar.general.IntVector resolvingList_;
		private boolean recursiveRequestMade_;
		private SkeletonPackrat.Column previous_ = null;
		public Column(SkeletonPackrat.Table baseTable, int column) {
			baseTable_ = baseTable;
			column_ = column;
			transientResults_ = new org.ffd2.austenx.runtime.PackratElement[29];
			resolvingList_ = new org.ffd2.solar.general.IntVector();
		}
		public final org.ffd2.austenx.runtime.PackratElement getResult(int offset, int ruleIndex) {
			if(offset > 0) {
				return baseTable_.getResult(column_ + offset, ruleIndex);
			} else {
				if(resolvingList_.isContains(ruleIndex)) {
					recursiveRequestMade_ = true;
				} else {
					addRule(ruleIndex);
					rebuildResult(ruleIndex);
				}
				return getDirectCurrentResult(ruleIndex);
			}
		}
		public final int getCurrentLineNumber(int offset) {
			return baseTable_.getTableTokenOrLast(column_ + offset).getLineNumber();
		}
		public final int getCurrentCharacterNumber(int offset) {
			return baseTable_.getTableTokenOrLast(column_ + offset).getCharacterNumber();
		}
		public final java.lang.String getCurrentErrorMessage() {
			org.ffd2.austenx.runtime.ErrorInfo ei = getErrorHintInfo();
			if(ei != null) {
				return ei.getMessage();
			} else {
				return "";
			}
		}
		public final SkeletonToken getColumnTokenOrLast(int offset) {
			return baseTable_.getTableTokenOrLast(column_ + offset);
		}
		public final org.ffd2.austenx.runtime.ErrorInfo getErrorHintInfo() {
			return baseTable_.getErrorHintInfo();
		}
		public final void clearError() {
			baseTable_.clearError();
		}
		public final SkeletonToken getColumnToken(int offset) {
			return baseTable_.getTableToken(column_ + offset);
		}
		public final boolean isNewLine(int offset) {
			final int index = column_ + offset;
			if(index == 0) {
				return baseTable_.getTableToken(index).getLineNumber() > 0;
			} else {
				org.ffd2.austenx.runtime.BaseToken token = baseTable_.getTableToken(index);
				return baseTable_.getTableToken(index).getLineNumber() > baseTable_.getTableToken(index - 1).getLineNumber();
			}
		}
		public final boolean isColumnTokenAt(int offset) {
			return baseTable_.isTokenAt(column_ + offset);
		}
		public final void setErrorHint(java.lang.String message, int offset) {
			baseTable_.setErrorHint(message, column_ + offset);
		}
		public final SkeletonPackrat.Column getPrevious() {
			return previous_;
		}
		public final void resetColumn(int newColumn) {
			if(newColumn != column_) {
				column_ = newColumn;
				for(int i = 29 - 1 ; i >= 0 ; i--) {
					transientResults_[i] = null;
				}
			}
			resolvingList_.removeAllElements();
			recursiveRequestMade_ = false;
		}
		public final void setPrevious(SkeletonPackrat.Column c) {
			previous_ = c;
		}
		public final void addRule(int ruleIndex) {
			resolvingList_.addElement(ruleIndex);
			setDirectCurrentResult(ruleIndex, org.ffd2.austenx.runtime.ErrorElement.getInstance());
		}
		public final void doResolutions() {
			while(stackSweep()) {
			}
		}
		private final void setDirectCurrentResult(int ruleIndex, org.ffd2.austenx.runtime.PackratElement resultz) {
			if(ruleIndex < 41) {
				baseTable_.updateResult(column_, ruleIndex, resultz);
			} else {
				transientResults_[ruleIndex - 41] = resultz;
			}
		}
		private final boolean rebuildResult(int ruleIndex) {
			org.ffd2.austenx.runtime.PackratElement oldResult = getDirectCurrentResult(ruleIndex);
			SkeletonPackrat.BaseReader reader = baseTable_.getReader(ruleIndex);
			org.ffd2.austenx.runtime.PackratElement newResult = reader.build(this, oldResult);
			if(newResult != null) {
				setDirectCurrentResult(ruleIndex, newResult);
				return true;
			} else {
				return false;
			}
		}
		private final org.ffd2.austenx.runtime.PackratElement getDirectCurrentResult(int ruleIndex) {
			if(ruleIndex < 41) {
				return baseTable_.checkResult(column_, ruleIndex);
			} else {
				return transientResults_[ruleIndex - 41];
			}
		}
		private final boolean stackSweep() {
			recursiveRequestMade_ = false;
			final int initialSize = resolvingList_.size();
			int current = initialSize;
			boolean betterResolutionMade = false;
			while(current != 0) {
				current--;
				int ruleIndex = resolvingList_.get(current);
				if(rebuildResult(ruleIndex)) {
					betterResolutionMade = true;
				}
			}
			if(recursiveRequestMade_) {
				if(betterResolutionMade) {
					return true;
				}
				return initialSize != resolvingList_.size();
			} else {
				return false;
			}
		}
	}
	public static interface BaseReader {
		public org.ffd2.austenx.runtime.PackratElement build(SkeletonPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldResult) ;
	}
}
