package org.ffd2.skeletonx.austenx.peg.base;
public final class BlockElementPeer {
	public static interface Indirect {
		public BlockElementPeer.FixedPatternPeer createFixed(java.lang.String name, int nameLine, int nameCharacter) ;
		public BlockElementPeer.ChainPatternPeer createChain(int keywordLine, int keywordCharacter, java.lang.String chainName) ;
		public void createMapping(int keywordLine, int keywordCharacter, java.lang.String name, java.lang.String keyName, java.lang.String target) ;
		public void createKey(int keywordLine, int keywordCharacter, java.lang.String name) ;
		public BlockElementPeer.TemplatePatternPeer createTemplate(java.lang.String name, int nameLine, int nameCharacter) ;
		public BlockElementPeer.BlockPatternPeer createBlock(java.lang.String blockName, int blockNameLine, int blockNameCharacter) ;
	}
	public static interface FixedPatternPeer {
		public void end() ;
		public void addTypeElement(java.lang.String value, int lineNumber, int characterNumber) ;
		public FixedArgValuePatternPeer addFixedArgValueForValue(java.lang.String variableName, int variableNameLine, int variableNameCharacter) ;
	}
	public static interface ChainPatternPeer {
		public void end() ;
		public ChainElementPatternPeer addChainElementForElement(java.lang.String name, int nameLine, int nameCharacter) ;
	}
	public static interface TemplatePatternPeer {
		public void end() ;
		public TemplateElementPeer.ChildPatternPeer addOptionChildOfTemplateElementForElement(java.lang.String blockName, int blockNameLine, int blockNameCharacter) ;
	}
	public static interface BlockPatternPeer {
		public void end() ;
		public void addDependent(int lineNumber, int characterNumber) ;
		public void addMaybeMarker() ;
		public void addOneOrMoreMarker() ;
		public ParameterBlockPatternPeer addParameterBlockForParameters() ;
		public void addTemplateExtension(java.lang.String value, int lineNumber, int characterNumber) ;
		public BlockElementPeer.FixedPatternPeer addOptionFixedOfBlockElementForElement(java.lang.String name, int nameLine, int nameCharacter) ;
		public BlockElementPeer.ChainPatternPeer addOptionChainOfBlockElementForElement(int keywordLine, int keywordCharacter, java.lang.String chainName) ;
		public void addOptionMappingOfBlockElementForElement(int keywordLine, int keywordCharacter, java.lang.String name, java.lang.String keyName, java.lang.String target) ;
		public void addOptionKeyOfBlockElementForElement(int keywordLine, int keywordCharacter, java.lang.String name) ;
		public BlockElementPeer.TemplatePatternPeer addOptionTemplateOfBlockElementForElement(java.lang.String name, int nameLine, int nameCharacter) ;
		public BlockElementPeer.BlockPatternPeer addOptionBlockOfBlockElementForElement(java.lang.String blockName, int blockNameLine, int blockNameCharacter) ;
	}
}
