package org.ffd2.skeletonx.austenx.peg.base;
public final class JavaClassInterfaceElementPeer {
	public static interface Indirect {
		public JavaClassInterfaceElementPeer.PrototypePatternPeer createPrototype() ;
		public JavaClassInterfaceElementPeer.MethodPatternPeer createMethod() ;
		public JavaClassInterfaceElementPeer.ConstructorPatternPeer createConstructor() ;
		public JavaClassInterfaceElementPeer.InstanceVariablePatternPeer createInstanceVariable() ;
		public JavaClassInterfaceElementPeer.ClassPatternPeer createClass() ;
		public JavaClassInterfaceElementPeer.InterfacePatternPeer createInterface() ;
		public JavaClassInterfaceElementPeer.MacroDefPatternPeer createMacroDef() ;
		public JavaClassInterfaceElementPeer.MacroCallPatternPeer createMacroCall() ;
		public JavaClassInterfaceElementPeer.LinkPatternPeer createLink(int keywordLine, int keywordCharacter) ;
		public JavaClassInterfaceElementPeer.FindPatternPeer createFind() ;
		public JavaClassInterfaceElementPeer.GlobalClassPatternPeer createGlobalClass() ;
	}
	public static interface PrototypePatternPeer {
		public void end() ;
		public JavaPrototypePatternPeer addJavaPrototypeForValue(int keywordLine, int keywordCharacter, java.lang.String name) ;
	}
	public static interface MethodPatternPeer {
		public void end() ;
		public JavaMethodPatternPeer addJavaMethodForValue(java.lang.String name, int nameLine, int nameCharacter) ;
	}
	public static interface ConstructorPatternPeer {
		public void end() ;
		public JavaConstructorPatternPeer addJavaConstructorForValue(int keywordLine, int keywordCharacter) ;
	}
	public static interface InstanceVariablePatternPeer {
		public void end() ;
		public JavaInstanceVariablePatternPeer addJavaInstanceVariableForVariable(java.lang.String name, int nameLine, int nameCharacter) ;
	}
	public static interface ClassPatternPeer {
		public void end() ;
		public JavaClassPatternPeer addJavaClassForValue(int keywordLine, int keywordCharacter, java.lang.String name) ;
	}
	public static interface InterfacePatternPeer {
		public void end() ;
		public JavaInterfacePatternPeer addJavaInterfaceForValue(int keywordLine, int keywordCharacter, java.lang.String name) ;
	}
	public static interface MacroDefPatternPeer {
		public void end() ;
		public JavaMacroBlockPatternPeer addJavaMacroBlockForMacroDef(int keywordLine, int keywordCharacter, java.lang.String macroname) ;
	}
	public static interface MacroCallPatternPeer {
		public void end() ;
		public GeneralMacroCallPatternPeer addGeneralMacroCallForCall(int keywordLine, int keywordCharacter, java.lang.String macroName) ;
	}
	public static interface LinkPatternPeer {
		public void end() ;
		public LinkChainPatternPeer addLinkChainForSingleChain() ;
		public void setJavaClassInterfaceElementForElement(DeferredJavaClassInterfaceElement value) ;
	}
	public static interface FindPatternPeer {
		public void end() ;
		public FindDefinitionPatternPeer addFindDefinitionForDefinition(java.lang.String varibleName, int varibleNameLine, int varibleNameCharacter) ;
	}
	public static interface GlobalClassPatternPeer {
		public void end() ;
		public GlobalClassDefinitionPatternPeer addGlobalClassDefinitionForDefinition(java.lang.String className, int classNameLine, int classNameCharacter) ;
	}
}
