package org.ffd2.skeletonx.austenx.peg.base;
public final class JavaImplementationElementPeer {
	public static interface Indirect {
		public JavaImplementationElementPeer.ClassPatternPeer createClass() ;
		public JavaImplementationElementPeer.InterfacePatternPeer createInterface() ;
		public JavaImplementationElementPeer.LinkPatternPeer createLink() ;
		public void createInclude(java.lang.String fileName, int fileNameLine, int fileNameCharacter) ;
		public JavaImplementationElementPeer.IfPatternPeer createIf() ;
		public JavaImplementationElementPeer.PackageSetPatternPeer createPackageSet(int keywordLine, int keywordCharacter) ;
		public JavaImplementationElementPeer.MacroDefPatternPeer createMacroDef() ;
		public JavaImplementationElementPeer.MacroCallPatternPeer createMacroCall() ;
		public JavaImplementationElementPeer.GlobalClassPatternPeer createGlobalClass() ;
		public JavaImplementationElementPeer.FindPatternPeer createFind() ;
	}
	public static interface ClassPatternPeer {
		public void end() ;
		public JavaClassPatternPeer addJavaClassForJavaClass(int keywordLine, int keywordCharacter, java.lang.String name) ;
	}
	public static interface InterfacePatternPeer {
		public void end() ;
		public JavaInterfacePatternPeer addJavaInterfaceForJavaInterface(int keywordLine, int keywordCharacter, java.lang.String name) ;
	}
	public static interface LinkPatternPeer {
		public void end() ;
		public LinkChainPatternPeer addLinkChainForSingleChain() ;
		public void setJavaImplementationElementForElement(DeferredJavaImplementationElement value) ;
	}
	public static interface IfPatternPeer {
		public void end() ;
		public LinkChainPatternPeer addLinkChainForChain() ;
		public JavaImplementationElementPeer.Indirect getJavaImplementationElementForElement() ;
	}
	public static interface PackageSetPatternPeer {
		public void end() ;
		public void addNameElement(java.lang.String value) ;
	}
	public static interface MacroDefPatternPeer {
		public void end() ;
		public JavaMacroBlockPatternPeer addJavaMacroBlockForMacroDef(int keywordLine, int keywordCharacter, java.lang.String macroname) ;
	}
	public static interface MacroCallPatternPeer {
		public void end() ;
		public GeneralMacroCallPatternPeer addGeneralMacroCallForCall(int keywordLine, int keywordCharacter, java.lang.String macroName) ;
	}
	public static interface GlobalClassPatternPeer {
		public void end() ;
		public GlobalClassDefinitionPatternPeer addGlobalClassDefinitionForDefinition(java.lang.String className, int classNameLine, int classNameCharacter) ;
	}
	public static interface FindPatternPeer {
		public void end() ;
		public FindDefinitionPatternPeer addFindDefinitionForDefinition(java.lang.String varibleName, int varibleNameLine, int varibleNameCharacter) ;
	}
}
