package org.ffd2.skeletonx.austenx.peg.base;
public final class JavaStatementPeer {
	public static interface Indirect {
		public JavaStatementPeer.BlockPatternPeer createBlock() ;
		public JavaStatementPeer.DeclarationPatternPeer createDeclaration(java.lang.String name, int nameLine, int nameCharacter) ;
		public JavaStatementPeer.IfPatternPeer createIf(int keywordLine, int keywordCharacter) ;
		public void createNote(java.lang.String note) ;
		public JavaStatementPeer.ForPatternPeer createFor(int keywordLine, int keywordCharacter) ;
		public JavaStatementPeer.WhilePatternPeer createWhile(int keywordLine, int keywordCharacter) ;
		public void createMark(java.lang.String markName, int markNameLine, int markNameCharacter) ;
		public JavaStatementPeer.MacroCallPatternPeer createMacroCall() ;
		public JavaStatementPeer.ExpressionVarPatternPeer createExpressionVar(java.lang.String variableName, int variableNameLine, int variableNameCharacter) ;
		public JavaStatementPeer.StatementVarPatternPeer createStatementVar(java.lang.String variableName, int variableNameLine, int variableNameCharacter) ;
		public JavaStatementPeer.FindPatternPeer createFind() ;
		public JavaStatementPeer.LinkBlockPatternPeer createLinkBlock() ;
		public void createReturnSimple(int keywordLine, int keywordCharacter) ;
		public JavaStatementPeer.ReturnPatternPeer createReturn(int keywordLine, int keywordCharacter) ;
		public JavaStatementPeer.ThrowPatternPeer createThrow(int keywordLine, int keywordCharacter) ;
		public JavaStatementPeer.ExpressionPatternPeer createExpression() ;
		public JavaStatementPeer.SyncPatternPeer createSync(int keywordLine, int keywordCharacter) ;
		public JavaStatementPeer.SetPatternPeer createSet(java.lang.String variableName, int variableNameLine, int variableNameCharacter) ;
	}
	public static interface BlockPatternPeer {
		public void end() ;
		public JavaCodeBlockPatternPeer addJavaCodeBlockForValue() ;
	}
	public static interface DeclarationPatternPeer {
		public void end() ;
		public void addIsFinal() ;
		public TargetTypeReferencePatternPeer addTargetTypeReferenceForType(java.lang.String typeName, int typeNameLine, int typeNameCharacter) ;
		public NamePeer.BasicPatternPeer addOptionBasicOfNameForNameOutput() ;
		public void addOptionImplementsOfNameForNameOutput(int keywordLine, int keywordCharacter, java.lang.String className, java.lang.String methodName, int methodNameLine, int methodNameCharacter) ;
		public JavaExpressionPeer.Indirect getJavaExpressionForInitialValue() ;
	}
	public static interface IfPatternPeer {
		public void end() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForConditional() ;
		public JavaStatementPeer.Indirect getJavaStatementForTrueStatement() ;
		public JavaStatementPeer.Indirect getJavaStatementForFalseStatement() ;
	}
	public static interface ForPatternPeer {
		public void end() ;
		public ForInitialStatementPeer.Indirect getForInitialStatementForInitialStatement() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForConditionalExpression() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForRoundExpression() ;
		public JavaStatementPeer.Indirect getJavaStatementForLoopStatement() ;
	}
	public static interface WhilePatternPeer {
		public void end() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForConditional() ;
		public JavaStatementPeer.Indirect getJavaStatementForLoopStatement() ;
	}
	public static interface MacroCallPatternPeer {
		public void end() ;
		public GeneralMacroCallPatternPeer addGeneralMacroCallForCall(int keywordLine, int keywordCharacter, java.lang.String macroName) ;
	}
	public static interface ExpressionVarPatternPeer {
		public void end() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForValue() ;
	}
	public static interface StatementVarPatternPeer {
		public void end() ;
		public JavaStatementPeer.Indirect getJavaStatementForValue() ;
	}
	public static interface FindPatternPeer {
		public void end() ;
		public FindDefinitionPatternPeer addFindDefinitionForDefinition(java.lang.String varibleName, int varibleNameLine, int varibleNameCharacter) ;
	}
	public static interface LinkBlockPatternPeer {
		public void end() ;
		public LinkChainPatternPeer addLinkChainForSingleChain() ;
		public void setJavaStatementForStatement(DeferredJavaStatement value) ;
		public void addIsWithSubBlock() ;
	}
	public static interface ReturnPatternPeer {
		public void end() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForResult() ;
	}
	public static interface ThrowPatternPeer {
		public void end() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForResult() ;
	}
	public static interface ExpressionPatternPeer {
		public void end() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForValue() ;
	}
	public static interface SyncPatternPeer {
		public void end() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForSyncObject() ;
		public JavaStatementPeer.Indirect getJavaStatementForStatement() ;
	}
	public static interface SetPatternPeer {
		public void end() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForValue() ;
	}
}
