package org.ffd2.skeletonx.compile.impl;

import java.util.HashMap;

import org.ffd2.skeletonx.austenx.peg.base.BlockElementPeer.ChainPatternPeer;
import org.ffd2.skeletonx.austenx.peg.base.BlockElementPeer.FixedPatternPeer;
import org.ffd2.skeletonx.austenx.peg.base.ChainElementPatternPeer;
import org.ffd2.skeletonx.austenx.peg.base.DesignExpressionPeer;
import org.ffd2.skeletonx.austenx.peg.base.DesignTypePatternPeer;
import org.ffd2.skeletonx.austenx.peg.base.FixedArgValuePatternPeer;
import org.ffd2.skeletonx.austenx.peg.base.ParameterBlockPatternPeer;
import org.ffd2.skeletonx.austenx.peg.base.ParameterPeer;
import org.ffd2.skeletonx.compile.design.DesignType;
import org.ffd2.skeletonx.compile.design.DesignType.GivenParameterInstantiation;
import org.ffd2.skeletonx.compile.design.DesignTypeAccess;
import org.ffd2.skeletonx.compile.design.FixedValueAccess;
import org.ffd2.skeletonx.compile.design.FixedValueAccess.ParameterSource;
import org.ffd2.skeletonx.compile.java.ImplementationParameterTarget;
import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.skeletonx.skeleton.BaseTrackers.DesignVariablePath;
import org.ffd2.skeletonx.skeleton.DataBlockFormHolder.DataBlockFormBlock;
import org.ffd2.skeletonx.skeleton.DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock;
import org.ffd2.skeletonx.skeleton.JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock;
import org.ffd2.skeletonx.skeleton.ParameterSettingsFormHolder;
import org.ffd2.skeletonx.skeleton.ParameterSettingsFormHolder.ParameterSettingsFormBlock;
import org.ffd2.solar.compile.GlobalEnvironment;
import org.ffd2.solar.exceptions.ItemAlreadyExistsException;
import org.ffd2.solar.exceptions.ParsingException;
import org.ffd2.solar.general.Debug;
import org.ffd2.solar.general.SimpleVector;
import org.ffd2.solar.language.AccessStoreX;
import org.ffd2.solar.language.SpecificCommonErrorOutput;

public class BlockParameters implements  ParameterBlockPatternPeer {
  private final AccessStoreX<ParameterHandler> parameters_;
  private final SpecificCommonErrorOutput baseError_;
//  private final DesignTypeAccess typeAccess_;
  private final GlobalEnvironment baseEnvironment_;
  private final SimpleVector<ParameterHandler> orderedParameters_;
  private final ParameterSettingsFormHolder.ParameterSettingsFormBlock myParameters_;
  private final BaseBuilder baseBuilder_;
  public BlockParameters(GlobalEnvironment baseEnvironment, BaseBuilder baseBuilder, SpecificCommonErrorOutput error) {
    this.baseEnvironment_ = baseEnvironment;
    //this.typeAccess_ = typeAccess;
    this.baseBuilder_ = baseBuilder;
    this.myParameters_ = baseBuilder.createParameterSettingsChild();
    this.parameters_ =baseEnvironment.createEntityStore("parameter");
    this.baseError_ = error;
    this.orderedParameters_ = new SimpleVector<ParameterHandler>();
  }
//  public ParameterSettingsFormHolder.ParameterSettingsFormBlock getParameterSettingsSkeleton() {
//  	return this.myParameters_;
//  }
//  public JavaParameterSettingsFormBlock getJavaParameterSettings() {
//  	JavaParameterSettingsFormBlock settings = this.baseBuilder_.createJavaParameterSettingsChild();
//  	for(ParameterHandler ph : this.orderedParameters_) {
//  		ph.createJavaParameter(settings);
//  	}
//  	return settings;
//  	//= this.myParameters_
//  }
  // ==========================================================================
  // Austen stuff

  public FixedPatternPeer addFixedElement( String nameParameter,SpecificCommonErrorOutput error ) {
	 FixedVariableHandler ph = new FixedVariableHandler(nameParameter,this,error);
   addParameter(nameParameter,ph,error);
   return ph;
  }
  public  ChainVariableHandler addChainElement( String chainNameParameter, String variableNameParameter, SpecificCommonErrorOutput error ) {
  	ChainVariableHandler cvh = new ChainVariableHandler(chainNameParameter, variableNameParameter, error);
  	addParameter(chainNameParameter,cvh,error);
  	return cvh;
  }
	public void addOptionChainOfParameterForParameter(int keywordLineNumber,
			int keywordCharacterNumber, String chainNameParameter, String variableNameParameter) {
		SpecificCommonErrorOutput error = this.baseError_.createAdjusted(keywordLineNumber, keywordCharacterNumber);
    ChainVariableHandler ph = new ChainVariableHandler(chainNameParameter, variableNameParameter, error);
    addParameter(chainNameParameter,ph,error);
	}
  public void end() {}
  
  public void addOptionMappingOfParameterForParameter(int keywordLineNumber, int keywordCharacterNumber, String mappingNameParameter, String variableNameParameter) {
		SpecificCommonErrorOutput relatedError = this.baseError_.createAdjusted(keywordLineNumber, keywordCharacterNumber);
	  MappingVariableHandler ph = new MappingVariableHandler(mappingNameParameter, variableNameParameter, relatedError);
    addParameter(mappingNameParameter,ph,relatedError);
		
	}
  
	public void addOptionKeyOfParameterForParameter(int keywordLineNumber, int keywordCharacterNumber, String keyNameParameter, String variableNameParameter) {
		SpecificCommonErrorOutput relatedError = this.baseError_.createAdjusted(keywordLineNumber, keywordCharacterNumber);
	  KeyVariableHandler ph = new KeyVariableHandler(keyNameParameter, variableNameParameter,relatedError);
    addParameter(keyNameParameter,ph,relatedError);
    Debug.println("---------Adding key:",keyNameParameter);
		
	}
	
  // =======================
  public void finalBuild() {
  	for(ParameterHandler ph : this.orderedParameters_) {
      ph.finalBuild();
    }
  }
//  public void updateDesignForm(DesignFormBlock  target) {
//  	for(ParameterHandler ph : this.orderedParameters_) {
//      ph.updateParametersSkeleton( target.getParametersParameter());
//    }
//  }
  
//  public void updateNonDesignFormParametersSkeleton(ParameterSettingsTemplate skeleton) {
//    for(ParameterHandler ph : this.orderedParameters_) {
//      ph.updateParametersSkeleton( skeleton);
//    }
//  }
//  public void updateTargetParametersSkeleton(TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock  skeleton) {
//  	for(ParameterHandler ph : this.orderedParameters_) {
//      ph.updateParametersSkeleton( skeleton.getParametersParameter());
//    }
//  }
  boolean updatedAlready_ = false;
  
//  public void updateGeneralParametersSkeleton(DataBlockFormBlock.GeneralSubDataBlock skeleton) {
//  	if(updatedAlready_) {
//  		Thread.dumpStack();
//  	}
//  	for(ParameterHandler ph : this.orderedParameters_) {
//      ph.updateParametersSkeleton( skeleton.getSubSettingsParameter());
//    }
//  	updatedAlready_ = true;
////  }
//  public void updateParametersSkeleton() {
//  	Debug.println("Doing update parameters:",this.orderedParameters_);
//  	if(updatedAlready_) {
//  		Thread.dumpStack();
//  	}
//  	for(ParameterHandler ph : this.orderedParameters_) {
//      ph.updateParametersSkeleton( this.myParameters_);
//    }
//  	updatedAlready_ = true;
//
//  }
  public ParameterSettingsFormHolder.ParameterSettingsFormBlock getParametersSkeleton() { return this.myParameters_; }
  public void buildImplementationParameters(ImplementationParameterTarget target) {
    for(ParameterHandler ph : this.orderedParameters_) {
      ph.buildImplementationParameters( target);
    }
    target.allParametersDeclared();
  }
  
	public void requestParameterSetForFixed(
			ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock	fixedSkeleton, FixedValueAccess.ParameterSource parameterValueSource) {
		for(ParameterHandler ph : this.orderedParameters_) {
      ph.requestParameterSetForFixedFinal( fixedSkeleton,parameterValueSource);
    }
	}

	
	public ParameterPeer.BlockPatternPeer addOptionBlockOfParameterForParameter(String nameParameter,
			int nameLineNumber, int nameCharacterNumber) {
		SpecificCommonErrorOutput error = this.baseError_.createAdjusted(nameLineNumber, nameCharacterNumber);
    BlockVariableHandler ph = new BlockVariableHandler(nameParameter,this);
    addParameter(nameParameter,ph,error);

    return ph;
  }
	public void directAddBlock(String nameParameter,DesignType	resolvedType, SpecificCommonErrorOutput error) {
    BlockVariableHandler ph = new BlockVariableHandler(nameParameter,resolvedType,this);
    addParameter(nameParameter,ph,error);
  }
	private final void addParameter(String name, ParameterHandler ph,SpecificCommonErrorOutput error) {
		try {
      this.parameters_.put(name, ph);
    } catch(ItemAlreadyExistsException e) {
      error.repeatedObjectError("parameter", name);
    }
    this.orderedParameters_.addElement(ph);
	}
	private final static class LocalEnvironment implements DesignVariableEnvironment {
		private final DesignVariableEnvironment	environment_;
		private final BlockParameters	parent_;
		public LocalEnvironment(final DesignVariableEnvironment environment, BlockParameters parent) {
			this.environment_ = environment;
			this.parent_ = parent;
			
		}
		public DesignVariable getVariableQuiet(String variableName, DesignVariablePath variablePath) {
			ParameterHandler local = this.parent_.parameters_.getQuiet(variableName);
			if(local!=null) {
				return local;
			} else {
				return environment_.getVariableQuiet(variableName, variablePath);
			}
		}
	}
  // --------------------------------------------------------------------------
  /**
   * Do the basic build pass, and then return the augmented environment for the children
   */
	public final DesignVariableEnvironment basicBuildFromNonRoot(final DesignVariableEnvironment environment, final DesignTypeAccess typeAccess, DataBlockFormBlock.IsNotRootDataBlock targetDataSkeleton) {
  	LocalEnvironment subEnvironment = new LocalEnvironment(environment,this);
  	for(ParameterHandler ph : this.orderedParameters_) {
      ph.basicBuildNonRoot(this,subEnvironment,targetDataSkeleton, typeAccess);
    }
  	return subEnvironment;
  }
	public final DesignVariableEnvironment basicBuildFromRoot(final DesignVariableEnvironment environment, final DesignTypeAccess typeAccess) {
  	LocalEnvironment subEnvironment = new LocalEnvironment(environment,this);
  	for(ParameterHandler ph : this.orderedParameters_) {
      ph.basicBuildRoot(this,subEnvironment,this.myParameters_, typeAccess);
    }
  	return subEnvironment;
  }
  private  static interface ParameterHandler extends DesignVariable{
  	public void basicBuildNonRoot(BlockParameters parent, LocalEnvironment environment, DataBlockFormBlock.IsNotRootDataBlock targetDataSkeleton, DesignTypeAccess typeAccess);
  	public void basicBuildRoot(BlockParameters parent, LocalEnvironment environment, ParameterSettingsFormHolder.ParameterSettingsFormBlock targetDataSkeleton, DesignTypeAccess typeAccess);

  //	public void createJavaParameter(JavaParameterSettingsFormBlock settings);
  	public void finalBuild();
  	
  	public void buildImplementationParameters(ImplementationParameterTarget target);
    public void updateParametersSkeleton(ParameterSettingsFormHolder.ParameterSettingsFormBlock skeleton);
    //public void updateParametersSkeleton(JavaParameterSettingsFormBlock skeleton);
    
  //  public void updateTargetParametersSkeleton(TargetBaseFormBlock.BlockDataBlock  skeleton);
  //  public void updateGeneralParametersSkeleton(DataBlockFormBlock.GeneralSubDataBlock skeleton);
   // public void updateDesignForm(DesignFormBlock skeleton);
    
    
    public void requestParameterSetForFixedFinal(
    		ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock	fixedSkeleton, 
    		FixedValueAccess.ParameterSource parameterValueSource);
  }
  // ==========================================================================
  private static final class FixedVariableParameterValue implements FixedArgValuePatternPeer {
  	private final SpecificCommonErrorOutput	error_;
  	private boolean used_ = false;
  	private final FVValueStore valueStore_;
		public FixedVariableParameterValue(SpecificCommonErrorOutput error) {
			this.error_ = error;
			this.valueStore_ = new FVValueStore(error);
  	}
		public FVValueStore getValueForUsage() {
			this.used_ =true;
			return valueStore_;
		}
		public void basicBuild(LocalEnvironment environment) {
		
			this.valueStore_.basicBuild(environment);
		}

		public void end() {}

		public DesignExpressionPeer.Indirect getDesignExpressionForValue() {
			return valueStore_;
		}
  }
  private static abstract class AbstractPrimitiveValue implements Value {
		public final void basicBuild(LocalEnvironment environment) { }
		public final void requestRecord(DesignType recordType, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton,SpecificCommonErrorOutput	baseError) {
			baseError.invalidTypeError("record type", "primitive");
		}
		public final void requestChainValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
			baseError.invalidTypeError("chain", "primitive");
		}
		public void requestMappingValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, MappingDefinitionBlock type,SpecificCommonErrorOutput	baseError) {
			baseError.invalidTypeError("mapping", "primitive");

  	}
  }
  private static interface Value {
		public void basicBuild(LocalEnvironment environment);
		public void requestRecord(DesignType recordType, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton,SpecificCommonErrorOutput	baseError);
  	public void requestIntArrayValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton,SpecificCommonErrorOutput	baseError);
  	public void requestIntValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton,SpecificCommonErrorOutput	baseError);

  	public void requestStringValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton,SpecificCommonErrorOutput	baseError);

  	public void requestDoubleValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton,SpecificCommonErrorOutput	baseError);

  	public void requestBooleanValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton,SpecificCommonErrorOutput	baseError);

  	public void requestChainValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton,SpecificCommonErrorOutput	baseError);
  	public void requestMappingValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, MappingDefinitionBlock type,SpecificCommonErrorOutput	baseError);

  }
  private static final class FVValueStore implements DesignExpressionPeer.Indirect,DesignExpressionPeer.PrimitivePatternPeer {
  	private Value value_;
		private final SpecificCommonErrorOutput	baseError_;
  	public FVValueStore(SpecificCommonErrorOutput baseError) {
			this.baseError_ = baseError; 
  	}

  	public void requestRecord(DesignType recordType, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton) {
  		this.value_.requestRecord(recordType,fixedSkeleton,baseError_);
  	}
  	public void requestIntArrayValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton) {
  		this.value_.requestIntArrayValue(fixedSkeleton,baseError_);
  	}
  	public void requestIntValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton) {
  		this.value_.requestIntValue(fixedSkeleton,baseError_);
  	}
  	public void requestStringValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton) {
  		this.value_.requestStringValue(fixedSkeleton,baseError_);
  	}
  	public void requestDoubleValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton) {
  		this.value_.requestDoubleValue(fixedSkeleton,baseError_);
  	}
  	public void requestBooleanValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton) {
  		this.value_.requestBooleanValue(fixedSkeleton,baseError_);
  	}
  	public void requestChainValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton) {
  		this.value_.requestChainValue(fixedSkeleton,baseError_);
  	}
  	public void requestMappingValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, MappingDefinitionBlock type) {
  		this.value_.requestMappingValue(fixedSkeleton,type,baseError_);
  	}
  	public DesignExpressionPeer.PrimitivePatternPeer createPrimitive() {
  		return this;
  	}
		public void basicBuild(LocalEnvironment environment) {
			this.value_.basicBuild(environment);
		}

		public void end() { }

		public void addCharValue(final String value, int lineNumber, int characterNumber) {
			this.value_ = new AbstractPrimitiveValue() {
				public void requestIntArrayValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}
		  	
				public void requestIntValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}
				public void requestStringValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}

				public void requestDoubleValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}

				public void requestBooleanValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}
			};
		}

		public void addString(String value, int lineNumber, int characterNumber) {
			this.value_ = new AbstractPrimitiveValue() {
				public void requestIntArrayValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}
				public void requestIntValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}
				public void requestStringValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}

				public void requestDoubleValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}

				public void requestBooleanValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}
			};

		}

		public void addInteger(int value, int lineNumber, int characterNumber) {
			this.value_ = new AbstractPrimitiveValue() {
				public void requestIntArrayValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}
				public void requestIntValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}
				public void requestStringValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}

				public void requestDoubleValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}

				public void requestBooleanValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}
			};
			//TODO:
			Debug.finishMeMarker();
		}

		public void addBooleanValue(boolean value, int lineNumber, int characterNumber) {
			this.value_ = new AbstractPrimitiveValue() {
				public void requestIntArrayValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}
				public void requestIntValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}
				public void requestStringValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}

				public void requestDoubleValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}

				public void requestBooleanValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}
			};
			//TODO:
			Debug.finishMeMarker();
		}

		public void createVariable(final String variableName, int variableNameLineNumber, int variableNameCharacterNumber) {
			final SpecificCommonErrorOutput error = this.baseError_.createAdjusted(variableNameLineNumber, variableNameCharacterNumber);
			this.value_ = new Value() {
				private DesignVariable foundVariable_;
				private final BaseTrackers.DesignVariablePath variablePath_  = new BaseTrackers.DesignVariablePath();
				public void basicBuild(LocalEnvironment environment) {
					this.foundVariable_ = environment.getVariableQuiet(variableName, this.variablePath_);
					if(this.foundVariable_==null) {
						error.objectNotFoundError("design variable", variableName);
					}
				}
				public void requestMappingValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, MappingDefinitionBlock type,SpecificCommonErrorOutput	baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub

		  	}
				public void requestIntArrayValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}
				public void requestStringValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}
				public void requestIntValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}

				public void requestDoubleValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}

				public void requestBooleanValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, SpecificCommonErrorOutput baseError) {
					Debug.finishMeMarker();// TODO Auto-generated method stub
				}
				public void requestRecord(DesignType recordType, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton,  SpecificCommonErrorOutput baseError) {
					try {
						foundVariable_.requestRecordFromVariableFinal(recordType, fixedSkeleton, variablePath_);
					} catch (ParsingException e) {
						e.updateError(error);
					}
				}
				public void requestChainValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton,
						SpecificCommonErrorOutput baseError) {
					// TODO Auto-generated method stub
					
				}
			};
			//TODO:
			Debug.finishMeMarker();
		}

  }
  // --------------------------------------------------------------------------
  private final static class FixedVariableHandler implements ParameterHandler, FixedPatternPeer, FixedValueAccess.ParameterSource {
  	private final String	variableName_;
		private final SpecificCommonErrorOutput	error_;
    private final DesignTypeBlock type_;
		private DesignType	resolvedType_;
		private final HashMap<String, FixedVariableParameterValue> arguments_ = new HashMap<String, FixedVariableParameterValue>();
		private FixedValueAccess	fixedInstantiation_;
		public FixedVariableHandler(String variableName,BlockParameters parent,SpecificCommonErrorOutput error ) {
			this.variableName_ = variableName;
			this.error_ = error;
  		this.type_ = new DesignTypeBlock( parent.baseEnvironment_, error);
  	}
  	public void requestRecordFromVariableFinal(DesignType recordType, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, BaseTrackers.DesignVariablePath variablePath) throws ParsingException {
  		if(recordType!=resolvedType_) {
  			throw ParsingException.createInvalidType(this.resolvedType_.getNameForError(), recordType.getNameForError());
  		}
  		this.fixedInstantiation_.requestRecordFromVariableFinal(fixedSkeleton, variablePath);
  	}
  	// =========================================================================
  	// Austen stuff
		public void end() { }

		public void addTypeElement(String value, int lineNumber, int characterNumber) {
			 SpecificCommonErrorOutput error = this.error_.createAdjusted(lineNumber, lineNumber);
	     this.type_.addTypeElement(value,error);
		}

		public FixedArgValuePatternPeer addFixedArgValueForValue(
								String variableNameParameter, 
								int variableNameLineNumber, int variableNameCharacterNumber
			) {
			SpecificCommonErrorOutput error = this.error_.createAdjusted(variableNameLineNumber, variableNameCharacterNumber);
			FixedVariableParameterValue value = new FixedVariableParameterValue(error);
			if(this.arguments_.containsKey(variableNameParameter)) {
				error.repeatedObjectError("argument value", variableNameParameter);
				return null;
			} else {
				this.arguments_.put(variableNameParameter, value);
			}
			return value;
		}
		//End of Austen Stuff
		// ========================================================================
		public void requestParameterSetForFixedFinal(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, ParameterSource parameterValueSource) {
			parameterValueSource.addDesignRecord(variableName_,this.resolvedType_,fixedSkeleton);
		}
	// ========================================================================
		// Compilation stuff

		public void basicBuildNonRoot(BlockParameters parent, LocalEnvironment environment, DataBlockFormBlock.IsNotRootDataBlock targetDataSkeleton, DesignTypeAccess typeAccess) {
      this.resolvedType_ = type_.buildResolvedQuiet(typeAccess);	
      if(this.resolvedType_!=null) {
      	try {
      		this.fixedInstantiation_ = this.resolvedType_.createFixed(targetDataSkeleton, this.variableName_);
      	} catch(ParsingException e) {
      		e.updateError(this.error_);
      	}
      }
      for(FixedVariableParameterValue argument : arguments_.values()) {
      	argument.basicBuild(environment);
      }
		}
		public void basicBuildRoot(BlockParameters parent, LocalEnvironment environment, ParameterSettingsFormHolder.ParameterSettingsFormBlock targetDataSkeleton, DesignTypeAccess typeAccess) {
      this.resolvedType_ = type_.buildResolvedQuiet(typeAccess);	
      error_.invalidConstructionError("Fixed parameter", this.variableName_, "not yet available at root");
      Debug.finishMeMarker();
      for(FixedVariableParameterValue argument : arguments_.values()) {
      	argument.basicBuild(environment);
      }
		}
  	public void finalBuild() { 
  		if(this.fixedInstantiation_!=null) {
  			//This does the call back stuff to ask for parameters
  			this.fixedInstantiation_.buildParameters(this);
      }	
  	}
  	// ========================================================================
  	// ParameterHandler
		public void buildImplementationParameters( ImplementationParameterTarget target) {
      // TODO: FIX THIS, so is not just normal parameter
			// - But why? Just so parameter names single that is fixed for debugging?
			if(this.resolvedType_!=null) {
      	this.resolvedType_.buildImplementationParameter(target, this.variableName_);
      }
		}

		public void updateParametersSkeleton(ParameterSettingsFormBlock skeleton) {
			this.resolvedType_.updateParameter(skeleton, this.variableName_);

			//.addParameterBlock(this.variableName_).addRecordBlock(block)
		}
//    public void updateDesignForm(DesignFormBlock skeleton) {
//    	this.resolvedType_.updateParameter(skeleton, this.variableName_);
//
//    } 
//    public void updateTargetParametersSkeleton(TargetBaseFormBlock.BlockDataBlock  skeleton) { updateParametersSkeleton(skeleton.getParametersParameter()); } //No difference
//    public void updateGeneralParametersSkeleton(DataBlockFormBlock.GeneralSubDataBlock skeleton){  
//
//    } 
  	
		// === Parameter Callback stuff
		private final FixedVariableParameterValue getArgument(String variableName) {
			FixedVariableParameterValue argument = this.arguments_.get(variableName);
			if(argument==null) {
				error_.objectNotFoundError("requested argument", variableName);
			}
			return argument;
		}
		
		// ========================================================================
		// FixedValueAccess.ParameterSource stuff
		public void addDesignRecord(String variableName, DesignType recordType, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton) {
			FixedVariableParameterValue argument = getArgument(variableName);
			if(argument!=null) { argument.getValueForUsage().requestRecord(recordType, fixedSkeleton); }
		} 

		public void addIntValue(String variableName, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton) {
			FixedVariableParameterValue argument = getArgument(variableName);
			if(argument!=null) { 	argument.getValueForUsage().requestIntValue( fixedSkeleton); }
		}

		public void addIntArrayValue(String variableName, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton) {
			FixedVariableParameterValue argument = getArgument(variableName);
			if(argument!=null) { argument.getValueForUsage().requestIntArrayValue( fixedSkeleton); 	}
		}

		public void addStringValue(String variableName, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton) {
			FixedVariableParameterValue argument = getArgument(variableName);
			if(argument!=null) { argument.getValueForUsage().requestStringValue( fixedSkeleton); 	}
		}

		public void addDoubleValue(String variableName, 	ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton) {
			FixedVariableParameterValue argument = getArgument(variableName);
			if(argument!=null) { argument.getValueForUsage().requestDoubleValue( fixedSkeleton); }
		}

		public void addBooleanValue(String variableName, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton) {
			FixedVariableParameterValue argument = getArgument(variableName);
			if(argument!=null) { argument.getValueForUsage().requestBooleanValue( fixedSkeleton); }
		}

		public void addChain(String variableName, ChainDefinitionBlock chainAccess, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton) {
			FixedVariableParameterValue argument = getArgument(variableName);
			if(argument!=null) { argument.getValueForUsage().requestChainValue( fixedSkeleton); }
		}
		public void addMapping(String variableName, MappingDefinitionBlock mappingAccess, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock  fixedSkeleton){
			FixedVariableParameterValue argument = getArgument(variableName);
			if(argument!=null) { argument.getValueForUsage().requestMappingValue(fixedSkeleton,mappingAccess); }
		}
		public void updateParametersSkeleton(JavaParameterSettingsFormBlock skeleton) {
			//	this.resolvedType_.updateParameter(skeleton, this.variableName_);
	    	//Nothing to do, as fixed values don't exist as design parameters (they are created in the constructor...)

				//.addParameterBlock(this.variableName_).addRecordBlock(block)
			}
	    
		
		

		
  }
  private final static class KeyVariableHandler implements ParameterHandler {
  	private final String	keyName_;
		private final String	variableName_;
		private final SpecificCommonErrorOutput	error_;
		private KeyDefinitionBlock	keyAccess_;
	//	private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock baseSkeleton_;
		private  ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock	keyParameterSkeleton_;

		public KeyVariableHandler(String keyName, String variableName, SpecificCommonErrorOutput error) {
			this.keyName_ = keyName;
			this.variableName_ = variableName;
			//this.baseSkeleton_  = parentSkeleton.addParameter(variableName);
			
			this.error_ = error;
		}

		public void requestRecordFromVariableFinal(DesignType recordType, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, DesignVariablePath variablePath) throws ParsingException {
			// TODO Auto-generated method stub
			Debug.finishMeMarker();
			throw ParsingException.createGeneralSyntax("Not implemented yet!");
		}

		public void basicBuildNonRoot(BlockParameters parent, LocalEnvironment environment, IsNotRootDataBlock targetDataSkeleton, DesignTypeAccess typeAccess) {
			basicBuildRoot(parent,environment,targetDataSkeleton.getParent().getParametersParameter(), typeAccess);
		}

		public void basicBuildRoot(BlockParameters parent, LocalEnvironment environment, ParameterSettingsFormHolder.ParameterSettingsFormBlock targetDataSkeleton, DesignTypeAccess typeAccess) {
			try {
				this.keyAccess_ = typeAccess.getKey(this.keyName_);
				this.keyParameterSkeleton_ = this.keyAccess_.addKeyParameter(targetDataSkeleton.addParameter(this.variableName_));
			} catch(ParsingException e) {
				e.updateError(this.error_);
			}
		}

		public void finalBuild() {
	
		}

		public void buildImplementationParameters( 	ImplementationParameterTarget target) {
			target.newKeyParameter(this.variableName_,this.keyAccess_);
		}

		public void updateParametersSkeleton(ParameterSettingsFormBlock skeleton) {
			Debug.println("$$$$$$ Adding key parameter:",this.variableName_);
			this.keyAccess_.addKeyParameter(skeleton.addParameter(this.variableName_));
		}
		public void createJavaParameter(JavaParameterSettingsFormBlock skeleton) {
			this.keyAccess_.addKeyParameter(skeleton.addParameter(this.variableName_));
		}
	
		public void requestParameterSetForFixedFinal(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton,ParameterSource parameterValueSource) {
		// TODO Auto-generated method stub
			Debug.finishMeMarker();
			this.error_.generalSyntaxError("Not implemented yet!");
		}
  }
  private final static class MappingVariableHandler implements ParameterHandler {
		private final String	mappingName_;
		private final String	variableName_;
		private final SpecificCommonErrorOutput	error_;
		private MappingDefinitionBlock	mappingAccess_;

		public MappingVariableHandler(String mappingName, String variableName, SpecificCommonErrorOutput error) {
			this.mappingName_ = mappingName;
			this.variableName_ = variableName;
			this.error_ = error;
		}

		public void requestRecordFromVariableFinal(DesignType recordType, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, DesignVariablePath variablePath) throws ParsingException {
  		throw ParsingException.createInvalidType("mapping", recordType.getNameForError());

		}
		public void requestParameterSetForFixedFinal(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, ParameterSource parameterValueSource){
			parameterValueSource.addMapping(variableName_,this.mappingAccess_,fixedSkeleton);

		}
		public void basicBuildNonRoot(BlockParameters parent, LocalEnvironment environment, IsNotRootDataBlock targetDataSkeleton, DesignTypeAccess typeAccess) {
			basicBuildRoot(parent,environment,targetDataSkeleton.getParent().getParametersParameter(), typeAccess);
		}
		public void basicBuildRoot(BlockParameters parent, LocalEnvironment environment, ParameterSettingsFormHolder.ParameterSettingsFormBlock targetDataSkeleton, DesignTypeAccess typeAccess) {
			try {
				this.mappingAccess_ = typeAccess.getMapping(this.mappingName_);
				this.mappingAccess_.addMappingParameter(targetDataSkeleton.addParameter(this.variableName_));
			} catch(ParsingException e) {
				e.updateError(this.error_);
			}
		}

		public void finalBuild() { }

		public void buildImplementationParameters( ImplementationParameterTarget target) {
			target.newMappingParameter(this.variableName_, this.mappingAccess_);		
		}

		public void updateParametersSkeleton(ParameterSettingsFormBlock skeleton) {
			this.mappingAccess_.addMappingParameter(skeleton.addParameter(this.variableName_));
		}
//		public void updateParametersSkeleton(JavaParameterSettingsFormBlock skeleton) {
//			this.mappingAccess_.addMappingParameter(skeleton.addParameter(this.variableName_));
//		}
		public void createJavaParameter(JavaParameterSettingsFormBlock skeleton) {
			this.mappingAccess_.addMappingParameter(skeleton.addParameter(this.variableName_));
		}
		
//		public void updateTargetParametersSkeleton(BlockDataBlock skeleton) {
//			this.mappingAccess_.addMappingParameter(skeleton.addParameterBlock(this.variableName_));
//		}
//
//		public void updateGeneralParametersSkeleton(GeneralSubDataBlock skeleton) {
//			this.mappingAccess_.addMappingParameter(skeleton.addParameter(this.variableName_));			
//		}
//
//		public void updateDesignForm(DesignFormBlock skeleton) {
//			this.mappingAccess_.addMappingParameter(skeleton.addParameter(this.variableName_));			
//		}

		
  }
  // ==========================================================================
  private final static class ChainVariableHandler implements ParameterHandler, ChainPatternPeer {
  	private final SpecificCommonErrorOutput error_;
		private final String variableName_;
		private final String chainName_;
		private ChainDefinitionBlock chainAccess_;

		public ChainVariableHandler(String chainName, String variableName, SpecificCommonErrorOutput error) {
			this.chainName_ = chainName;
			this.variableName_ = variableName;
			this.error_ = error;
  		
  	}
		public void requestRecordFromVariableFinal(DesignType recordType, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, BaseTrackers.DesignVariablePath variablePath) throws ParsingException {
  		throw ParsingException.createInvalidType("chain", recordType.getNameForError());

  		
  	}
		public void requestParameterSetForFixedFinal(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, ParameterSource parameterValueSource) {
			parameterValueSource.addChain(variableName_,this.chainAccess_,fixedSkeleton);
		}
		public void buildImplementationParameters(ImplementationParameterTarget target) {
			target.newChainParameter(this.variableName_, this.chainAccess_);
		}
		public void basicBuildRoot(BlockParameters parent, LocalEnvironment environment, ParameterSettingsFormHolder.ParameterSettingsFormBlock targetDataSkeleton, DesignTypeAccess typeAccess) {
		//TODO: fix stuff
			Debug.finishMeMarker();
			try {
				this.chainAccess_ = typeAccess.getChain(this.chainName_);
				this.chainAccess_.addParameter(targetDataSkeleton.addParameter(this.variableName_));
			} catch(ParsingException e) {
				e.updateError(this.error_);
			}
      
    }
		public void basicBuildNonRoot(BlockParameters parent, LocalEnvironment environment, DataBlockFormBlock.IsNotRootDataBlock targetDataSkeleton, DesignTypeAccess typeAccess) {
			basicBuildRoot(parent,environment,targetDataSkeleton.getParent().getParametersParameter(), typeAccess);
		}
  	public void finalBuild() { }


		public void updateParametersSkeleton(ParameterSettingsFormHolder.ParameterSettingsFormBlock skeleton) {
			this.chainAccess_.addParameter(skeleton.addParameter(this.variableName_));
		}

		public void createJavaParameter(JavaParameterSettingsFormBlock skeleton) {
			this.chainAccess_.addJavaParameter(skeleton.addParameter(this.variableName_));
		}
    // ------------- Peer Stuff ---------------
		public ChainElementPatternPeer addChainElementForElement(String nameParameter,
				int nameLineNumber, int nameCharacterNumber) {
			SpecificCommonErrorOutput error = this.error_.createAdjusted(nameLineNumber, nameCharacterNumber);
			//TODO: fix this plese (chain access not found until resolvetype Called)
			//Probably will have to wait until redesign like the implementation stuff
			Debug.finishMeMarker();
			return this.chainAccess_.addChainElementForElement(nameParameter, nameLineNumber, nameCharacterNumber);
		}

		public void end() {	 }
  }
  //==========================================================================
  
  private final static class BlockVariableHandler implements ParameterHandler, ParameterPeer.BlockPatternPeer {
    private final DesignTypeBlock type_; 
    private final String name_;
    private final BlockParameters parent_;
    private DesignType resolvedType_;
		private GivenParameterInstantiation	givenParameterAccess_;
		private final boolean isDirect_;
    public BlockVariableHandler( String name, BlockParameters parent) {
			this.type_ = new DesignTypeBlock(parent.baseEnvironment_, parent.baseError_);
      this.parent_ = parent;
      this.name_ = name;
      this.isDirect_ = false;
    }
    //The direct add constructor
    public BlockVariableHandler( String name, DesignType resolvedType, BlockParameters parent) {
			this.type_ = null; //This isn't needed
			this.resolvedType_ = resolvedType;
      this.parent_ = parent;
      this.name_ = name;
      this.isDirect_ = true;
    }
    public void requestRecordFromVariableFinal(DesignType recordType, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, BaseTrackers.DesignVariablePath variablePath) throws ParsingException {
  		if(recordType!=resolvedType_) {
  			throw ParsingException.createInvalidType(this.resolvedType_.getNameForError(), recordType.getNameForError());
  		}
  		givenParameterAccess_.requestRecordFromVariableFinal(fixedSkeleton, variablePath);
  		
  	}
    public void requestParameterSetForFixedFinal(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, ParameterSource parameterValueSource) {
			parameterValueSource.addDesignRecord(name_,this.resolvedType_,fixedSkeleton);
		}
    public void basicBuildRoot(BlockParameters parent, LocalEnvironment environment, ParameterSettingsFormHolder.ParameterSettingsFormBlock targetDataSkeleton, DesignTypeAccess typeAccess) {
    	if(this.type_!=null) {
    		this.resolvedType_ = type_.buildResolvedQuiet(typeAccess);
    	}
      
      if(this.resolvedType_!=null) {
      	this.givenParameterAccess_ = this.resolvedType_.createParameter(targetDataSkeleton, this.name_);
      }
    }
    public void basicBuildNonRoot(BlockParameters parent, LocalEnvironment environment, DataBlockFormBlock.IsNotRootDataBlock targetDataSkeleton, DesignTypeAccess typeAccess) {
      basicBuildRoot(parent,environment,targetDataSkeleton.getParent().getParametersParameter(), typeAccess);
    }
  	public void finalBuild() { }
  	
    public void buildImplementationParameters(ImplementationParameterTarget target) {
      
      this.resolvedType_.buildImplementationParameter(target, this.name_);
    }
    public void updateParametersSkeleton(ParameterSettingsFormHolder.ParameterSettingsFormBlock skeleton) {
    	Debug.println("DO UPDATE SKELETON FOR ROOT");
    	this.resolvedType_.updateParameter(skeleton, this.name_);
    } 
//    public void createJavaParameter(JavaParameterSettingsFormBlock skeleton) {
//      this.resolvedType_.updateJavaParameter(skeleton, this.name_);
//    } 
    //public void updateDesignForm(DesignFormBlock skeleton) { updateParametersSkeleton(skeleton.getParametersParameter()); } //No difference
  //  public void updateTargetParametersSkeleton(TargetBaseFormBlock.BlockDataBlock  skeleton) { updateParametersSkeleton(skeleton.getParametersParameter()); } //No difference
    //public void updateGeneralParametersSkeleton(DataBlockFormBlock.GeneralSubDataBlock skeleton){ updateParametersSkeleton(skeleton.getSubSettingsParameter()); } //No difference
    // ------------------------------------------------------------------------
    // Peer stuff
    public void end() {  }
		

		public void addIsArray(int lineNumber, int characterNumber) {
      SpecificCommonErrorOutput relatedError = this.parent_.baseError_.createAdjusted(lineNumber, lineNumber);
			this.type_.setIsArray(relatedError);
		}
		public DesignTypePatternPeer addDesignTypeForType() { return this.type_; }

  }

  

}
