package org.ffd2.skeletonx.compile.impl;

import org.ffd2.skeletonx.austenx.peg.base.ImportPatternPeer;
import org.ffd2.skeletonx.austenx.peg.base.PackagePathElementPeer;
import org.ffd2.solar.exceptions.ItemAlreadyExistsException;
import org.ffd2.solar.general.SimpleVector;
import org.ffd2.solar.language.SpecificCommonErrorOutput;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class ImportNode implements ImportPatternPeer {
  private final String namespace_;
  private final FileRoot environment_;
  private final SpecificCommonErrorOutput error_;
  private Handler handler_;
  private boolean doOutput_ = false;
  public ImportNode(String namespace, FileRoot environment, SpecificCommonErrorOutput error) {
    this.environment_ = environment;
    this.namespace_ = namespace;
    this.error_ = error;
  }
  public void addDoOutput() {
    this.doOutput_ =true;
  }

  public PackagePathElementPeer.NormalPatternPeer addOptionNormalOfPackagePathElementForPathElement() {
    PathHandler handler = new PathHandler();
    this.handler_ = handler;
    return handler;
  }
  public void addFileName(final String fileName) {
    this.handler_ = new Handler() {
     public void doEnd(ImportNode parent) {
      parent.doImport(fileName);
    }

    };
  }
  private final void doImport(String importFile) {
    try {
      environment_.addImport(namespace_,importFile,doOutput_,this.error_);
    } catch(ItemAlreadyExistsException e) {
      error_.repeatedObjectError("Namespace", namespace_);
    }
  }
  public void end() {
    this.handler_.doEnd(this);
  }
  // ===================================
  private static interface Handler {
    public void doEnd(ImportNode parent);
  }
  // -------------------
  private final static class PathHandler implements Handler,PackagePathElementPeer.NormalPatternPeer {
  	private final SimpleVector<String> components_ = new SimpleVector<String>();
  	public PathHandler() {
    }
    public void doEnd(ImportNode parent) {
      String importFile =components_.toString("/");
      parent.doImport(importFile);
    }
		public void end() { }
		public void addComponent(String value) {
			this.components_.addElement(value);
		}
  } //End of class PathHandler
}
