package org.ffd2.skeletonx.compile.impl;

import java.io.IOException;

import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.solar.io.FileLocator;


public class OutputGrouping {
	private final BaseBuilder	rootBuilder_;
	private final String[]	packageElements_;
//	private final String	builderOutputName_;
	private boolean isToOutput_ = false;
	public OutputGrouping(String[] packageElements, boolean doOutput,BaseBuilder	rootBuilder) {
		this.packageElements_ = packageElements;
	//	this.builderOutputName_ = builderOutputName;
		this.isToOutput_ = doOutput;
		this.rootBuilder_ = rootBuilder;

	}
	public void output(FileLocator target) throws IOException {
		rootBuilder_.outputStubs(this.packageElements_, this.isToOutput_, target);
	}

	public boolean isMatching(String[] packageElements) {
//		if(!builderOutputName.equals(this.builderOutputName_)) {
//			return false;
//		}
		if(packageElements.length!=this.packageElements_.length) {
			return false;
		}
		for(int i = packageElements.length-1 ; i>=0 ;i--) {
			if(!packageElements[i].equals(this.packageElements_[i])) {
				return false;
			}
		}
		return true;
	}
	public void setIsDoOutput() {
		this.isToOutput_ = true;
	}

	public BaseBuilder getRootBuilder() {
		return this.rootBuilder_;
	}
	
}
