package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.compile.impl.KeyDefinitionBlock;
import org.ffd2.skeletonx.compile.impl.MappingDefinitionBlock;
import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.BasicCallChainFormHolder.BasicCallChainFormBlock;
import org.ffd2.skeletonx.skeleton.ExpressionDetailsFormHolder.ExpressionDetailsFormBlock;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock;
import org.ffd2.skeletonx.skeleton.NameDetailsFormHolder.NameDetailsFormBlock;
import org.ffd2.skeletonx.skeleton.NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock;
import org.ffd2.skeletonx.skeleton.BaseTrackers.JavaVariablePath;
import org.ffd2.solar.exceptions.ParsingException;

//I don't normally do this, but what the hey
public abstract class AbstractIRecordVariable implements IRecordVariable {


	public void updateNameBlock(ComplexDataBlock target,
			JavaVariablePath variablePath, NameBlockDetails elementDetails)
			throws ParsingException {
		throw ParsingException.createGeneralSyntax("not for names");
	}

	public void updateExpressionFinal(CodeBlockEnvironment environment,
			ExpressionDetailsFormBlock expressionSkeleton, JavaVariablePath variablePath)
			throws ParsingException {
		throw ParsingException.createGeneralSyntax("not an expression");

	}

	public void updateCallChainFinal(BasicCallChainFormBlock target,
			JavaVariablePath variablePathToThisVariable) throws ParsingException {
		throw ParsingException.createGeneralSyntax("not call link");
	}

	public void addAsMacroRecordParameter(JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock macroCallBlock,
			JavaVariablePath variablePath, IVariableType type)
			throws ParsingException {
		throw ParsingException.createGeneralSyntax("not a record");

	}

	public void addAsMacroRecordMappingParameter(
			JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock  macroCallBlock, JavaVariablePath variablePath,
			MappingDefinitionBlock type) throws ParsingException {
		throw ParsingException.createGeneralSyntax("not a mapping");

	}

	public void addAsMacroRecordKeyParameter(JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock  macroCallBlock,
			JavaVariablePath variablePath, KeyDefinitionBlock type)
			throws ParsingException {
		throw ParsingException.createGeneralSyntax("not a key");

	}
	public void addAsGeneralExpressionTargetRequirement(MacroCallDataBlock macroCallBlock, JavaVariablePath variablePath) throws ParsingException {
		throw ParsingException.createGeneralSyntax("not an expression target");
		
	}
}
