package org.ffd2.skeletonx.compile.java;

import org.ffd2.solar.exceptions.ParsingException;

import org.ffd2.skeletonx.compile.java.layer.FoundationNode;
import org.ffd2.skeletonx.compile.java.layer.SLayer;
import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.BasicCallChainFormHolder.BasicCallChainFormBlock;
import org.ffd2.skeletonx.skeleton.ExpressionDetailsFormHolder.ExpressionDetailsFormBlock;
import org.ffd2.skeletonx.skeleton.NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock;
import org.ffd2.skeletonx.skeleton.BaseTrackers.JavaVariablePath;

public abstract class AbstractMarkIRecordVariable extends AbstractIRecordVariable implements IRecordVariable{
	private final String	markType_;

	public AbstractMarkIRecordVariable(String markType) {
		this.markType_ = markType;
		
	}
	public final IRecordVariable getResolvedVariableQuiet(String variableName, JavaVariablePath fromThisSpaceToTypeDeclarationPath) throws ParsingException {
		throw ParsingException.createGeneralSyntax(markType_+" have no sub varibles");
	}
	public final IRecordVariable getBuilderVariableFromLayersOnlyQuiet(String name, JavaVariablePath pathToVariable) throws ParsingException {
		throw ParsingException.createGeneralSyntax(markType_+" have no sub varibles");
	}

	public final IRecordVariable getBuilderVariableWideQuiet(String name, JavaVariablePath pathToVariable) throws ParsingException {
		throw ParsingException.createGeneralSyntax(markType_+" have no sub varibles");

	}
 
	public final SLayer getValueRecordFinal(JavaVariablePath variablePath) throws ParsingException {
		throw ParsingException.createGeneralSyntax(markType_+" have no records");
	}
	public FoundationNode getAsFoundataionNodeReferenceVariable() throws ParsingException {
		throw ParsingException.createGeneralSyntax(markType_+" have no records");
  }
	public final void updateNameBlock(ComplexDataBlock target, JavaVariablePath variablePath, NameBlockDetails elementDetails) throws ParsingException {
		throw ParsingException.createGeneralSyntax(markType_+" are not for names");
	}
	public final void updateExpressionFinal(CodeBlockEnvironment environment, ExpressionDetailsFormBlock expressionSkeleton, JavaVariablePath variablePath) throws ParsingException {
		throw ParsingException.createGeneralSyntax(markType_+" are not expressions");

	}
	
	public final void updateCallChainFinal(BasicCallChainFormBlock target, JavaVariablePath variablePathToThisVariable) throws ParsingException {
		throw ParsingException.createGeneralSyntax(markType_+" are not call links");
	}
}
