package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.compile.impl.KeyDefinitionBlock;
import org.ffd2.skeletonx.compile.impl.MappingDefinitionBlock;
import org.ffd2.skeletonx.compile.java.layer.SLayer;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.skeletonx.skeleton.BasicCallChainFormHolder.BasicCallChainFormBlock;
import org.ffd2.skeletonx.skeleton.ExpressionDetailsFormHolder.ExpressionDetailsFormBlock;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock;
import org.ffd2.skeletonx.skeleton.NameDetailsFormHolder.NameDetailsFormBlock;
import org.ffd2.skeletonx.skeleton.StringBuilderVariableAccessFormHolder.StringBuilderVariableAccessFormBlock;
import org.ffd2.solar.exceptions.ParsingException;

public interface IRecordVariable  {
  //public IRecordVariable getResolvedVariable(String name, BaseTrackers.JavaVariablePath variablePath) throws ParsingException;
  
  //At a later point could change to returning a "ScaffoldReference" for more complex variable types (such as arrays)

	  //public SLayer getDefiningLayer();
  /**
   * adds name block reference for this variable (if viable)
   * @param target
   * @param variablePath  the chain of variables leading to this one (the called variable may update this path - callers must treat it as a workspace variable)
   * @param elementDetails TODO
   * @throws ParsingException
   * @note the variable path should be allowed to be altered by implementations!
   */
  public void updateNameBlock(NameDetailsFormBlock.ComplexDataBlock target,BaseTrackers.JavaVariablePath variablePath, NameBlockDetails elementDetails) throws ParsingException;
  public boolean isMatchesVariableName(String queryVariableName);
  public String getRoughVariableName();
  
  public void updateExpressionFinal(CodeBlockEnvironment environment, ExpressionDetailsFormBlock expressionSkeleton,BaseTrackers.JavaVariablePath variablePath) throws ParsingException;
  
  public void addAsMacroRecordParameter(MacroCallDataBlock macroCallBlock,BaseTrackers.JavaVariablePath variablePath, IVariableType type ) throws ParsingException;
  public void addAsGeneralExpressionTargetRequirement(MacroCallDataBlock macroCallBlock,BaseTrackers.JavaVariablePath variablePath)throws ParsingException;
  public void addAsMacroRecordMappingParameter(MacroCallDataBlock macroCallBlock,BaseTrackers.JavaVariablePath variablePath, MappingDefinitionBlock type ) throws ParsingException;
  public void addAsMacroRecordKeyParameter(MacroCallDataBlock macroCallBlock,BaseTrackers.JavaVariablePath variablePath, KeyDefinitionBlock type ) throws ParsingException;

  public void updateCallChainFinal(BasicCallChainFormBlock target, BaseTrackers.JavaVariablePath variablePathToThisVariable) throws ParsingException;
  //public ImplementationRecord getHostingRecord();
  
//  public CodeReference getAsCodeReference() throws ParsingException;
//	public ArgTypesReference getAsArgTypesMarkReference() throws ParsingException;
//	public ArgValuesReference getAsArgValuesMarkReference() throws ParsingException;
//  public MappingReference getAsMappingReference() throws ParsingException;
//  public KeyMarkerReference getAsKeyReference() throws ParsingException;
//  
  public void getAsReference(IRecordTypeTarget target);
  /**
	 * Get access to a path that leads to a FoundationNode Layer
	 * @param variablePath a current path, that will have any final links added to include the variable "pointing" to a block relating to the 
	 * specified FoundationNode
	 * @return the FoundationNode this BuilderVariable references
	 * @throws ParsingException if this variable doesn't reference a FoundationNode!
	 */
	public SLayer getAsFoundataionNodeReferenceVariable(BaseTrackers.JavaVariablePath variablePath) throws ParsingException;
 // public BuilderVariableAccess getAsBuilderVariableAccess() throws ParsingException;
  
//	public void doVariableQueryMatch(JavaImplementationForm.BlockDataBlock.SearchRecordDataBlock targetSkeleton, IRecordVariable queryMatchValue, BaseTrackers.JavaVariablePath variablePathToQueryMatch) throws ParsingException;

  
  
  public static interface NameBlockDetails {
  	public void updateStringParameter(StringBuilderVariableAccessFormBlock parameterSkeleton,NameDetailsFormBlock.ComplexDataBlock target,BaseTrackers.JavaVariablePath variablePath);
  }
  public static final NameBlockDetails CAPITALISED = new NameBlockDetails() {
  	public void updateStringParameter(StringBuilderVariableAccessFormBlock parameterSkeleton,NameDetailsFormBlock.ComplexDataBlock target,BaseTrackers.JavaVariablePath variablePath) {
  		target.addNameElement().addStringCapitalisedParameter( variablePath,parameterSkeleton);
  	}
  };
  public static final NameBlockDetails DECAPITALISED = new NameBlockDetails() {
  	public void updateStringParameter(StringBuilderVariableAccessFormBlock parameterSkeleton,NameDetailsFormBlock.ComplexDataBlock target,BaseTrackers.JavaVariablePath variablePath) {
  		target.addNameElement().addStringDecapitalisedParameter(variablePath,parameterSkeleton);
  	}
  };
  

}
