package org.ffd2.skeletonx.compile.java;

import org.ffd2.austenx.runtime.GeneralErrorCatcher;
import org.ffd2.solar.general.Source;
import org.ffd2.solar.language.GeneralCommonErrorOutput;
import org.ffd2.solar.language.StringBasedCharacterSource;

import org.ffd2.skeletonx.austenx.lexi.main.SkeletonLexParser;
import org.ffd2.skeletonx.austenx.lexi.tokens.SkeletonTable;
import org.ffd2.skeletonx.austenx.lexi.tokens.SkeletonToken;
import org.ffd2.skeletonx.austenx.peg.base.JavaImplementationElementPeer;
import org.ffd2.skeletonx.austenx.peg.base.JavaImplementationIncludeFilePatternPeer;
import org.ffd2.skeletonx.austenx.packrat.library.JavaImplementationIncludeFileRootBuilderForSkeleton;
import org.ffd2.skeletonx.austenx.packrat.library.SkeletonPackrat;

public class JavaIncludeImplementationElementTool implements JavaImplementationIncludeFileRootBuilderForSkeleton,JavaImplementationIncludeFilePatternPeer{
	private final JavaImplementationElementPeer.Indirect	base_;

	public JavaIncludeImplementationElementTool(JavaImplementationElementPeer.Indirect base) {
		this.base_ = base;
	}
	public void end() { }

	public JavaImplementationElementPeer.Indirect getJavaImplementationElementForElement() {
		return base_;
	}
	public JavaImplementationIncludeFilePatternPeer buildJavaImplementationIncludeFile() {
		return this;
	}
	// ==========================================================================
	public void doInclude(String fileText, GeneralCommonErrorOutput adjustedGeneral) {
//		String fileText = this.fileEnvironment_.readFile(fileName);
    SkeletonTable table = new SkeletonTable();
    SkeletonLexParser lex = new SkeletonLexParser();
    GeneralErrorCatcher errorCatcher = new GeneralErrorCatcher(adjustedGeneral);//error.createAdjustedBase(fileName));
    lex.doParseForNormal(new StringBasedCharacterSource(fileText),table,errorCatcher);
    if(!errorCatcher.isInError()) {
      Source<SkeletonToken> tokens = table.getTokens();
//      Debug.println("Tokens:",tokens);
      SkeletonPackrat builder = new SkeletonPackrat(tokens);
      builder.buildJavaImplementationIncludeFile(this,errorCatcher);
    }
	}
		

}
