package org.ffd2.skeletonx.compile.java;

import org.ffd2.solar.general.Debug;

import org.ffd2.skeletonx.compile.impl.DesignBridgeComponents.DesignRecordReference;
import org.ffd2.skeletonx.compile.java.layer.FoundationNode;
import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock;


public class LinkupTracker {
  private final FoundationNode[] newLinkups_;
  private final ChainImplementationConnection[] chainLinkups_;
  private final JavaImplementationFormBlock baseForm_;

  private int spareBlockIndexCounter_;
  public LinkupTracker(JavaImplementationFormBlock baseForm, int numberOfBlocksInDesign, int numberOfChainsInDesign) {

    this.newLinkups_ = new FoundationNode[numberOfBlocksInDesign];
    this.chainLinkups_ = new ChainImplementationConnection[numberOfChainsInDesign];
    this.baseForm_ = baseForm;
		this.spareBlockIndexCounter_ = numberOfBlocksInDesign; //This is a hack

  }
  //Need to change so all blocks are allocated before linkup (use @link on implements in JavaImplementation and Block code...)
  public JavaImplementationFormBlock.BlockDataBlock allocateSpareNode(
  		String name, String fullName
  	) {
  	JavaImplementationFormBlock.BlockDataBlock skeletonBlock = this.baseForm_.addBlock(name, fullName,  this.spareBlockIndexCounter_++,this.baseForm_.getRootBuilder().createJavaParameterSettingsChild());
  	return skeletonBlock;
  
  }
  public FoundationNode getImplementationContainer(int index) {
  	return this.newLinkups_[index];
  }

  public FoundationNode getLinkup(int recordIndex) {
  	FoundationNode result =this.newLinkups_[recordIndex];
    if(result==null) {
      Debug.println("Result linkup is null:", this.newLinkups_);
    }
    return result;
  }
  public ChainImplementationConnection getChainLinkup(int chainIndex) {
  	ChainImplementationConnection result =this.chainLinkups_[chainIndex];
    if(result==null) {
      Debug.println("Result chain linkup is null:", this.chainLinkups_);
    }
    return result;
  }
  public void setChainImplementation(int chainIndex, ChainImplementationConnection connection) {
  	assert this.chainLinkups_[chainIndex] == null;
  	this.chainLinkups_[chainIndex] = connection;
  	
  }
  
  // ==========================================================================
//  public JavaImplementationForm.BlockDataBlock.IsDesignLinkedDataBlock instantiateRecord(DesignRecordReference reference, ImplementationRecord linkup) {
//    final int recordIndex = reference.getRecordIndex();
//    this.linkups_[recordIndex] = linkup;
//    return reference.buildJavaImplementations(this.baseForm_);
//  }
//  
  public JavaImplementationFormBlock.BlockDataBlock.IsDesignLinkedDataBlock instantiateDesignNode(DesignRecordReference reference, FoundationNode linkup) {
    final int recordIndex = reference.getRecordIndex();
    this.newLinkups_[recordIndex] = linkup;
    return reference.buildJavaImplementations(this.baseForm_);
  }
  
//  public JavaImplementationForm.BlockDataBlock instantiateUnusedRecord(RecordReference reference, IRecordResolutionEnvironment recordEnvironment) {
//    final int recordIndex = reference.getRecordIndex();
//    BlockDataBlock builtDataBlock = reference.buildJavaImplementations(this.baseForm_);
//    ImplementationRecord linkup = new ImplementationRecord(this.environemnt_,recordEnvironment);
//    this.linkups_[recordIndex] = linkup;
//    return builtDataBlock;
//  }
//  public JavaImplementationForm.BlockDataBlock.IsDesignLinkedDataBlock getBlockSkeleton(int index) {
//    return linkups_[index].getBlockSkeleton();
//  }
//  public ImplementationRecord getJavaImplementationRecord(int index) {
//  	return this.linkups_[index];
//  }
//  public ImplementationTarget getDummyTarget(JavaImplementationForm.BlockDataBlock dataBlock) {
//    return new DummyTarget(dataBlock, this);
//  }
//  private static final class DummyTarget implements ImplementationTarget {
//    private final LinkupTracker parent_;
//    private final JavaImplementationForm.BlockDataBlock dataBlock_;
//    public DummyTarget(JavaImplementationForm.BlockDataBlock dataBlock, LinkupTracker parent) {
//      this.parent_ = parent;
//      this.dataBlock_ = dataBlock;
//    }
//    public ImplementationTarget newInternalChild(String childName, RecordReference reference, TargetBaseForm.BlockDataBlock.ChildRefDataBlock childRefInParent) {
//      JavaImplementationForm.BlockDataBlock result =  parent_.instantiateUnusedRecord(reference);
//      dataBlock_.addChildRefBlock(childName,childRefInParent, result.addIsChildBlock(dataBlock_) );
//      return new DummyTarget(result,this.parent_);
//    }
//    public void newTerminalChild(String childName, RecordReference reference, TargetBaseForm.BlockDataBlock.ChildRefDataBlock childRefInParent) {
//      JavaImplementationForm.BlockDataBlock result = parent_.instantiateUnusedRecord(reference);   
//      dataBlock_.addChildRefBlock(childName,childRefInParent, result.addIsChildBlock(dataBlock_) );
//    }
//    public void allChildrenGiven() {
//      //Nothing to do...
//    }
//  }
}
