package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.skeleton.BaseTrackers.JavaVariablePath;
import org.ffd2.solar.exceptions.ItemNotFoundException;
import org.ffd2.solar.exceptions.ParsingException;

public class NullDataBlockEnvironment{// implements DataBlockEnvironment {
  public static final NullDataBlockEnvironment INSTANCE = new NullDataBlockEnvironment();
  private NullDataBlockEnvironment() {
    
  }
  public IRecordVariable getResolvedVariable(String variableName)  throws ItemNotFoundException {
    throw new ItemNotFoundException(variableName, "builder variable", variableName);
  }
  public String getRecordName() { return "NULL"; }
  
  public TargetMethod getTargetMethod(String name) throws ItemNotFoundException {
    throw new ItemNotFoundException(name, "target method", name);
  }
  public TargetMethod getTargetMethod(String name, TargetType containingType) throws ItemNotFoundException {
    throw new ItemNotFoundException(name, "target method", name);
  }

  public TargetVariable getTargetVariable(String name)
                                                      throws ItemNotFoundException {
    throw new ItemNotFoundException(name, "target variable", name);
  }

  public TargetType getTargetType(String typeName) throws ParsingException {
    throw new ItemNotFoundException(typeName, "target type", typeName);
  }
  public TargetVariable getTargetVariable(String name, TargetType containingType) throws ParsingException {
    throw new ItemNotFoundException(name, "target variable", name);
  }
  public TargetType getTargetType(String typeName, JavaVariablePath basePath) throws ParsingException {
    throw new ItemNotFoundException(typeName, "target type", typeName);
  }
    

}
