package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.compile.java.layer.SLayer;
import org.ffd2.skeletonx.skeleton.BClassContainerAccessFormHolder.BClassContainerAccessFormBlock;
import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock;

import org.ffd2.solar.exceptions.ItemNotFoundException;
import org.ffd2.solar.exceptions.ParsingException;
import org.ffd2.solar.general.Debug;

public class RecordContainerAccess {

  private final BClassContainerAccessFormBlock containerVariable_;
  private final SLayer currentLayer_;
  private final SLayer variableDefiningLayer_;
  private BaseTrackers.JavaVariablePath builtPathToClassDef_;
	private final GlobalClassReference[]	allGlobalReferences_;
	/**
	 * 
	 * @param currentRecord
	 * @param containingClass
	 * @param allGlobalReferences the global references of the containing class - may be null if no such references made
	 */
  public RecordContainerAccess(SLayer currentLayer,SLayer variableDefiningLayer, BClassContainerAccessFormBlock containerVariable,final GlobalClassReference[] allGlobalReferences) { //, String packageSubName) {
    this.currentLayer_ = currentLayer;
    this.variableDefiningLayer_ = variableDefiningLayer;
    this.containerVariable_ = containerVariable;
		this.allGlobalReferences_ = allGlobalReferences;
  }
//  public String getPackageSubName() { return this.packageSubName_; }
  public void addContextRef(MacroCallDataBlock macroCallBlock) {

  	//TODO: this should throw an error
  	Debug.finishMeMarker();
  	macroCallBlock.addInGeneral(this.containerVariable_, this.getPathToClassDefinition());
  }
  public void addGeneralRef(MacroCallDataBlock macroCallBlock) {
  	macroCallBlock.addInGeneral(this.containerVariable_, this.getPathToClassDefinition());
  }
  public MacroCallInstance createMacroCallFinal(
			String variableName,
			MacroConstruction macro,
			MacroCallRequirementsAccess requirementsAccess
		) {
  	return this.currentLayer_.createMacroCallFinal(variableName, macro,requirementsAccess);
  }
  //Repeated with Basic version
  //  public MacroConstruction getMacroConstructionFinal(String macroName) throws ItemNotFoundException {
//  	return this.currentRecord_.getMacroConstructionBasic(macroName);
//  }
  
//  private JavaImplementationForm.BlockDataBlock.ItemDataBlock.MakeClassDataBlock.GeneralTypeDataBlock classSkeleton_;
//	private final ClassConstruction parent_;
//	private final JavaVariablePath chainToParentClassDef_  = new JavaVariablePath();
//	public InContainerSkeletons( ClassConstruction parent,RecordContainerAccess parentContainer) {
//		this.parent_ = parent;
//		this.parentContainer_ = parentContainer;
//		
//	}
	public JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MakeClassDataBlock.GeneralTypeDataBlock 
			buildGeneralTypeSkeleton(
					SLayer currentEnvironment,
					JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MakeClassDataBlock classSkeleton) {
		BaseTrackers.JavaVariablePath pathToBaseRecordStore = new BaseTrackers.JavaVariablePath();
		currentEnvironment.buildPathToUpperLayer(variableDefiningLayer_, pathToBaseRecordStore);
		return classSkeleton.addGeneralType(containerVariable_, pathToBaseRecordStore);
	}
	
	
  
  public MacroCallInstance createMacroCallFinal(
			MacroConstruction macro,
			MacroCallRequirementsAccess requirementsAccess
		) {
		return this.currentLayer_.createMacroCallFinal(macro.getName(), macro, requirementsAccess);
	}
  public GlobalClassReference[] getAllGlobalClassReferences() { return this.allGlobalReferences_; }
  public RecordContainerAccess getLinkedQuiet(LinkChainBlock chainBlock)  {
  	//This is wrong as it does not handle variable path stuff?
  	//Answer: No, as the linkage will be rebuilt later when requested..
  	//UPDATE: HAVE SHIFTED STUFF BACK TO NORMAL - NEED TO CHECK THE UTILS. method
    SLayer linkedRecord = chainBlock.getLinkChainEndContainerQuiet(this.currentLayer_);
//    Debug.println("LINK PATH:",linkPathToRecord);
    if(linkedRecord==null) {
      return null;
    } else {
      return new RecordContainerAccess(linkedRecord, this.variableDefiningLayer_, this.containerVariable_,this.allGlobalReferences_); //,this.packageSubName_);
    }
  }
  
	public MacroConstruction getMacroConstructionFinal(String name, BaseTrackers.JavaVariablePath pathToContainingLayer) throws ItemNotFoundException {
		return this.currentLayer_.getMacroConstructionFinal(name,pathToContainingLayer);
	}
  public SLayer getBaseLayer() { return this.currentLayer_; }
  
  
  //Source of problem - must make sure this is called when building basic structure - before solidification with foundation node stuff
  public RecordContainerAccess getChild(String childName,int lineNumber) throws ParsingException{
    SLayer linkedRecord = this.currentLayer_.getNodeChild(childName,lineNumber);
    return new RecordContainerAccess(linkedRecord,this.variableDefiningLayer_, this.containerVariable_,this.allGlobalReferences_); //,this.packageSubName_);
  }
 
  private BaseTrackers.JavaVariablePath getPathToClassDefinition() {
    if(builtPathToClassDef_==null) {
      builtPathToClassDef_ = new BaseTrackers.JavaVariablePath(); 
      this.currentLayer_.buildPathToUpperLayer(this.variableDefiningLayer_, builtPathToClassDef_);
    }
    return builtPathToClassDef_;
  }
 
}
