package org.ffd2.skeletonx.compile.java;


import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.BaseTrackers.JavaVariablePath;
import org.ffd2.skeletonx.skeleton.BasicCallChainFormHolder.BasicCallChainFormBlock;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock;
import org.ffd2.skeletonx.skeleton.TypeSetterDetailsFormHolder.TypeSetterDetailsFormBlock;

import org.ffd2.solar.exceptions.ParsingException;

public class StaticTypeVariable implements TargetVariable{
	private final TargetTypeReference baseType_;

	public StaticTypeVariable(TargetTypeReference baseType ) {
		this.baseType_ = baseType;
		
	}

	public void createCallExpressionFinal(BasicCallChainFormBlock target, JavaVariablePath basePathDisposable) {
		TypeSetterDetailsFormBlock typeSkeleton = target.getRootBuilder().createTypeSetterDetailsChild();
		target.addElement().addStaticCall(typeSkeleton);
		this.baseType_.getBaseType().buildCodeSetType(typeSkeleton,basePathDisposable);
	}

	public void createMacroCallParameter(JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock macroCallBlock,
			JavaVariablePath pathToVariable) throws ParsingException {
		throw ParsingException.createInvalidConstruction("Static type", this.baseType_.getBaseType().getOutputName(), "Cannot use static types as variables for macros");
		
	}

	public TargetTypeReference getTargetTypeReferenceQuietFinal() {
		return this.baseType_;
	}
}
