package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.skeleton.ArgumentSetDetailsFormHolder.ArgumentSetDetailsFormBlock;
import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.skeletonx.skeleton.BaseTrackers.JavaVariablePath;
import org.ffd2.skeletonx.skeleton.BasicCallChainFormHolder.BasicCallChainFormBlock;
import org.ffd2.skeletonx.skeleton.ExpressionDetailsFormHolder.ExpressionDetailsFormBlock;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock;

import org.ffd2.solar.exceptions.ParsingException;

public interface TargetMethod {
  /**
   * Does not have to be valid until Intermediate pass
   * @param toTypeDefChainStorage storage for the links from the hosting area of the target variable to the declaration of its TargetType
   * @return the target type, or null if type not available.
   */
  //public TargetType getReturnTargetType(BaseTrackers.JavaVariablePath toTypeDefChainStorage);

  public TargetTypeReference getReturnTargetTypeReferenceQuietFinal();

  public GlobalMethodReference getAsGlobalQuiet();
  public boolean isStatic();
  /**
   * 
   * @param target
   * @param basePathDisposable
   * @return may return null
   */
  public ArgumentSetDetailsFormBlock createExpressionFinal(ExpressionDetailsFormBlock target, JavaVariablePath basePathDisposable);
  public ArgumentSetDetailsFormBlock createCallExpressionFinal(BasicCallChainFormBlock target, JavaVariablePath basePathDisposable);
  
	public JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MethodDataBlock.ImplementsNameDataBlock 
				addMethodImplementsNameBlock(JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MethodDataBlock target, BaseTrackers.JavaVariablePath methodDeclarationPathChainTracker) throws ParsingException;

  
}
