package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.BaseTrackers.JavaVariablePath;
import org.ffd2.skeletonx.skeleton.TypeSetterDetailsFormHolder.TypeSetterDetailsFormBlock;

import org.ffd2.solar.exceptions.ParsingException;

public interface TargetType //extends TargetElementAccess 
{	 
	//Maybe should have getTargetMethod(String name, SLayer initialLayer); type message
	// seems a much nicer solution to the direct access problem. 
	
	/**
	 * Get the direct access for types that support it (eg external types)
	 * @return the direct access, or null if not possible with this type
	 * @note this is a hacky way of doing things - should ask the type to get target element, passing a callback that can be used to search parents (which will not be used in case of "Direct" elements)
	 */
	public DirectTargetElementAccess getDirectElementAccessQuiet();
	
	public boolean isSubTypeOf(TargetType parentType);
	
	//public TargetTypeWithPath formTargetTypeWithPath(RecordAccess baseEnvironment);
	
	public TargetType specifyGenericTypes(TargetTypeWithPath[] types) throws ParsingException;
	public TargetType getArrayed(int dimensions) throws ParsingException;

  public void buildCodeSetType(TypeSetterDetailsFormBlock target,JavaVariablePath disposableTargetPath);
  /**
   * The base path may be altered by the implementation 
   * @param target
   * @param basePathDisposable can be altered, the caller shouldn't use it anymore
   */
  //public void createStaticTypeExpression(BaseBuilder.ExpressionCode target, BaseTrackers.JavaVariablePath basePathDisposable);
  public String getOutputName();
}
