package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.BaseTrackers.JavaVariablePath;
import org.ffd2.skeletonx.skeleton.TypeSetterDetailsFormHolder.TypeSetterDetailsFormBlock;

public class TargetTypeWithPath {
	private final TargetTypeReference typeReference_;
	private final JavaVariablePath path_;
	//Marker constructor for a better usage.
	public TargetTypeWithPath(TargetTypeReference typeReference) {
		this(typeReference,new JavaVariablePath());
	}
	public TargetTypeWithPath(TargetTypeReference typeReference, JavaVariablePath path) {
		this.typeReference_ = typeReference;
		this.path_ = path;
	}
	public TargetTypeReference getTypeReference() {
		return this.typeReference_;
	}
	public void buildCodeSetType(TypeSetterDetailsFormBlock target) {
		this.typeReference_.getBaseType().buildCodeSetType(target,this.path_.getCopy());
	}
	public TargetType getType() { return this.typeReference_.getBaseType(); }
}
