package org.ffd2.skeletonx.compile.java.layer;

import org.ffd2.skeletonx.compile.impl.FileEnvironment;
import org.ffd2.skeletonx.compile.java.IRecordVariable;
import org.ffd2.skeletonx.compile.java.LinkupTracker;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.skeletonx.skeleton.BaseTrackers.JavaVariablePath;
import org.ffd2.solar.exceptions.ParsingException;
import org.ffd2.solar.general.Debug;

public final class MacroGeneralLayerType implements NonFoundationChildSLayerMaker {
	private final SLayer					parentPeerLayer_;
	private final FileEnvironment	environment_;
	private final IRecordVariable	referencingVariable_;
	private final JavaVariablePath pathFromChildLayerToParentPeerLayer_;

	private MacroGeneralLayerType(SLayer parentPeerLayer, BaseTrackers.JavaVariablePath pathFromChildLayerToParentPeerLayer, IRecordVariable referencingVariable, FileEnvironment environment) {
		this.parentPeerLayer_ = parentPeerLayer;
		this.pathFromChildLayerToParentPeerLayer_ = pathFromChildLayerToParentPeerLayer;
		this.referencingVariable_ = referencingVariable;
		this.environment_ = environment;

	}

	public static final MacroGeneralLayerType createForNodeChild(SLayer parentPeerLayer,BaseTrackers.JavaVariablePath pathFromChildLayerToParentPeerLayer, FileEnvironment environment) {
		return new MacroGeneralLayerType(parentPeerLayer, pathFromChildLayerToParentPeerLayer,null, environment);
	}

	public static final MacroGeneralLayerType createForVariableChild(SLayer parentPeerLayer,BaseTrackers.JavaVariablePath pathFromChildLayerToParentPeerLayer, IRecordVariable referencingVariable, FileEnvironment environment) {
		return new MacroGeneralLayerType(parentPeerLayer, pathFromChildLayerToParentPeerLayer,referencingVariable, environment);
	}

	public NodeLayerChild createNewNodeLayerChild(String name,
			ImplementationBlockSkeletonManager blockSkeleton,
			LinkupTracker relatedTracker, SLayer parentLayer,
			LayerType parentLayerType, FileEnvironment fileEnvironment, int lineNumber) throws ParsingException {

		BaseTrackers.JavaVariablePath pathToVariableDefinition = new BaseTrackers.JavaVariablePath();
		this.pathFromChildLayerToParentPeerLayer_.transferTo(pathToVariableDefinition);

		SLayer peerChildLayer = this.parentPeerLayer_.getNodeChild(name,lineNumber);
		
		BaseTrackers.JavaVariablePath childPathToPeer = new BaseTrackers.JavaVariablePath();
//		if(name.equals("StoreValue")) {
//			Thread.dumpStack();
//		}
		boolean foundPeer = parentLayer.buildHorizontalPathToPeerLayerViaSkeleton(this.parentPeerLayer_, childPathToPeer);

	//	Okay - need to remember that the referenced layer will have a direct peer with the specified name (peerChildLayer)
		LocalChild childRef = blockSkeleton.createLocalChild(
				name, parentLayer, MacroGeneralLayerType.createForNodeChild(peerChildLayer,childPathToPeer, this.environment_), relatedTracker,
				peerChildLayer, childPathToPeer);

		SLayer childLayer = childRef.getChildLayer();
		return NodeLayerChild.createLocalChild(name, childLayer, childRef);
	}

	public VariableChild createNewVariableLayerChild(String name, IRecordVariable resolvedVariable, BaseTrackers.JavaVariablePath pathToVariableDefinition,
			SLayer parentLayer, LayerType parentLayerType, FileEnvironment fileEnvironment, int lineNumber)
			throws ParsingException {		
//		if(name.equals("token")) {
//			Thread.dumpStack();
//		}
//		BaseTrackers.JavaVariablePath pathToMacroVariableDefinition = new BaseTrackers.JavaVariablePath();
//		IRecordVariable macroVariable = parentLayer.getLayerStrictBuilderVariableQuiet(name, pathToMacroVariableDefinition);
//		//Just a hack to see if the peer can resolve variable. 
//		if (macroVariable != null) {
//			macroVariable.
//			DualIndirectLayerType parentBridgeForChild =
//					DualIndirectLayerType.buildVariableBased(
//							pathToVariableDefinition,
//							this.parentPeerLayer_,
//							parentLayer,
//							MacroGeneralLayerType.createForVariableChild(
//									parentPeerLayer_, macroVariable, this.environment_),
//							macroVariable,
//							fileEnvironment
//							);
//			
//			SLayer childLayer = parentBridgeForChild.getChildLayer();
//			return new VariableChild(name, childLayer, macroVariable, fileEnvironment, pathToMacroVariableDefinition);
//
//		} else {
		// *************** THIS IS WHERE THERE WILL BE PROBLEMS ******************8	
		VariableChild peerLayerChild = this.parentPeerLayer_.getVariableChildNodeQuiet(name,lineNumber);
			SLayer nextLayer = resolvedVariable.getAsFoundataionNodeReferenceVariable(pathToVariableDefinition);
			if(peerLayerChild==null) {
				BaseTrackers.JavaVariablePath childPathToPeer = new BaseTrackers.JavaVariablePath();

				DualIndirectLayerType parentBridgeForChild =
						DualIndirectLayerType.buildVariableBased(
								pathToVariableDefinition,
								nextLayer,
								parentLayer,
								MacroGeneralLayerType.createForVariableChild(
										nextLayer, childPathToPeer, this.referencingVariable_, this.environment_),//,pathToVariableDefinition),
		
								// new
								// RedirectedChildSLayerMaker(nextLayer,resolvedVariable,pathToVariableDefinition),
								resolvedVariable, fileEnvironment);
				SLayer childLayer = parentBridgeForChild.getChildLayer();
				parentLayer.buildHorizontalPathToPeerLayerViaSkeleton(this.parentPeerLayer_, childPathToPeer);
				//childLayer.buildHorizontalPathToPeerLayer(nextLayer, childPathToPeer);
				return new VariableChild(name, childLayer, resolvedVariable, fileEnvironment, pathToVariableDefinition);
		
			} else {
//				SLayer nextLayer = resolvedVariable.getAsFoundataionNodeReferenceVariable(pathToVariableDefinition);
				BaseTrackers.JavaVariablePath childPathToPeer = new BaseTrackers.JavaVariablePath();
				DualIndirectLayerType parentBridgeForChild =
						DualIndirectLayerType.buildVariableBased(
								pathToVariableDefinition,
								nextLayer,
								parentLayer,
								MacroGeneralLayerType.createForVariableChild(
										peerLayerChild.getBase(),childPathToPeer, peerLayerChild.getReferencingVariable(), this.environment_),//,pathToVariableDefinition),
		
								// new
								// RedirectedChildSLayerMaker(nextLayer,resolvedVariable,pathToVariableDefinition),
								resolvedVariable, fileEnvironment);
				SLayer childLayer = parentBridgeForChild.getChildLayer();
				parentLayer.buildHorizontalPathToPeerLayer(this.parentPeerLayer_, childPathToPeer);

	//			childLayer.buildHorizontalPathToPeerLayer(nextLayer, childPathToPeer);

				return new VariableChild(name, childLayer, resolvedVariable, fileEnvironment, pathToVariableDefinition);
			}
		// return SLayer.NORMAL_CHILD_MAKER.createNewVariableLayerChild(name,
		// resolvedVariable, pathToVariableDefinition, parentLayer, parentLayerType,
		// fileEnvironment);

		// VariableChild peerLayerChild =
		// this.parentPeerLayer_.getVariableChildNode(name);
		// DualIndirectLayerType parentBridgeForChild =
		// DualIndirectLayerType.buildVariableBased(
		// pathToVariableDefinition,
		// peerLayerChild.getBase(),
		// parentLayer,
		// MacroGeneralLayerType.createForVariableChild(peerLayerChild.getBase(),peerLayerChild.getReferencingVariable(),this.environment_),
		// peerLayerChild.getReferencingVariable(),
		// fileEnvironment
		// );
		// SLayer childLayer = parentBridgeForChild.getChildLayer();
		//
		// //TODO : What am I doing?
		// return new VariableChild(name, childLayer,resolvedVariable,
		// fileEnvironment);
	}

	public VariableChild createNewVariableLayerChildNonLocal(String name,
			SLayer parentLayer, LayerType parentLayerType, FileEnvironment fileEnvironment, int lineNumber)
			throws ParsingException {
		BaseTrackers.JavaVariablePath pathToMacroVariableDefinition = new BaseTrackers.JavaVariablePath();
		IRecordVariable macroVariable = parentLayer.getLayerStrictBuilderVariableQuiet(name, pathToMacroVariableDefinition);
		
		if (macroVariable != null) {
			//VariableChild variableChild = createNewVariableLayerChild(name, macroVariable, pathToMacroVariableDefinition, parentLayer, parentLayerType, fileEnvironment);

			SLayer nextLayer = macroVariable.getAsFoundataionNodeReferenceVariable(pathToMacroVariableDefinition);
			BaseTrackers.JavaVariablePath childPathToPeer = new BaseTrackers.JavaVariablePath();
			DualIndirectLayerType parentBridgeForChild =
					DualIndirectLayerType.buildVariableBased(
							pathToMacroVariableDefinition,
							nextLayer,
							parentLayer,
							MacroGeneralLayerType.createForVariableChild(
									nextLayer, childPathToPeer, this.referencingVariable_, this.environment_),//,pathToVariableDefinition),
	
							// new
							// RedirectedChildSLayerMaker(nextLayer,resolvedVariable,pathToVariableDefinition),
							macroVariable, fileEnvironment);
			SLayer childLayer = parentBridgeForChild.getChildLayer();
			childLayer.buildHorizontalPathToPeerLayer(nextLayer, childPathToPeer);
			return new VariableChild(name, childLayer, macroVariable, fileEnvironment, pathToMacroVariableDefinition);
		} else {
			final BaseTrackers.JavaVariablePath pathToVariableDefinition = new BaseTrackers.JavaVariablePath();
			//BaseTrackers.JavaVariablePath childPathToPeer = new BaseTrackers.JavaVariablePath();
			VariableChild peerLayerChild = this.parentPeerLayer_.getVariableChildNode(name,lineNumber);
			if (peerLayerChild.getReferencingVariable() == this.referencingVariable_) {
				throw ParsingException.createInvalidVariable(name, "referencing self");
			}
			BaseTrackers.JavaVariablePath childPathToPeer2 = new BaseTrackers.JavaVariablePath();
			
			parentLayerType.buildHorizontalPathToPeerLayer( this.parentPeerLayer_, childPathToPeer2);
			DualIndirectLayerType parentBridgeForChild =
					DualIndirectLayerType.buildVariableBased(
							childPathToPeer2,
							peerLayerChild.getBase(),
							parentLayer,
							MacroGeneralLayerType.createForVariableChild(
									peerLayerChild.getBase(),childPathToPeer2, peerLayerChild.getReferencingVariable(), this.environment_),//,pathToVariableDefinition),
							peerLayerChild.getReferencingVariable(),
							fileEnvironment
							);
		
			SLayer childLayer = parentBridgeForChild.getChildLayer();
			//TODO : just guessing on this one...
			//childLayer.buildHorizontalPathToPeerLayer(peerLayerChild.getBase(), childPathToPeer);

			return new VariableChild(name, childLayer, peerLayerChild.getReferencingVariable(), fileEnvironment, pathToVariableDefinition);
		}
	}

}
