package org.ffd2.skeletonx.compile.java.layer;

import org.ffd2.skeletonx.compile.impl.FileEnvironment;
import org.ffd2.skeletonx.compile.java.IRecordVariable;
import org.ffd2.skeletonx.compile.java.LinkupTracker;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.skeletonx.skeleton.BaseTrackers.JavaVariablePath;
import org.ffd2.solar.exceptions.ParsingException;
import org.ffd2.solar.general.Debug;

public final class RedirectedChildSLayerMaker implements NonFoundationChildSLayerMaker {
	private final SLayer	baseLayer_;
	private final IRecordVariable	referencingVariableMayBeNull_;
	private final JavaVariablePath	pathToParallelAncestor_;

	public RedirectedChildSLayerMaker(SLayer baseLayer,IRecordVariable	referencingVariableMayBeNull,JavaVariablePath pathToLocalRef) {
		this.baseLayer_ = baseLayer;
		this.referencingVariableMayBeNull_ = referencingVariableMayBeNull;
		this.pathToParallelAncestor_ = pathToLocalRef;
		
	}
//	public static final RedirectedChildSLayerMaker createForNodeLayer(SLayer baseLayer) {
//		return new RedirectedChildSLayerMaker(baseLayer, null);
//	}
//	public RedirectedChildSLayerMaker(VariableChild child) {
//		this(child.getBase(),child.getReferencingVariable());
//	}
//	public RedirectedChildSLayerMaker(NodeLayerChild child) {
//		this(child.getBase(),null);
//	}
	
//	public VariableChild createNewVariableLayerChild(String name, SLayer parentLayer, LayerType parentLayerType, FileEnvironment fileEnvironment)
//			throws ParsingException {
//		
//		final BaseTrackers.JavaVariablePath pathToVariableDefinition = new BaseTrackers.JavaVariablePath();
//		IRecordVariable resolvedVariable = parentLayer.getBuilderVariableQuiet(name, pathToVariableDefinition,true);
//		
//		if(resolvedVariable==null) {
//			throw ParsingException.createObjectNotFound("skeleton variable", napublic static final RedirectedChildSLayerMaker createForNodeLayer(SLayer baseLayer) {
//return new RedirectedChildSLayerMaker(baseLayer, null);
//}me);
//		} else {
//			return createNewVariableLayerChild(name, resolvedVariable, pathToVariableDefinition, parentLayer, parentLayerType, fileEnvironment);
//		}
//	}
	public VariableChild createNewVariableLayerChild(
			String name, IRecordVariable resolvedVariable, BaseTrackers.JavaVariablePath pathToVariableDefinition,
			SLayer parentLayer, LayerType parentLayerType, FileEnvironment fileEnvironment, int lineNumber) throws ParsingException {			
	//This needs fiddling around.
		// The problem is the path to the variable. Very confusing.	
		
		BaseTrackers.JavaVariablePath pathStore = new BaseTrackers.JavaVariablePath();
		SLayer nextLayer = resolvedVariable.getAsFoundataionNodeReferenceVariable(pathStore);
		pathStore.transferTo(pathToVariableDefinition);
		DualIndirectLayerType parentBridgeForChild = 
				DualIndirectLayerType.buildVariableBased(pathToVariableDefinition,nextLayer,parentLayer,new RedirectedChildSLayerMaker(nextLayer,resolvedVariable,pathToVariableDefinition),resolvedVariable,fileEnvironment);
		SLayer childLayer = parentBridgeForChild.getChildLayer();
		return new VariableChild(name, childLayer, resolvedVariable, fileEnvironment,pathToVariableDefinition);
	}
	private final BaseTrackers.JavaVariablePath createBasePathToDefinition() {
//		BaseTrackers.JavaVariablePath pathToVariableDefinition = new BaseTrackers.JavaVariablePath();
//		return pathToVariableDefinition;
		return this.pathToParallelAncestor_.getCopy();
	}
	static int counter_ = 0;
	public VariableChild createNewVariableLayerChildNonLocal(String name, SLayer parentLayer, LayerType parentLayerType, FileEnvironment fileEnvironment, int lineNumber)
		throws ParsingException {
	//	BaseTrackers.JavaVariablePath pathToVariableDefinition = createBasePathToDefinition();
		BaseTrackers.JavaVariablePath pathToCurrentPeer =new BaseTrackers.JavaVariablePath();// createBasePathToDefinition();
		pathToParallelAncestor_.transferTo(pathToCurrentPeer);
		//parentLayer.buildHorizontalPathToPeerLayerViaSkeleton(this.baseLayer_, pathToVariableDefinition);
		int debugCount = counter_++;
		try {	
			VariableChild nextLayer = baseLayer_.getVariableChildNode(name,lineNumber);
			//Doesn't work yet...
			if(nextLayer.getReferencingVariable()==this.referencingVariableMayBeNull_) {
				throw ParsingException.createInvalidVariable(name, "referencing self");
			}
			BaseTrackers.JavaVariablePath pathToVariableIncludingVariableDefinition = nextLayer.getPathToVariableInBase().getCopy();

			DualIndirectLayerType parentBridgeForChild = 
					DualIndirectLayerType.buildVariableBased(pathToCurrentPeer,nextLayer.getBase(),parentLayer,new RedirectedChildSLayerMaker(nextLayer.getBase(),null,pathToCurrentPeer),nextLayer.getReferencingVariable(),fileEnvironment);
			SLayer childLayer = parentBridgeForChild.getChildLayer();
			//This is not right if the parent is not a peer one, but then again - why would this be a redirected child layer maker?
			//parentLayer.getBlockSkeleton().getPeerConnection().addPathToPeer(pathToCurrentPeer);
		//	if(pathToCurrentPeer.isEmpty()) {
			//	Thread.dumpStack();
			//}
			return new VariableChild(name, childLayer,nextLayer.getReferencingVariable(), fileEnvironment,pathToVariableIncludingVariableDefinition);
		} catch(ParsingException e) {
			pathToCurrentPeer.clear();
			IRecordVariable resolvedVariable = parentLayer.getBuilderVariableQuiet(name, pathToCurrentPeer,true);
			
			if(resolvedVariable==null) {
				throw ParsingException.createObjectNotFound("skeleton variable", name);
			} else {
				if(resolvedVariable==this.referencingVariableMayBeNull_) {
					throw ParsingException.createInvalidVariable(name, "referencing self");
				}
				return createNewVariableLayerChild(name, resolvedVariable, pathToCurrentPeer, parentLayer, parentLayerType, fileEnvironment, lineNumber);
			}
		}
		
	}
	
	public NodeLayerChild createNewNodeLayerChild(String name, ImplementationBlockSkeletonManager blockSkeleton, LinkupTracker	relatedTracker, SLayer parentLayer, LayerType parentLayerType, FileEnvironment fileEnvironment, int lineNumber) throws ParsingException {
		BaseTrackers.JavaVariablePath pathToLocalRef = new BaseTrackers.JavaVariablePath();
		LocalChild childRef;
		NodeLayerChild createdRecord;
		pathToParallelAncestor_.transferTo(pathToLocalRef);
		
//		pathToLocalRef.addLocalGlobalPeer(childRef.getIsLocalSkeleton());

		try {

		//	BaseTrackers.JavaVariablePath path =new BaseTrackers.JavaVariablePath();// createBasePathToDefinition();
			//parentLayer.buildHorizontalPathToPeerLayerViaSkeleton(this.baseLayer_, path);
		
			BaseTrackers.JavaVariablePath pathToPeer = new BaseTrackers.JavaVariablePath();

			NodeLayerChild nextSideLayer = this.baseLayer_.getNodeLayerChild(name,lineNumber);

			childRef = blockSkeleton.createLocalChild(name, parentLayer,new RedirectedChildSLayerMaker(nextSideLayer.getBase(),null,pathToPeer), relatedTracker, nextSideLayer.getBase(),pathToLocalRef);
			pathToPeer.addLocalGlobalPeer(childRef.getIsLocalSkeleton());

			SLayer childLayer = childRef.getChildLayer();
		  createdRecord = NodeLayerChild.createLocalChild(name, childLayer,childRef);
		  
		} catch(ParsingException e)  {
			BaseTrackers.JavaVariablePath path =new BaseTrackers.JavaVariablePath();// createBasePathToDefinition();
			AncestorConnection ancestor = parentLayerType.getAncestorFoundationNodeQuiet(name, path,true);
			if(ancestor==null) {
				throw ParsingException.createObjectNotFound("node child", name);
			} else {		

				childRef = blockSkeleton.createLocalChild(name, parentLayer,new RedirectedChildSLayerMaker(parentLayer,null,pathToLocalRef), relatedTracker, ancestor);//,path);
				SLayer childLayer = childRef.getChildLayer();
				createdRecord = NodeLayerChild.createLocalChild(name, childLayer,childRef);
			}	
			
		}
		return createdRecord;
	}
}