package org.ffd2.skeletonx.compile.java.layer;

import org.ffd2.skeletonx.compile.java.ScopeContainer;
import org.ffd2.skeletonx.compile.java.TargetVariable;
import org.ffd2.solar.exceptions.ItemAlreadyExistsException;
import org.ffd2.solar.general.Debug;

public class SLocalVariableHolder {
  private final TargetVariable variable_;
  private SLocalVariableHolder next_ = null;
  private final ScopeContainer relatedScope_;
  public SLocalVariableHolder(ScopeContainer relatedScope, TargetVariable variable) {
    this.relatedScope_ = relatedScope;
    this.variable_ = variable;
  }
  public boolean isContains(CodeBlockContainer queryRelatedCodeBlock) {
    if(this.relatedScope_.getRelatedCodeBlockContainer() == queryRelatedCodeBlock) {
      return true;
    } else if(next_==null) {
      return false;
    } else {
      return next_.isContains(queryRelatedCodeBlock);
    }
  }
  public boolean isContainsVariableInScope(ScopeContainer queryScope) {
    if(queryScope.isThisScopeChildOfTheQuery(this.relatedScope_)) {
      return true;
    } else if(next_==null) {
      return false;
    } else {
      return next_.isContainsVariableInScope(queryScope);
    }
  }
  public void addVariableInScope(String variableName,ScopeContainer scope,TargetVariable variable) throws ItemAlreadyExistsException {
    
  	if(scope.isThisScopeChildOfTheQuery(this.relatedScope_)) {
  		Debug.println("Problem scope:",this,", new variable scope:",scope);
      throw new ItemAlreadyExistsException();
    } else if(next_==null) {
      this.next_ = new SLocalVariableHolder(scope, variable);
    } else {
      next_.addVariableInScope(variableName,scope,variable);
    }
  }
  public TargetVariable getVariable(ScopeContainer callerScope) {
//  	Debug.println("R2C:",this.relatedScope_.isThisScopeChildOfTheQuery(callerScope));
//  	Debug.println("C2R:",callerScope.isThisScopeChildOfTheQuery(this.relatedScope_));

    if(callerScope.isThisScopeChildOfTheQuery(this.relatedScope_)) {
      return this.variable_;
    } else if(next_==null) {
      return null;
    } else {
      return next_.getVariable(callerScope);
    }
  }
}

