package org.ffd2.skeletonx.compile.java.layer;

import org.ffd2.skeletonx.compile.impl.KeyDefinitionBlock;
import org.ffd2.skeletonx.compile.impl.MappingDefinitionBlock;
import org.ffd2.skeletonx.compile.java.CodeBlockEnvironment;
import org.ffd2.skeletonx.compile.java.IRecordTypeTarget;
import org.ffd2.skeletonx.compile.java.IRecordVariable;
import org.ffd2.skeletonx.compile.java.IVariableType;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.skeletonx.skeleton.BaseTrackers.JavaVariablePath;
import org.ffd2.skeletonx.skeleton.BasicCallChainFormHolder.BasicCallChainFormBlock;
import org.ffd2.skeletonx.skeleton.ExpressionDetailsFormHolder.ExpressionDetailsFormBlock;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock;
import org.ffd2.skeletonx.skeleton.NameDetailsFormHolder.NameDetailsFormBlock;
import org.ffd2.solar.exceptions.ParsingException;

public final class TypicalBuilderIVariable implements IRecordVariable {
	private final String	variableName_;
	private final BuilderVariableType	type_;

	public TypicalBuilderIVariable(String variableName,BuilderVariableType type ) {
		this.variableName_ = variableName;
		this.type_ = type;
	}
	
	// ==========================================================================
	public String toString() {
		return "(Type="+type_+"m name="+variableName_+")";
	}
	@Override public boolean isMatchesVariableName(String queryVariableName) {
		return this.variableName_.equals(queryVariableName);
	}
	public void addAsGeneralExpressionTargetRequirement(MacroCallDataBlock macroCallBlock, JavaVariablePath variablePath) throws ParsingException {
		throw ParsingException.createGeneralSemantic("variable cannot supply general expression target");
	}
	public String getRoughVariableName() { return this.variableName_; }
	
	
	@Override public void getAsReference(IRecordTypeTarget target) {
  	type_.getAsReference(target);
  }

  @Override public void addAsMacroRecordMappingParameter( MacroCallDataBlock macroCallBlock, JavaVariablePath variablePath, MappingDefinitionBlock type) throws ParsingException {
  	this.type_.addAsMacroRecordMappingParameter(macroCallBlock, variablePath, type);
	}
	@Override public void addAsMacroRecordKeyParameter(MacroCallDataBlock macroCallBlock,
			JavaVariablePath variablePath, KeyDefinitionBlock type)
			throws ParsingException {
  	this.type_.addAsMacroRecordKeyParameter(macroCallBlock, variablePath, type);		
	}

	
	@Override public SLayer getAsFoundataionNodeReferenceVariable(BaseTrackers.JavaVariablePath pathToExtend) throws ParsingException{
  //	this.variableAccess_.addToPath(pathToExtend);
		return type_.getAsFoundataionNodeReferenceVariableForType(pathToExtend);
  }
	// ------------------------------------------------------------------------
	// IRecordVariable stuff
	
  @Override public void updateNameBlock(NameDetailsFormBlock.ComplexDataBlock target, JavaVariablePath variablePath, NameBlockDetails elementDetails) throws ParsingException {
		this.type_.updateNameBlock(target, variablePath, elementDetails);
	}
  
  @Override public void updateExpressionFinal(CodeBlockEnvironment environment, ExpressionDetailsFormBlock expressionSkeleton, JavaVariablePath variablePath) throws ParsingException {
		this.type_.updateExpressionFinal(environment,expressionSkeleton, variablePath);
	}
	
  @Override public void updateCallChainFinal(BasicCallChainFormBlock target, JavaVariablePath variablePathToThisVariable) throws ParsingException {
		this.type_.updateCallChainFinal(target, variablePathToThisVariable);
	}
  
  @Override
	public void addAsMacroRecordParameter(MacroCallDataBlock macroCallBlock, JavaVariablePath variablePath, IVariableType requestedType) throws ParsingException {
  	this.type_.addAsMacroRecordParameter(macroCallBlock, variablePath, requestedType);
	}

	

	
	
}