package org.ffd2.skeletonx.compile.java.layer;

//NO LONGER USED!

import org.ffd2.skeletonx.compile.impl.ChainDefinitionBlock;
import org.ffd2.skeletonx.compile.java.GlobalClassReference;
import org.ffd2.skeletonx.compile.java.GlobalMethodReference;
import org.ffd2.skeletonx.compile.java.IRecordVariable;
import org.ffd2.skeletonx.compile.java.ScopeContainer;
import org.ffd2.skeletonx.compile.java.TargetMethod;
import org.ffd2.skeletonx.compile.java.TargetType;
import org.ffd2.skeletonx.compile.java.TargetVariable;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.skeletonx.skeleton.BaseTrackers.JavaVariablePath;
import org.ffd2.solar.exceptions.ParsingException;

/**
 * Handles the case of the VariableBased layer, and the "Local" Node child (a node child outside of the Foundation Layers)
 * 
 * Notes:...
 * A variable layer sits within the Skeleton Block of the parent layer, so we don't have to add anything to variable paths when we go up a layer,
 * only when we get stuff from the Foundation Layers that the associated variable points to.
 * @author Matthew Goode
 *
 * @note THIS ISN"T USED? REPLACED BY DualIndirectLayerType (option)
 */
public abstract class VariableBasedLayerParentBridge implements LayerType {
	private final JavaVariablePath	pathToVariableDef_;
	private final FoundationNode	relatedFoundationNode_;
	private final SLayer	parentLayer_;
	private final SLayer	childLayer_;
	/**
	 * Variable based layers share the space of their parent layers, but any references to things in their target scaffolds 
	 * must go through a variable chain
	 * @param pathToVariableDef the chain to the variable that this Variable is connected too
	 */
	public VariableBasedLayerParentBridge(SLayer childLayer,BaseTrackers.JavaVariablePath pathToVariableDef, FoundationNode relatedFoundationNode, SLayer parentLayer) {
		this.childLayer_ = childLayer;
		this.pathToVariableDef_ = pathToVariableDef;
		this.relatedFoundationNode_ = relatedFoundationNode;
		this.parentLayer_ = parentLayer;
	}
	public FoundationNode getRootFoundationNodeBasic() { return parentLayer_.getRootFoundationNodeBasic(); }

	// -----------------------------
	public void buildPathToUpperLayerBack(SLayer ancestor, JavaVariablePath path) {
		this.parentLayer_.buildPathToUpperLayer(ancestor, path);

	}
	public boolean buildPathToFoundationNode(FoundationNode target, BaseTrackers.JavaVariablePath path) {
	 return parentLayer_.buildPathToFoundationNode(target, path);
	}
	public boolean buildPathToPeerLayer(SLayer target, BaseTrackers.JavaVariablePath path) {
	  return parentLayer_.buildPathToPeerLayer(target, path);

	}
	public void addPathElementsToFoundationNodePeer(JavaVariablePath pathStore) {
		//Just add the variable chain to the Foundation Layer
		this.pathToVariableDef_.transferTo(pathStore);		
	}
	public ChainDefinitionBlock getChainDefinition(String name) throws ParsingException {
  	return parentLayer_.getChainDefinition(name);
  }
	public IRecordVariable getBuilderVariableQuiet(String name, JavaVariablePath pathToVariable, boolean isFirstLayer) {
		
		//Now we have two options
		// (1) check back along the Foundation nodes of the Scaffold heirarchy of the base layer variable 
		// (2) check back along the implementation layers. 
		
		// If the variable is "local", or that it exists in the related foundation, then we only need to append the chain
		// to the layer variable's reference
		// That is if $a is an A and A(C c) , and we are in @link $a { }, then $c will be resolved to aRef_.cVarRef_
		final int pathMark = pathToVariable.mark();
		
		this.pathToVariableDef_.transferTo(pathToVariable);
		//Try via the FoundationNode tree first
	
		IRecordVariable local =this.relatedFoundationNode_.getBuilderParameterQuiet(name,pathToVariable,isFirstLayer) ;

	  //(if first layer, we check all the way back on the Foundation Heirarchy first, otherwise, just the variables or the locally defined node 
		if(local!=null ) {
			return local;
		} else {
			//Clear path, and try again
			
			pathToVariable.unmark(pathMark);

			//We don't add any links as the layer sits within the Skeleton "space" as its parent
			return this.parentLayer_.getBuilderVariableQuiet(name, pathToVariable,false);
		}
	}
	
	public boolean buildPathToType(TargetType type, JavaVariablePath pathStore,boolean isFirstLayer) {
		final int pathMark = pathStore.mark();
		
		this.pathToVariableDef_.transferTo(pathStore);
		//Try via the FoundationNode tree first
	
		boolean foundType =  this.relatedFoundationNode_.buildPathToType(type, pathStore, isFirstLayer) ;
		if(foundType) {
			return true;
		}
		pathStore.unmark(pathMark);
	  //(if first layer, we check all the way back on the Foundation Heirarchy first, otherwise, just the variables or the locally defined node 

		//We don't add any links as the layer sits within the Skeleton "space" as its parent
		return this.parentLayer_.buildPathToType(type, pathStore,false);
	}


	public TargetVariable getTargetVariableQuiet(boolean allowLocalVariables, TargetType outputClass, String variableName, JavaVariablePath pathToDeclaration, boolean isFirstLayer) {
		if(isFirstLayer) {
			final int pathMark = pathToDeclaration.mark();
			this.pathToVariableDef_.transferTo(pathToDeclaration);
			TargetVariable result =	this.relatedFoundationNode_.getRelatedLayerForLayerComponents().getTargetVariableQuiet(allowLocalVariables,outputClass,variableName, pathToDeclaration, isFirstLayer);
			if(result!=null) {
				return result;
			}
			pathToDeclaration.unmark(pathMark);
		}
		return parentLayer_.getTargetVariableQuiet( allowLocalVariables,outputClass,variableName, pathToDeclaration, false);
	}

	public TargetMethod getTargetMethodQuiet(TargetType outputClass, String name, JavaVariablePath pathToDeclaration, boolean isFirstLayer) {
		if(isFirstLayer) {
			final int pathMark = pathToDeclaration.mark();
			this.pathToVariableDef_.transferTo(pathToDeclaration);
			TargetMethod result =	this.relatedFoundationNode_.getRelatedLayerForLayerComponents().getTargetMethodQuiet(outputClass,name, pathToDeclaration, isFirstLayer);
			if(result!=null) {
				return result;
			}
			pathToDeclaration.unmark(pathMark);
		}
		return parentLayer_.getTargetMethodQuiet( outputClass,name, pathToDeclaration, false);
	}

	public TargetType getTargetTypeQuiet(String typeName, JavaVariablePath pathToDeclaration, boolean isFirstLayer) {
		if(isFirstLayer) {
			final int pathMark = pathToDeclaration.mark();
			this.pathToVariableDef_.transferTo(pathToDeclaration);
			TargetType result =	this.relatedFoundationNode_.getRelatedLayerForLayerComponents().getTargetTypeQuiet(typeName, pathToDeclaration, isFirstLayer);
			if(result!=null) {
				return result;
			}
			pathToDeclaration.unmark(pathMark);
		}
		return parentLayer_.getTargetTypeQuiet( typeName, pathToDeclaration, false);
	}


	public GlobalClassReference getGlobalClassReferenceQuiet(String className, JavaVariablePath pathToDeclaration, boolean isFirstLayer) {
		if(isFirstLayer) {
			final int pathMark = pathToDeclaration.mark();
			this.pathToVariableDef_.transferTo(pathToDeclaration);
			GlobalClassReference result =	this.relatedFoundationNode_.getRelatedLayerForLayerComponents().getGlobalClassReferenceQuiet(className, pathToDeclaration, isFirstLayer);
			if(result!=null) {
				return result;
			}
			pathToDeclaration.unmark(pathMark);
		}
		return parentLayer_.getGlobalClassReferenceQuiet( className, pathToDeclaration, false);
	}

	public GlobalMethodReference getGlobalMethodReferenceQuiet( GlobalClassReference baseClass, String methodName, JavaVariablePath pathToDeclaration, boolean isFirstLayer) {
		if(isFirstLayer) {
			final int pathMark = pathToDeclaration.mark();
			this.pathToVariableDef_.transferTo(pathToDeclaration);
			GlobalMethodReference result =	this.relatedFoundationNode_.getRelatedLayerForLayerComponents().getGlobalMethodReferenceQuiet(baseClass, methodName, pathToDeclaration, isFirstLayer);
			if(result!=null) {
				return result;
			}
			pathToDeclaration.unmark(pathMark);
		}
		return parentLayer_.getGlobalMethodReferenceQuiet(baseClass, methodName, pathToDeclaration, false);
	}

	//Last finished 20/01/11
	@Override
	public TargetVariable getLocalVariableQuiet(ScopeContainer relatedScope, String variableName, JavaVariablePath pathToDeclaration, boolean isFirstLayer) {
		if(isFirstLayer) {
			final int pathMark = pathToDeclaration.mark();
			this.pathToVariableDef_.transferTo(pathToDeclaration);
			TargetVariable result =	this.relatedFoundationNode_.getRelatedLayerForLayerComponents().getLocalVariableQuiet(relatedScope, variableName, pathToDeclaration, isFirstLayer);
			if(result!=null) {
				return result;
			}
			pathToDeclaration.unmark(pathMark);
		}
		return parentLayer_.getLocalVariableQuiet(relatedScope, variableName, pathToDeclaration, false);
	}
	
	//Last finished 20/01/11
	@Override
	public boolean isLocalVariableQuiet(ScopeContainer relatedScope, String variableName, boolean isFirstLayer) {
		if(isFirstLayer) {
			if(this.relatedFoundationNode_.getRelatedLayerForLayerComponents().isLocalTargetVariableQuiet(relatedScope, variableName, isFirstLayer)) {
				return true;
			}
		}
		return parentLayer_.isLocalTargetVariableQuiet(relatedScope, variableName, false);
	}
	
	//Last finished 20/01/11
	@Override
	public AncestorConnection getAncestorFoundationNodeQuiet( String foundationNodeName, JavaVariablePath pathToAncestorNodeParent, boolean isFirstLayer) {
		final int pathMark = pathToAncestorNodeParent.mark();
		this.pathToVariableDef_.transferTo(pathToAncestorNodeParent);
		AncestorConnection result = this.relatedFoundationNode_.getAncestorConnectionQuiet(foundationNodeName, pathToAncestorNodeParent, isFirstLayer);
		if(result!=null) {
			return result;
		}
		pathToAncestorNodeParent.unmark(pathMark);
		return this.parentLayer_.getAncestorFoundationNodeQuiet(foundationNodeName, pathToAncestorNodeParent, false);
	}

	
	
}
