package org.ffd2.skeletonx.austenx.packrat.impl;
import org.ffd2.skeletonx.austenx.peg.base.*;
public final class AllDecodersSkeleton {
	public static final class ImportDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ImportPatternPeer peer_;
		public ImportDecoder(ImportPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 1) {
				peer_.addDoOutput();
			}
			if(index == 3) {
				peer_.addFileName(token.getStringValue());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					PackagePathElementPeer.NormalPatternPeer child = peer_.addOptionNormalOfPackagePathElementForPathElement();
					if(child != null) {
						element.updateConstruction(new AllDecodersSkeleton.NormalDecoder(child));
						child.end();
					}
				}
			}
		}
	}
	public static final class FileDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final FilePatternPeer peer_;
		public FileDecoder(FilePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
				org.ffd2.austenx.runtime.BaseToken namespaceToken = element.getBaseArgumentToken(2);
				ImportPatternPeer child = peer_.addImportForImports(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), namespaceToken.getStringValue());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.ImportDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				int type = element.getType();
				if(type == 0) {
					PackagePathElementPeer.NormalPatternPeer child_1 = peer_.addOptionNormalOfPackagePathElementForOutputElement();
					if(child_1 != null) {
						element.updateConstruction(new AllDecodersSkeleton.NormalDecoder(child_1));
						child_1.end();
					}
				}
			}
			if(index == 2) {
				org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
				org.ffd2.austenx.runtime.BaseToken formNameToken = element.getBaseArgumentToken(1);
				DesignBlockPatternPeer child_2 = peer_.addDesignBlockForDesignBlock(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber(), formNameToken.getStringValue());
				if(child_2 != null) {
					element.updateConstruction(new AllDecodersSkeleton.DesignBlockDecoder(child_2));
					child_2.end();
				}
			}
			if(index == 3) {
				org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
				org.ffd2.austenx.runtime.BaseToken javaNameToken = element.getBaseArgumentToken(1);
				JavaImplementatonBlockPatternPeer child_3 = peer_.addJavaImplementatonBlockForJavaBlock(keywordToken_2.getStringValue(), keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber(), javaNameToken.getStringValue());
				if(child_3 != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaImplementatonBlockDecoder(child_3));
					child_3.end();
				}
			}
			if(index == 4) {
				org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
				org.ffd2.austenx.runtime.BaseToken javaNameToken_1 = element.getBaseArgumentToken(1);
				JavaExternalBlockPatternPeer child_4 = peer_.addJavaExternalBlockForJavaExternalBlock(keywordToken_3.getStringValue(), keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber(), javaNameToken_1.getStringValue());
				if(child_4 != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaExternalBlockDecoder(child_4));
					child_4.end();
				}
			}
		}
	}
	public static final class NormalDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final PackagePathElementPeer.NormalPatternPeer peer_;
		public NormalDecoder(PackagePathElementPeer.NormalPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addComponent(token.getStringValue());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
		}
	}
	public static final class DesignBlockDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final DesignBlockPatternPeer peer_;
		public DesignBlockDecoder(DesignBlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				ParameterBlockPatternPeer child = peer_.addParameterBlockForParameters();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.ParameterBlockDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				int type = element.getType();
				if(type == 0) {
					org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
					BlockElementPeer.FixedPatternPeer child_1 = peer_.addOptionFixedOfBlockElementForElement(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
					if(child_1 != null) {
						element.updateConstruction(new AllDecodersSkeleton.FixedDecoder(child_1));
						child_1.end();
					}
				}
				if(type == 1) {
					org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken chainNameToken = element.getBaseArgumentToken(1);
					BlockElementPeer.ChainPatternPeer child_2 = peer_.addOptionChainOfBlockElementForElement(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), chainNameToken.getStringValue());
					if(child_2 != null) {
						element.updateConstruction(new AllDecodersSkeleton.ChainDecoder(child_2));
						child_2.end();
					}
				}
				if(type == 2) {
					org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(1);
					org.ffd2.austenx.runtime.BaseToken keyNameToken = element.getBaseArgumentToken(2);
					org.ffd2.austenx.runtime.BaseToken targetToken = element.getBaseArgumentToken(3);
					peer_.addOptionMappingOfBlockElementForElement(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber(), nameToken_1.getStringValue(), keyNameToken.getStringValue(), targetToken.getStringValue());
				}
				if(type == 3) {
					org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken nameToken_2 = element.getBaseArgumentToken(1);
					peer_.addOptionKeyOfBlockElementForElement(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber(), nameToken_2.getStringValue());
				}
				if(type == 4) {
					org.ffd2.austenx.runtime.BaseToken nameToken_3 = element.getBaseArgumentToken(0);
					BlockElementPeer.TemplatePatternPeer child_3 = peer_.addOptionTemplateOfBlockElementForElement(nameToken_3.getStringValue(), nameToken_3.getLineNumber(), nameToken_3.getCharacterNumber());
					if(child_3 != null) {
						element.updateConstruction(new AllDecodersSkeleton.TemplateDecoder(child_3));
						child_3.end();
					}
				}
				if(type == 5) {
					org.ffd2.austenx.runtime.BaseToken blockNameToken = element.getBaseArgumentToken(1);
					BlockElementPeer.BlockPatternPeer child_4 = peer_.addOptionBlockOfBlockElementForElement(blockNameToken.getStringValue(), blockNameToken.getLineNumber(), blockNameToken.getCharacterNumber());
					if(child_4 != null) {
						element.updateConstruction(new AllDecodersSkeleton.BlockDecoder(child_4));
						child_4.end();
					}
				}
			}
		}
	}
	public static final class FixedArgValueDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final FixedArgValuePatternPeer peer_;
		public FixedArgValueDecoder(FixedArgValuePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					DesignExpressionPeer.Indirect indirect = peer_.getDesignExpressionForValue();
					if(indirect != null) {
						DesignExpressionPeer.PrimitivePatternPeer child = indirect.createPrimitive();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					DesignExpressionPeer.Indirect indirect_1 = peer_.getDesignExpressionForValue();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken = element.getBaseArgumentToken(0);
						indirect_1.createVariable(variableNameToken.getStringValue(), variableNameToken.getLineNumber(), variableNameToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class PrimitiveDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final DesignExpressionPeer.PrimitivePatternPeer peer_;
		public PrimitiveDecoder(DesignExpressionPeer.PrimitivePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addCharValue(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
			if(index == 1) {
				peer_.addString(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
			if(index == 2) {
				peer_.addInteger(token.getIntValue(), token.getLineNumber(), token.getCharacterNumber());
			}
			if(index == 3) {
				peer_.addBooleanValue(token.getBooleanValue(), token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
		}
	}
	public static final class FixedDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final BlockElementPeer.FixedPatternPeer peer_;
		public FixedDecoder(BlockElementPeer.FixedPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 1) {
				peer_.addTypeElement(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken variableNameToken = element.getBaseArgumentToken(0);
				FixedArgValuePatternPeer child = peer_.addFixedArgValueForValue(variableNameToken.getStringValue(), variableNameToken.getLineNumber(), variableNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.FixedArgValueDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class ChainDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final BlockElementPeer.ChainPatternPeer peer_;
		public ChainDecoder(BlockElementPeer.ChainPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
				ChainElementPatternPeer child = peer_.addChainElementForElement(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.ChainElementDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class TemplateDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final BlockElementPeer.TemplatePatternPeer peer_;
		public TemplateDecoder(BlockElementPeer.TemplatePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					org.ffd2.austenx.runtime.BaseToken blockNameToken = element.getBaseArgumentToken(0);
					TemplateElementPeer.ChildPatternPeer child = peer_.addOptionChildOfTemplateElementForElement(blockNameToken.getStringValue(), blockNameToken.getLineNumber(), blockNameToken.getCharacterNumber());
					if(child != null) {
						element.updateConstruction(new AllDecodersSkeleton.ChildDecoder(child));
						child.end();
					}
				}
			}
		}
	}
	public static final class BlockDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final BlockElementPeer.BlockPatternPeer peer_;
		public BlockDecoder(BlockElementPeer.BlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addDependent(token.getLineNumber(), token.getCharacterNumber());
			}
			if(index == 2) {
				peer_.addMaybeMarker();
			}
			if(index == 3) {
				peer_.addOneOrMoreMarker();
			}
			if(index == 4) {
				peer_.addTemplateExtension(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				ParameterBlockPatternPeer child = peer_.addParameterBlockForParameters();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.ParameterBlockDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				int type = element.getType();
				if(type == 0) {
					org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
					BlockElementPeer.FixedPatternPeer child_1 = peer_.addOptionFixedOfBlockElementForElement(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
					if(child_1 != null) {
						element.updateConstruction(new AllDecodersSkeleton.FixedDecoder(child_1));
						child_1.end();
					}
				}
				if(type == 1) {
					org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken chainNameToken = element.getBaseArgumentToken(1);
					BlockElementPeer.ChainPatternPeer child_2 = peer_.addOptionChainOfBlockElementForElement(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), chainNameToken.getStringValue());
					if(child_2 != null) {
						element.updateConstruction(new AllDecodersSkeleton.ChainDecoder(child_2));
						child_2.end();
					}
				}
				if(type == 2) {
					org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(1);
					org.ffd2.austenx.runtime.BaseToken keyNameToken = element.getBaseArgumentToken(2);
					org.ffd2.austenx.runtime.BaseToken targetToken = element.getBaseArgumentToken(3);
					peer_.addOptionMappingOfBlockElementForElement(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber(), nameToken_1.getStringValue(), keyNameToken.getStringValue(), targetToken.getStringValue());
				}
				if(type == 3) {
					org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken nameToken_2 = element.getBaseArgumentToken(1);
					peer_.addOptionKeyOfBlockElementForElement(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber(), nameToken_2.getStringValue());
				}
				if(type == 4) {
					org.ffd2.austenx.runtime.BaseToken nameToken_3 = element.getBaseArgumentToken(0);
					BlockElementPeer.TemplatePatternPeer child_3 = peer_.addOptionTemplateOfBlockElementForElement(nameToken_3.getStringValue(), nameToken_3.getLineNumber(), nameToken_3.getCharacterNumber());
					if(child_3 != null) {
						element.updateConstruction(new AllDecodersSkeleton.TemplateDecoder(child_3));
						child_3.end();
					}
				}
				if(type == 5) {
					org.ffd2.austenx.runtime.BaseToken blockNameToken = element.getBaseArgumentToken(1);
					BlockElementPeer.BlockPatternPeer child_4 = peer_.addOptionBlockOfBlockElementForElement(blockNameToken.getStringValue(), blockNameToken.getLineNumber(), blockNameToken.getCharacterNumber());
					if(child_4 != null) {
						element.updateConstruction(new AllDecodersSkeleton.BlockDecoder(child_4));
						child_4.end();
					}
				}
			}
		}
	}
	public static final class ChildDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final TemplateElementPeer.ChildPatternPeer peer_;
		public ChildDecoder(TemplateElementPeer.ChildPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				ParameterBlockPatternPeer child = peer_.addParameterBlockForParameters();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.ParameterBlockDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				int type = element.getType();
				if(type == 0) {
					org.ffd2.austenx.runtime.BaseToken blockNameToken = element.getBaseArgumentToken(0);
					TemplateElementPeer.ChildPatternPeer child_1 = peer_.addOptionChildOfTemplateElementForElement(blockNameToken.getStringValue(), blockNameToken.getLineNumber(), blockNameToken.getCharacterNumber());
					if(child_1 != null) {
						element.updateConstruction(new AllDecodersSkeleton.ChildDecoder(child_1));
						child_1.end();
					}
				}
			}
		}
	}
	public static final class ChainElementDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ChainElementPatternPeer peer_;
		public ChainElementDecoder(ChainElementPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				DesignTypePatternPeer child = peer_.addDesignTypeForType();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.DesignTypeDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class DesignTypeDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final DesignTypePatternPeer peer_;
		public DesignTypeDecoder(DesignTypePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addTypeElement(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
		}
	}
	public static final class JavaExternalBlockDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaExternalBlockPatternPeer peer_;
		public JavaExternalBlockDecoder(JavaExternalBlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					GeneralTypePeer.Indirect indirect = peer_.getGeneralTypeForExternalType();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken namespaceToken = element.getBaseArgumentToken(0);
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(1);
						indirect.createImport(namespaceToken.getStringValue(), nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
					}
				}
				if(type == 1) {
					GeneralTypePeer.Indirect indirect_1 = peer_.getGeneralTypeForExternalType();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(0);
						indirect_1.createDirect(nameToken_1.getStringValue(), nameToken_1.getLineNumber(), nameToken_1.getCharacterNumber());
					}
				}
			}
			if(index == 1) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					org.ffd2.austenx.runtime.BaseToken nameToken_2 = element.getBaseArgumentToken(0);
					JavaExternalElementPeer.NormalPatternPeer child = peer_.addOptionNormalOfJavaExternalElementForElement(nameToken_2.getStringValue(), nameToken_2.getLineNumber(), nameToken_2.getCharacterNumber());
					if(child != null) {
						element.updateConstruction(new AllDecodersSkeleton.NormalDecoder_1(child));
						child.end();
					}
				}
			}
		}
	}
	public static final class NormalDecoder_1 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaExternalElementPeer.NormalPatternPeer peer_;
		public NormalDecoder_1(JavaExternalElementPeer.NormalPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 1) {
				peer_.addExtension(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
			if(index == 2) {
				peer_.addImplementation(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
				GenericsPatternPeer child = peer_.addGenericsForGenerics(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.GenericsDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				int type = element.getType();
				if(type == 0) {
					PackagePathElementPeer.NormalPatternPeer child_1 = peer_.addOptionNormalOfPackagePathElementForPathInfo();
					if(child_1 != null) {
						element.updateConstruction(new AllDecodersSkeleton.NormalDecoder(child_1));
						child_1.end();
					}
				}
			}
			if(index == 2) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					org.ffd2.austenx.runtime.BaseToken typeToken = element.getBaseArgumentToken(1);
					org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(3);
					LabelingSubsPeer.VariableSubPatternPeer child_2 = peer_.addOptionVariableSubOfLabelingSubsForSubs(typeToken.getStringValue(), nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
					if(child_2 != null) {
						element.updateConstruction(new AllDecodersSkeleton.VariableSubDecoder(child_2));
						child_2.end();
					}
				}
				if(type_1 == 1) {
					org.ffd2.austenx.runtime.BaseToken typeToken_1 = element.getBaseArgumentToken(1);
					org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(3);
					LabelingSubsPeer.MethodSubPatternPeer child_3 = peer_.addOptionMethodSubOfLabelingSubsForSubs(typeToken_1.getStringValue(), nameToken_1.getStringValue(), nameToken_1.getLineNumber(), nameToken_1.getCharacterNumber());
					if(child_3 != null) {
						element.updateConstruction(new AllDecodersSkeleton.MethodSubDecoder(child_3));
						child_3.end();
					}
				}
			}
		}
	}
	public static final class VariableSubDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final LabelingSubsPeer.VariableSubPatternPeer peer_;
		public VariableSubDecoder(LabelingSubsPeer.VariableSubPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addIsStatic();
			}
			if(index == 2) {
				peer_.addArrayDimension();
			}
			if(index == 4) {
				peer_.addActual(token.getStringValue());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
		}
	}
	public static final class MethodSubDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final LabelingSubsPeer.MethodSubPatternPeer peer_;
		public MethodSubDecoder(LabelingSubsPeer.MethodSubPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addIsStatic();
			}
			if(index == 2) {
				peer_.addArrayDimension();
			}
			if(index == 4) {
				peer_.addActual(token.getStringValue());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken typeToken = element.getBaseArgumentToken(0);
				org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(2);
				SimpleParameterPatternPeer child = peer_.addSimpleParameterForParameter(typeToken.getStringValue(), typeToken.getLineNumber(), typeToken.getCharacterNumber(), nameToken.getStringValue());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.SimpleParameterDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class GenericsDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final GenericsPatternPeer peer_;
		public GenericsDecoder(GenericsPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 1) {
				peer_.addName(token.getStringValue());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
		}
	}
	public static final class JavaImplementatonBlockDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaImplementatonBlockPatternPeer peer_;
		public JavaImplementatonBlockDecoder(JavaImplementatonBlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				ParameterBlockPatternPeer child = peer_.addParameterBlockForParameters();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.ParameterBlockDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				int type = element.getType();
				if(type == 0) {
					GeneralTypePeer.Indirect indirect = peer_.getGeneralTypeForDesignType();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken namespaceToken = element.getBaseArgumentToken(0);
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(1);
						indirect.createImport(namespaceToken.getStringValue(), nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
					}
				}
				if(type == 1) {
					GeneralTypePeer.Indirect indirect_1 = peer_.getGeneralTypeForDesignType();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(0);
						indirect_1.createDirect(nameToken_1.getStringValue(), nameToken_1.getLineNumber(), nameToken_1.getCharacterNumber());
					}
				}
			}
			if(index == 2) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					GeneralTypePeer.Indirect indirect_2 = peer_.getGeneralTypeForExternalType();
					if(indirect_2 != null) {
						org.ffd2.austenx.runtime.BaseToken namespaceToken_1 = element.getBaseArgumentToken(0);
						org.ffd2.austenx.runtime.BaseToken nameToken_2 = element.getBaseArgumentToken(1);
						indirect_2.createImport(namespaceToken_1.getStringValue(), nameToken_2.getStringValue(), nameToken_2.getLineNumber(), nameToken_2.getCharacterNumber());
					}
				}
				if(type_1 == 1) {
					GeneralTypePeer.Indirect indirect_3 = peer_.getGeneralTypeForExternalType();
					if(indirect_3 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_3 = element.getBaseArgumentToken(0);
						indirect_3.createDirect(nameToken_3.getStringValue(), nameToken_3.getLineNumber(), nameToken_3.getCharacterNumber());
					}
				}
			}
			if(index == 3) {
				int type_2 = element.getType();
				if(type_2 == 0) {
					JavaImplementationElementPeer.Indirect indirect_4 = peer_.getJavaImplementationElementForElement();
					if(indirect_4 != null) {
						JavaImplementationElementPeer.ClassPatternPeer child_1 = indirect_4.createClass();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ClassDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type_2 == 1) {
					JavaImplementationElementPeer.Indirect indirect_5 = peer_.getJavaImplementationElementForElement();
					if(indirect_5 != null) {
						JavaImplementationElementPeer.InterfacePatternPeer child_2 = indirect_5.createInterface();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.InterfaceDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type_2 == 2) {
					JavaImplementationElementPeer.Indirect indirect_6 = peer_.getJavaImplementationElementForElement();
					if(indirect_6 != null) {
						JavaImplementationElementPeer.LinkPatternPeer child_3 = indirect_6.createLink();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type_2 == 3) {
					JavaImplementationElementPeer.Indirect indirect_7 = peer_.getJavaImplementationElementForElement();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken fileNameToken = element.getBaseArgumentToken(0);
						indirect_7.createInclude(fileNameToken.getStringValue(), fileNameToken.getLineNumber(), fileNameToken.getCharacterNumber());
					}
				}
				if(type_2 == 4) {
					JavaImplementationElementPeer.Indirect indirect_8 = peer_.getJavaImplementationElementForElement();
					if(indirect_8 != null) {
						JavaImplementationElementPeer.IfPatternPeer child_4 = indirect_8.createIf();
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.IfDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type_2 == 5) {
					JavaImplementationElementPeer.Indirect indirect_9 = peer_.getJavaImplementationElementForElement();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaImplementationElementPeer.PackageSetPatternPeer child_5 = indirect_9.createPackageSet(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PackageSetDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type_2 == 6) {
					JavaImplementationElementPeer.Indirect indirect_10 = peer_.getJavaImplementationElementForElement();
					if(indirect_10 != null) {
						JavaImplementationElementPeer.MacroDefPatternPeer child_6 = indirect_10.createMacroDef();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroDefDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type_2 == 7) {
					JavaImplementationElementPeer.Indirect indirect_11 = peer_.getJavaImplementationElementForElement();
					if(indirect_11 != null) {
						JavaImplementationElementPeer.MacroCallPatternPeer child_7 = indirect_11.createMacroCall();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroCallDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type_2 == 8) {
					JavaImplementationElementPeer.Indirect indirect_12 = peer_.getJavaImplementationElementForElement();
					if(indirect_12 != null) {
						JavaImplementationElementPeer.GlobalClassPatternPeer child_8 = indirect_12.createGlobalClass();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GlobalClassDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type_2 == 9) {
					JavaImplementationElementPeer.Indirect indirect_13 = peer_.getJavaImplementationElementForElement();
					if(indirect_13 != null) {
						JavaImplementationElementPeer.FindPatternPeer child_9 = indirect_13.createFind();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.FindDecoder(child_9));
							child_9.end();
						}
					}
				}
			}
		}
	}
	public static final class JavaImplementationIncludeFileDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaImplementationIncludeFilePatternPeer peer_;
		public JavaImplementationIncludeFileDecoder(JavaImplementationIncludeFilePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaImplementationElementPeer.Indirect indirect = peer_.getJavaImplementationElementForElement();
					if(indirect != null) {
						JavaImplementationElementPeer.ClassPatternPeer child = indirect.createClass();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.ClassDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaImplementationElementPeer.Indirect indirect_1 = peer_.getJavaImplementationElementForElement();
					if(indirect_1 != null) {
						JavaImplementationElementPeer.InterfacePatternPeer child_1 = indirect_1.createInterface();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.InterfaceDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaImplementationElementPeer.Indirect indirect_2 = peer_.getJavaImplementationElementForElement();
					if(indirect_2 != null) {
						JavaImplementationElementPeer.LinkPatternPeer child_2 = indirect_2.createLink();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaImplementationElementPeer.Indirect indirect_3 = peer_.getJavaImplementationElementForElement();
					if(indirect_3 != null) {
						org.ffd2.austenx.runtime.BaseToken fileNameToken = element.getBaseArgumentToken(0);
						indirect_3.createInclude(fileNameToken.getStringValue(), fileNameToken.getLineNumber(), fileNameToken.getCharacterNumber());
					}
				}
				if(type == 4) {
					JavaImplementationElementPeer.Indirect indirect_4 = peer_.getJavaImplementationElementForElement();
					if(indirect_4 != null) {
						JavaImplementationElementPeer.IfPatternPeer child_3 = indirect_4.createIf();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.IfDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 5) {
					JavaImplementationElementPeer.Indirect indirect_5 = peer_.getJavaImplementationElementForElement();
					if(indirect_5 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaImplementationElementPeer.PackageSetPatternPeer child_4 = indirect_5.createPackageSet(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PackageSetDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 6) {
					JavaImplementationElementPeer.Indirect indirect_6 = peer_.getJavaImplementationElementForElement();
					if(indirect_6 != null) {
						JavaImplementationElementPeer.MacroDefPatternPeer child_5 = indirect_6.createMacroDef();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroDefDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 7) {
					JavaImplementationElementPeer.Indirect indirect_7 = peer_.getJavaImplementationElementForElement();
					if(indirect_7 != null) {
						JavaImplementationElementPeer.MacroCallPatternPeer child_6 = indirect_7.createMacroCall();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroCallDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 8) {
					JavaImplementationElementPeer.Indirect indirect_8 = peer_.getJavaImplementationElementForElement();
					if(indirect_8 != null) {
						JavaImplementationElementPeer.GlobalClassPatternPeer child_7 = indirect_8.createGlobalClass();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GlobalClassDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 9) {
					JavaImplementationElementPeer.Indirect indirect_9 = peer_.getJavaImplementationElementForElement();
					if(indirect_9 != null) {
						JavaImplementationElementPeer.FindPatternPeer child_8 = indirect_9.createFind();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.FindDecoder(child_8));
							child_8.end();
						}
					}
				}
			}
		}
	}
	public static final class JavaImplementationSpecificsBlockDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaImplementationSpecificsBlockPatternPeer peer_;
		public JavaImplementationSpecificsBlockDecoder(JavaImplementationSpecificsBlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					SpecificsBlockElementPeer.Indirect indirect = peer_.getSpecificsBlockElementForElements();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(1);
						SpecificsBlockElementPeer.MethodPatternPeer child = indirect.createMethod(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.MethodDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					SpecificsBlockElementPeer.Indirect indirect_1 = peer_.getSpecificsBlockElementForElements();
					if(indirect_1 != null) {
						SpecificsBlockElementPeer.SubPatternPeer child_1 = indirect_1.createSub();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SubDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					SpecificsBlockElementPeer.Indirect indirect_2 = peer_.getSpecificsBlockElementForElements();
					if(indirect_2 != null) {
						org.ffd2.austenx.runtime.BaseToken classNameToken = element.getBaseArgumentToken(0);
						SpecificsBlockElementPeer.ClassReferencePatternPeer child_2 = indirect_2.createClassReference(classNameToken.getStringValue(), classNameToken.getLineNumber(), classNameToken.getCharacterNumber());
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ClassReferenceDecoder(child_2));
							child_2.end();
						}
					}
				}
			}
		}
	}
	public static final class MethodDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final SpecificsBlockElementPeer.MethodPatternPeer peer_;
		public MethodDecoder(SpecificsBlockElementPeer.MethodPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addIsStatic();
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken typeNameToken = element.getBaseArgumentToken(0);
				TargetTypeReferencePatternPeer child = peer_.addTargetTypeReferenceForReturnType(typeNameToken.getStringValue(), typeNameToken.getLineNumber(), typeNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeReferenceDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class SubDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final SpecificsBlockElementPeer.SubPatternPeer peer_;
		public SubDecoder(SpecificsBlockElementPeer.SubPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken blockNameToken = element.getBaseArgumentToken(0);
				JavaImplementationSpecificsBlockPatternPeer child = peer_.addJavaImplementationSpecificsBlockForSubBlock(blockNameToken.getStringValue(), blockNameToken.getLineNumber(), blockNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaImplementationSpecificsBlockDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class ClassReferenceDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final SpecificsBlockElementPeer.ClassReferencePatternPeer peer_;
		public ClassReferenceDecoder(SpecificsBlockElementPeer.ClassReferencePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					SpecificsBlockElementPeer.Indirect indirect = peer_.getSpecificsBlockElementForElements();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(1);
						SpecificsBlockElementPeer.MethodPatternPeer child = indirect.createMethod(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.MethodDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					SpecificsBlockElementPeer.Indirect indirect_1 = peer_.getSpecificsBlockElementForElements();
					if(indirect_1 != null) {
						SpecificsBlockElementPeer.SubPatternPeer child_1 = indirect_1.createSub();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SubDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					SpecificsBlockElementPeer.Indirect indirect_2 = peer_.getSpecificsBlockElementForElements();
					if(indirect_2 != null) {
						org.ffd2.austenx.runtime.BaseToken classNameToken = element.getBaseArgumentToken(0);
						SpecificsBlockElementPeer.ClassReferencePatternPeer child_2 = indirect_2.createClassReference(classNameToken.getStringValue(), classNameToken.getLineNumber(), classNameToken.getCharacterNumber());
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ClassReferenceDecoder(child_2));
							child_2.end();
						}
					}
				}
			}
		}
	}
	public static final class ClassDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaImplementationElementPeer.ClassPatternPeer peer_;
		public ClassDecoder(JavaImplementationElementPeer.ClassPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(4);
				org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(5);
				JavaClassPatternPeer child = peer_.addJavaClassForJavaClass(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), nameToken.getStringValue());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaClassDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class InterfaceDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaImplementationElementPeer.InterfacePatternPeer peer_;
		public InterfaceDecoder(JavaImplementationElementPeer.InterfacePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(3);
				org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(4);
				JavaInterfacePatternPeer child = peer_.addJavaInterfaceForJavaInterface(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), nameToken.getStringValue());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaInterfaceDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class LinkDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaImplementationElementPeer.LinkPatternPeer peer_;
		public LinkDecoder(JavaImplementationElementPeer.LinkPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				LinkChainPatternPeer child = peer_.addLinkChainForSingleChain();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.LinkChainDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				DeferredJavaImplementationElement tool = new DeferredJavaImplementationElementImpl(element);
				peer_.setJavaImplementationElementForElement(tool);
			}
		}
	}
	public static final class IfDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaImplementationElementPeer.IfPatternPeer peer_;
		public IfDecoder(JavaImplementationElementPeer.IfPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				LinkChainPatternPeer child = peer_.addLinkChainForChain();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.LinkChainDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				int type = element.getType();
				if(type == 0) {
					JavaImplementationElementPeer.Indirect indirect = peer_.getJavaImplementationElementForElement();
					if(indirect != null) {
						JavaImplementationElementPeer.ClassPatternPeer child_1 = indirect.createClass();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ClassDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 1) {
					JavaImplementationElementPeer.Indirect indirect_1 = peer_.getJavaImplementationElementForElement();
					if(indirect_1 != null) {
						JavaImplementationElementPeer.InterfacePatternPeer child_2 = indirect_1.createInterface();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.InterfaceDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 2) {
					JavaImplementationElementPeer.Indirect indirect_2 = peer_.getJavaImplementationElementForElement();
					if(indirect_2 != null) {
						JavaImplementationElementPeer.LinkPatternPeer child_3 = indirect_2.createLink();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 3) {
					JavaImplementationElementPeer.Indirect indirect_3 = peer_.getJavaImplementationElementForElement();
					if(indirect_3 != null) {
						org.ffd2.austenx.runtime.BaseToken fileNameToken = element.getBaseArgumentToken(0);
						indirect_3.createInclude(fileNameToken.getStringValue(), fileNameToken.getLineNumber(), fileNameToken.getCharacterNumber());
					}
				}
				if(type == 4) {
					JavaImplementationElementPeer.Indirect indirect_4 = peer_.getJavaImplementationElementForElement();
					if(indirect_4 != null) {
						JavaImplementationElementPeer.IfPatternPeer child_4 = indirect_4.createIf();
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.IfDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					JavaImplementationElementPeer.Indirect indirect_5 = peer_.getJavaImplementationElementForElement();
					if(indirect_5 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaImplementationElementPeer.PackageSetPatternPeer child_5 = indirect_5.createPackageSet(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PackageSetDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 6) {
					JavaImplementationElementPeer.Indirect indirect_6 = peer_.getJavaImplementationElementForElement();
					if(indirect_6 != null) {
						JavaImplementationElementPeer.MacroDefPatternPeer child_6 = indirect_6.createMacroDef();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroDefDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 7) {
					JavaImplementationElementPeer.Indirect indirect_7 = peer_.getJavaImplementationElementForElement();
					if(indirect_7 != null) {
						JavaImplementationElementPeer.MacroCallPatternPeer child_7 = indirect_7.createMacroCall();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroCallDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 8) {
					JavaImplementationElementPeer.Indirect indirect_8 = peer_.getJavaImplementationElementForElement();
					if(indirect_8 != null) {
						JavaImplementationElementPeer.GlobalClassPatternPeer child_8 = indirect_8.createGlobalClass();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GlobalClassDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 9) {
					JavaImplementationElementPeer.Indirect indirect_9 = peer_.getJavaImplementationElementForElement();
					if(indirect_9 != null) {
						JavaImplementationElementPeer.FindPatternPeer child_9 = indirect_9.createFind();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.FindDecoder(child_9));
							child_9.end();
						}
					}
				}
			}
		}
	}
	public static final class PackageSetDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaImplementationElementPeer.PackageSetPatternPeer peer_;
		public PackageSetDecoder(JavaImplementationElementPeer.PackageSetPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 1) {
				peer_.addNameElement(token.getStringValue());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
		}
	}
	public static final class MacroDefDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaImplementationElementPeer.MacroDefPatternPeer peer_;
		public MacroDefDecoder(JavaImplementationElementPeer.MacroDefPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
				org.ffd2.austenx.runtime.BaseToken macronameToken = element.getBaseArgumentToken(1);
				JavaMacroBlockPatternPeer child = peer_.addJavaMacroBlockForMacroDef(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), macronameToken.getStringValue());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaMacroBlockDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class MacroCallDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaImplementationElementPeer.MacroCallPatternPeer peer_;
		public MacroCallDecoder(JavaImplementationElementPeer.MacroCallPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
				org.ffd2.austenx.runtime.BaseToken macroNameToken = element.getBaseArgumentToken(2);
				GeneralMacroCallPatternPeer child = peer_.addGeneralMacroCallForCall(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), macroNameToken.getStringValue());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.GeneralMacroCallDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class GlobalClassDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaImplementationElementPeer.GlobalClassPatternPeer peer_;
		public GlobalClassDecoder(JavaImplementationElementPeer.GlobalClassPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken classNameToken = element.getBaseArgumentToken(0);
				GlobalClassDefinitionPatternPeer child = peer_.addGlobalClassDefinitionForDefinition(classNameToken.getStringValue(), classNameToken.getLineNumber(), classNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.GlobalClassDefinitionDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class FindDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaImplementationElementPeer.FindPatternPeer peer_;
		public FindDecoder(JavaImplementationElementPeer.FindPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken varibleNameToken = element.getBaseArgumentToken(0);
				FindDefinitionPatternPeer child = peer_.addFindDefinitionForDefinition(varibleNameToken.getStringValue(), varibleNameToken.getLineNumber(), varibleNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.FindDefinitionDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class JavaMacroBlockDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaMacroBlockPatternPeer peer_;
		public JavaMacroBlockDecoder(JavaMacroBlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				MacroParameterBlockPatternPeer child = peer_.addMacroParameterBlockForParameters();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.MacroParameterBlockDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				int type = element.getType();
				if(type == 0) {
					MacroElementPeer.ArgValsBlockPatternPeer child_1 = peer_.addOptionArgValsBlockOfMacroElementForElement();
					if(child_1 != null) {
						element.updateConstruction(new AllDecodersSkeleton.ArgValsBlockDecoder(child_1));
						child_1.end();
					}
				}
				if(type == 1) {
					MacroElementPeer.ArgTypesBlockPatternPeer child_2 = peer_.addOptionArgTypesBlockOfMacroElementForElement();
					if(child_2 != null) {
						element.updateConstruction(new AllDecodersSkeleton.ArgTypesBlockDecoder(child_2));
						child_2.end();
					}
				}
				if(type == 2) {
					org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
					MacroElementPeer.CodeBlockPatternPeer child_3 = peer_.addOptionCodeBlockOfMacroElementForElement(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
					if(child_3 != null) {
						element.updateConstruction(new AllDecodersSkeleton.CodeBlockDecoder(child_3));
						child_3.end();
					}
				}
				if(type == 3) {
					org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
					MacroElementPeer.ContextBlockPatternPeer child_4 = peer_.addOptionContextBlockOfMacroElementForElement(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
					if(child_4 != null) {
						element.updateConstruction(new AllDecodersSkeleton.ContextBlockDecoder(child_4));
						child_4.end();
					}
				}
				if(type == 4) {
					org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
					MacroElementPeer.ContainerBlockPatternPeer child_5 = peer_.addOptionContainerBlockOfMacroElementForElement(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
					if(child_5 != null) {
						element.updateConstruction(new AllDecodersSkeleton.ContainerBlockDecoder(child_5));
						child_5.end();
					}
				}
			}
		}
	}
	public static final class ArgValsBlockBaseDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ArgValsBlockBasePatternPeer peer_;
		public ArgValsBlockBaseDecoder(ArgValsBlockBasePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				TargetCallArgumentsPatternPeer child = peer_.addTargetCallArgumentsForArguments();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetCallArgumentsDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class ArgTypesBlockBaseDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ArgTypesBlockBasePatternPeer peer_;
		public ArgTypesBlockBaseDecoder(ArgTypesBlockBasePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					TargetParameterPeer.Indirect indirect = peer_.getTargetParameterForParameter();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
						TargetParameterPeer.SimplePatternPeer child = indirect.createSimple(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.SimpleDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					TargetParameterPeer.Indirect indirect_1 = peer_.getTargetParameterForParameter();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						TargetParameterPeer.LinkPatternPeer child_1 = indirect_1.createLink(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkDecoder_5(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					TargetParameterPeer.Indirect indirect_2 = peer_.getTargetParameterForParameter();
					if(indirect_2 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_2.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class ArgValsBlockDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final MacroElementPeer.ArgValsBlockPatternPeer peer_;
		public ArgValsBlockDecoder(MacroElementPeer.ArgValsBlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken givenCodeVariableNameToken = element.getBaseArgumentToken(0);
				ArgValsBlockBasePatternPeer child = peer_.addArgValsBlockBaseForBlock(givenCodeVariableNameToken.getStringValue(), givenCodeVariableNameToken.getLineNumber(), givenCodeVariableNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.ArgValsBlockBaseDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class ArgTypesBlockDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final MacroElementPeer.ArgTypesBlockPatternPeer peer_;
		public ArgTypesBlockDecoder(MacroElementPeer.ArgTypesBlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken givenCodeVariableNameToken = element.getBaseArgumentToken(0);
				ArgTypesBlockBasePatternPeer child = peer_.addArgTypesBlockBaseForBlock(givenCodeVariableNameToken.getStringValue(), givenCodeVariableNameToken.getLineNumber(), givenCodeVariableNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.ArgTypesBlockBaseDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class CodeBlockDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final MacroElementPeer.CodeBlockPatternPeer peer_;
		public CodeBlockDecoder(MacroElementPeer.CodeBlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 1) {
				peer_.addGivenCodeVariableName(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken givenCodeVariableNameToken = element.getBaseArgumentToken(0);
				ArgTypesBlockBasePatternPeer child = peer_.addArgTypesBlockBaseForParametersBlock(givenCodeVariableNameToken.getStringValue(), givenCodeVariableNameToken.getLineNumber(), givenCodeVariableNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.ArgTypesBlockBaseDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				int type = element.getType();
				if(type == 0) {
					JavaStatementPeer.Indirect indirect = peer_.getJavaStatementForStatement();
					if(indirect != null) {
						JavaStatementPeer.BlockPatternPeer child_1 = indirect.createBlock();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BlockDecoder_1(child_1));
							child_1.end();
						}
					}
				}
				if(type == 1) {
					JavaStatementPeer.Indirect indirect_1 = peer_.getJavaStatementForStatement();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(1);
						JavaStatementPeer.DeclarationPatternPeer child_2 = indirect_1.createDeclaration(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.DeclarationDecoder_1(child_2));
							child_2.end();
						}
					}
				}
				if(type == 2) {
					JavaStatementPeer.Indirect indirect_2 = peer_.getJavaStatementForStatement();
					if(indirect_2 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaStatementPeer.IfPatternPeer child_3 = indirect_2.createIf(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.IfDecoder_1(child_3));
							child_3.end();
						}
					}
				}
				if(type == 3) {
					JavaStatementPeer.Indirect indirect_3 = peer_.getJavaStatementForStatement();
					if(indirect_3 != null) {
						org.ffd2.austenx.runtime.BaseToken noteToken = element.getBaseArgumentToken(0);
						indirect_3.createNote(noteToken.getStringValue());
					}
				}
				if(type == 4) {
					JavaStatementPeer.Indirect indirect_4 = peer_.getJavaStatementForStatement();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ForPatternPeer child_4 = indirect_4.createFor(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ForDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					JavaStatementPeer.Indirect indirect_5 = peer_.getJavaStatementForStatement();
					if(indirect_5 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaStatementPeer.WhilePatternPeer child_5 = indirect_5.createWhile(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.WhileDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 6) {
					JavaStatementPeer.Indirect indirect_6 = peer_.getJavaStatementForStatement();
					if(indirect_6 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_6.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
				if(type == 7) {
					JavaStatementPeer.Indirect indirect_7 = peer_.getJavaStatementForStatement();
					if(indirect_7 != null) {
						JavaStatementPeer.MacroCallPatternPeer child_6 = indirect_7.createMacroCall();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroCallDecoder_2(child_6));
							child_6.end();
						}
					}
				}
				if(type == 8) {
					JavaStatementPeer.Indirect indirect_8 = peer_.getJavaStatementForStatement();
					if(indirect_8 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken = element.getBaseArgumentToken(0);
						JavaStatementPeer.ExpressionVarPatternPeer child_7 = indirect_8.createExpressionVar(variableNameToken.getStringValue(), variableNameToken.getLineNumber(), variableNameToken.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ExpressionVarDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 9) {
					JavaStatementPeer.Indirect indirect_9 = peer_.getJavaStatementForStatement();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken_1 = element.getBaseArgumentToken(0);
						JavaStatementPeer.StatementVarPatternPeer child_8 = indirect_9.createStatementVar(variableNameToken_1.getStringValue(), variableNameToken_1.getLineNumber(), variableNameToken_1.getCharacterNumber());
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.StatementVarDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 10) {
					JavaStatementPeer.Indirect indirect_10 = peer_.getJavaStatementForStatement();
					if(indirect_10 != null) {
						JavaStatementPeer.FindPatternPeer child_9 = indirect_10.createFind();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.FindDecoder_2(child_9));
							child_9.end();
						}
					}
				}
				if(type == 11) {
					JavaStatementPeer.Indirect indirect_11 = peer_.getJavaStatementForStatement();
					if(indirect_11 != null) {
						JavaStatementPeer.LinkBlockPatternPeer child_10 = indirect_11.createLinkBlock();
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkBlockDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 12) {
					JavaStatementPeer.Indirect indirect_12 = peer_.getJavaStatementForStatement();
					if(indirect_12 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						indirect_12.createReturnSimple(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
					}
				}
				if(type == 13) {
					JavaStatementPeer.Indirect indirect_13 = peer_.getJavaStatementForStatement();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ReturnPatternPeer child_11 = indirect_13.createReturn(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ReturnDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 14) {
					JavaStatementPeer.Indirect indirect_14 = peer_.getJavaStatementForStatement();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ThrowPatternPeer child_12 = indirect_14.createThrow(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ThrowDecoder(child_12));
							child_12.end();
						}
					}
				}
				if(type == 15) {
					JavaStatementPeer.Indirect indirect_15 = peer_.getJavaStatementForStatement();
					if(indirect_15 != null) {
						JavaStatementPeer.ExpressionPatternPeer child_13 = indirect_15.createExpression();
						if(child_13 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ExpressionDecoder_1(child_13));
							child_13.end();
						}
					}
				}
				if(type == 16) {
					JavaStatementPeer.Indirect indirect_16 = peer_.getJavaStatementForStatement();
					if(indirect_16 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						JavaStatementPeer.SyncPatternPeer child_14 = indirect_16.createSync(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
						if(child_14 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SyncDecoder(child_14));
							child_14.end();
						}
					}
				}
				if(type == 17) {
					JavaStatementPeer.Indirect indirect_17 = peer_.getJavaStatementForStatement();
					if(indirect_17 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken_2 = element.getBaseArgumentToken(0);
						JavaStatementPeer.SetPatternPeer child_15 = indirect_17.createSet(variableNameToken_2.getStringValue(), variableNameToken_2.getLineNumber(), variableNameToken_2.getCharacterNumber());
						if(child_15 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SetDecoder(child_15));
							child_15.end();
						}
					}
				}
			}
			if(index == 2) {
				org.ffd2.austenx.runtime.BaseToken givenCodeVariableNameToken_1 = element.getBaseArgumentToken(0);
				ArgValsBlockBasePatternPeer child_16 = peer_.addArgValsBlockBaseForBlock(givenCodeVariableNameToken_1.getStringValue(), givenCodeVariableNameToken_1.getLineNumber(), givenCodeVariableNameToken_1.getCharacterNumber());
				if(child_16 != null) {
					element.updateConstruction(new AllDecodersSkeleton.ArgValsBlockBaseDecoder(child_16));
					child_16.end();
				}
			}
		}
	}
	public static final class ContextBlockDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final MacroElementPeer.ContextBlockPatternPeer peer_;
		public ContextBlockDecoder(MacroElementPeer.ContextBlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 1) {
				peer_.addExternalTypeName(token.getStringValue());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaClassInterfaceElementPeer.Indirect indirect = peer_.getJavaClassInterfaceElementForElements();
					if(indirect != null) {
						JavaClassInterfaceElementPeer.PrototypePatternPeer child = indirect.createPrototype();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrototypeDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaClassInterfaceElementPeer.Indirect indirect_1 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_1 != null) {
						JavaClassInterfaceElementPeer.MethodPatternPeer child_1 = indirect_1.createMethod();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MethodDecoder_1(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaClassInterfaceElementPeer.Indirect indirect_2 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_2 != null) {
						JavaClassInterfaceElementPeer.ConstructorPatternPeer child_2 = indirect_2.createConstructor();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaClassInterfaceElementPeer.Indirect indirect_3 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_3 != null) {
						JavaClassInterfaceElementPeer.InstanceVariablePatternPeer child_3 = indirect_3.createInstanceVariable();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.InstanceVariableDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					JavaClassInterfaceElementPeer.Indirect indirect_4 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_4 != null) {
						JavaClassInterfaceElementPeer.ClassPatternPeer child_4 = indirect_4.createClass();
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ClassDecoder_1(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					JavaClassInterfaceElementPeer.Indirect indirect_5 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_5 != null) {
						JavaClassInterfaceElementPeer.InterfacePatternPeer child_5 = indirect_5.createInterface();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.InterfaceDecoder_1(child_5));
							child_5.end();
						}
					}
				}
				if(type == 6) {
					JavaClassInterfaceElementPeer.Indirect indirect_6 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_6 != null) {
						JavaClassInterfaceElementPeer.MacroDefPatternPeer child_6 = indirect_6.createMacroDef();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroDefDecoder_1(child_6));
							child_6.end();
						}
					}
				}
				if(type == 7) {
					JavaClassInterfaceElementPeer.Indirect indirect_7 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_7 != null) {
						JavaClassInterfaceElementPeer.MacroCallPatternPeer child_7 = indirect_7.createMacroCall();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroCallDecoder_1(child_7));
							child_7.end();
						}
					}
				}
				if(type == 8) {
					JavaClassInterfaceElementPeer.Indirect indirect_8 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_8 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaClassInterfaceElementPeer.LinkPatternPeer child_8 = indirect_8.createLink(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkDecoder_1(child_8));
							child_8.end();
						}
					}
				}
				if(type == 9) {
					JavaClassInterfaceElementPeer.Indirect indirect_9 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_9 != null) {
						JavaClassInterfaceElementPeer.FindPatternPeer child_9 = indirect_9.createFind();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.FindDecoder_1(child_9));
							child_9.end();
						}
					}
				}
				if(type == 10) {
					JavaClassInterfaceElementPeer.Indirect indirect_10 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_10 != null) {
						JavaClassInterfaceElementPeer.GlobalClassPatternPeer child_10 = indirect_10.createGlobalClass();
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GlobalClassDecoder_1(child_10));
							child_10.end();
						}
					}
				}
			}
		}
	}
	public static final class ContainerBlockDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final MacroElementPeer.ContainerBlockPatternPeer peer_;
		public ContainerBlockDecoder(MacroElementPeer.ContainerBlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaClassInterfaceElementPeer.Indirect indirect = peer_.getJavaClassInterfaceElementForElements();
					if(indirect != null) {
						JavaClassInterfaceElementPeer.PrototypePatternPeer child = indirect.createPrototype();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrototypeDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaClassInterfaceElementPeer.Indirect indirect_1 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_1 != null) {
						JavaClassInterfaceElementPeer.MethodPatternPeer child_1 = indirect_1.createMethod();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MethodDecoder_1(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaClassInterfaceElementPeer.Indirect indirect_2 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_2 != null) {
						JavaClassInterfaceElementPeer.ConstructorPatternPeer child_2 = indirect_2.createConstructor();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaClassInterfaceElementPeer.Indirect indirect_3 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_3 != null) {
						JavaClassInterfaceElementPeer.InstanceVariablePatternPeer child_3 = indirect_3.createInstanceVariable();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.InstanceVariableDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					JavaClassInterfaceElementPeer.Indirect indirect_4 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_4 != null) {
						JavaClassInterfaceElementPeer.ClassPatternPeer child_4 = indirect_4.createClass();
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ClassDecoder_1(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					JavaClassInterfaceElementPeer.Indirect indirect_5 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_5 != null) {
						JavaClassInterfaceElementPeer.InterfacePatternPeer child_5 = indirect_5.createInterface();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.InterfaceDecoder_1(child_5));
							child_5.end();
						}
					}
				}
				if(type == 6) {
					JavaClassInterfaceElementPeer.Indirect indirect_6 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_6 != null) {
						JavaClassInterfaceElementPeer.MacroDefPatternPeer child_6 = indirect_6.createMacroDef();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroDefDecoder_1(child_6));
							child_6.end();
						}
					}
				}
				if(type == 7) {
					JavaClassInterfaceElementPeer.Indirect indirect_7 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_7 != null) {
						JavaClassInterfaceElementPeer.MacroCallPatternPeer child_7 = indirect_7.createMacroCall();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroCallDecoder_1(child_7));
							child_7.end();
						}
					}
				}
				if(type == 8) {
					JavaClassInterfaceElementPeer.Indirect indirect_8 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_8 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaClassInterfaceElementPeer.LinkPatternPeer child_8 = indirect_8.createLink(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkDecoder_1(child_8));
							child_8.end();
						}
					}
				}
				if(type == 9) {
					JavaClassInterfaceElementPeer.Indirect indirect_9 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_9 != null) {
						JavaClassInterfaceElementPeer.FindPatternPeer child_9 = indirect_9.createFind();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.FindDecoder_1(child_9));
							child_9.end();
						}
					}
				}
				if(type == 10) {
					JavaClassInterfaceElementPeer.Indirect indirect_10 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_10 != null) {
						JavaClassInterfaceElementPeer.GlobalClassPatternPeer child_10 = indirect_10.createGlobalClass();
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GlobalClassDecoder_1(child_10));
							child_10.end();
						}
					}
				}
			}
		}
	}
	public static final class TargetTypeElementDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final TargetTypeElementPatternPeer peer_;
		public TargetTypeElementDecoder(TargetTypeElementPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken typeNameToken = element.getBaseArgumentToken(0);
				TargetTypeReferencePatternPeer child = peer_.addTargetTypeReferenceForType(typeNameToken.getStringValue(), typeNameToken.getLineNumber(), typeNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeReferenceDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				TargetTypeLinkPatternPeer child_1 = peer_.addTargetTypeLinkForSubLink();
				if(child_1 != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeLinkDecoder(child_1));
					child_1.end();
				}
			}
		}
	}
	public static final class TargetTypeListDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final TargetTypeListPatternPeer peer_;
		public TargetTypeListDecoder(TargetTypeListPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken typeNameToken = element.getBaseArgumentToken(0);
				TargetTypeReferencePatternPeer child = peer_.addTargetTypeReferenceForType(typeNameToken.getStringValue(), typeNameToken.getLineNumber(), typeNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeReferenceDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				TargetTypeLinkPatternPeer child_1 = peer_.addTargetTypeLinkForSubLink();
				if(child_1 != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeLinkDecoder(child_1));
					child_1.end();
				}
			}
		}
	}
	public static final class TargetTypeLinkDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final TargetTypeLinkPatternPeer peer_;
		public TargetTypeLinkDecoder(TargetTypeLinkPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				LinkChainPatternPeer child = peer_.addLinkChainForSingleChain();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.LinkChainDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				DeferredTargetTypeElement tool = new DeferredTargetTypeElementImpl(element);
				peer_.setTargetTypeElementForSubList(tool);
			}
			if(index == 2) {
				DeferredTargetTypeElement tool_1 = new DeferredTargetTypeElementImpl(element);
				peer_.setTargetTypeElementForSingleType(tool_1);
			}
		}
	}
	public static final class SetsListDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final SetsListPatternPeer peer_;
		public SetsListDecoder(SetsListPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addClassName(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
		}
	}
	public static final class JavaClassDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaClassPatternPeer peer_;
		public JavaClassDecoder(JavaClassPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addIsPublic();
			}
			if(index == 1) {
				peer_.addIsPrivate();
			}
			if(index == 2) {
				peer_.addIsFinal(token.getLineNumber(), token.getCharacterNumber());
			}
			if(index == 3) {
				peer_.addIsStatic(token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					NamePeer.BasicPatternPeer child = peer_.addOptionBasicOfNameForNameOutput();
					if(child != null) {
						element.updateConstruction(new AllDecodersSkeleton.BasicDecoder_1(child));
						child.end();
					}
				}
				if(type == 1) {
					org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken classNameToken = element.getBaseArgumentToken(1);
					org.ffd2.austenx.runtime.BaseToken methodNameToken = element.getBaseArgumentToken(2);
					peer_.addOptionImplementsOfNameForNameOutput(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), classNameToken.getStringValue(), methodNameToken.getStringValue(), methodNameToken.getLineNumber(), methodNameToken.getCharacterNumber());
				}
			}
			if(index == 1) {
				TargetTypeListPatternPeer child_1 = peer_.addTargetTypeListForExtensionList();
				if(child_1 != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeListDecoder(child_1));
					child_1.end();
				}
			}
			if(index == 2) {
				TargetTypeListPatternPeer child_2 = peer_.addTargetTypeListForImplementsList();
				if(child_2 != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeListDecoder(child_2));
					child_2.end();
				}
			}
			if(index == 3) {
				SetsListPatternPeer child_3 = peer_.addSetsListForClassSet();
				if(child_3 != null) {
					element.updateConstruction(new AllDecodersSkeleton.SetsListDecoder(child_3));
					child_3.end();
				}
			}
			if(index == 4) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					JavaClassInterfaceElementPeer.Indirect indirect = peer_.getJavaClassInterfaceElementForElements();
					if(indirect != null) {
						JavaClassInterfaceElementPeer.PrototypePatternPeer child_4 = indirect.createPrototype();
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrototypeDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type_1 == 1) {
					JavaClassInterfaceElementPeer.Indirect indirect_1 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_1 != null) {
						JavaClassInterfaceElementPeer.MethodPatternPeer child_5 = indirect_1.createMethod();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MethodDecoder_1(child_5));
							child_5.end();
						}
					}
				}
				if(type_1 == 2) {
					JavaClassInterfaceElementPeer.Indirect indirect_2 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_2 != null) {
						JavaClassInterfaceElementPeer.ConstructorPatternPeer child_6 = indirect_2.createConstructor();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type_1 == 3) {
					JavaClassInterfaceElementPeer.Indirect indirect_3 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_3 != null) {
						JavaClassInterfaceElementPeer.InstanceVariablePatternPeer child_7 = indirect_3.createInstanceVariable();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.InstanceVariableDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type_1 == 4) {
					JavaClassInterfaceElementPeer.Indirect indirect_4 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_4 != null) {
						JavaClassInterfaceElementPeer.ClassPatternPeer child_8 = indirect_4.createClass();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ClassDecoder_1(child_8));
							child_8.end();
						}
					}
				}
				if(type_1 == 5) {
					JavaClassInterfaceElementPeer.Indirect indirect_5 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_5 != null) {
						JavaClassInterfaceElementPeer.InterfacePatternPeer child_9 = indirect_5.createInterface();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.InterfaceDecoder_1(child_9));
							child_9.end();
						}
					}
				}
				if(type_1 == 6) {
					JavaClassInterfaceElementPeer.Indirect indirect_6 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_6 != null) {
						JavaClassInterfaceElementPeer.MacroDefPatternPeer child_10 = indirect_6.createMacroDef();
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroDefDecoder_1(child_10));
							child_10.end();
						}
					}
				}
				if(type_1 == 7) {
					JavaClassInterfaceElementPeer.Indirect indirect_7 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_7 != null) {
						JavaClassInterfaceElementPeer.MacroCallPatternPeer child_11 = indirect_7.createMacroCall();
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroCallDecoder_1(child_11));
							child_11.end();
						}
					}
				}
				if(type_1 == 8) {
					JavaClassInterfaceElementPeer.Indirect indirect_8 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_8 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaClassInterfaceElementPeer.LinkPatternPeer child_12 = indirect_8.createLink(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkDecoder_1(child_12));
							child_12.end();
						}
					}
				}
				if(type_1 == 9) {
					JavaClassInterfaceElementPeer.Indirect indirect_9 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_9 != null) {
						JavaClassInterfaceElementPeer.FindPatternPeer child_13 = indirect_9.createFind();
						if(child_13 != null) {
							element.updateConstruction(new AllDecodersSkeleton.FindDecoder_1(child_13));
							child_13.end();
						}
					}
				}
				if(type_1 == 10) {
					JavaClassInterfaceElementPeer.Indirect indirect_10 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_10 != null) {
						JavaClassInterfaceElementPeer.GlobalClassPatternPeer child_14 = indirect_10.createGlobalClass();
						if(child_14 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GlobalClassDecoder_1(child_14));
							child_14.end();
						}
					}
				}
			}
		}
	}
	public static final class JavaInterfaceDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaInterfacePatternPeer peer_;
		public JavaInterfaceDecoder(JavaInterfacePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addIsPublic();
			}
			if(index == 1) {
				peer_.addIsPrivate();
			}
			if(index == 2) {
				peer_.addIsStatic(token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					NamePeer.BasicPatternPeer child = peer_.addOptionBasicOfNameForNameOutput();
					if(child != null) {
						element.updateConstruction(new AllDecodersSkeleton.BasicDecoder_1(child));
						child.end();
					}
				}
				if(type == 1) {
					org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken classNameToken = element.getBaseArgumentToken(1);
					org.ffd2.austenx.runtime.BaseToken methodNameToken = element.getBaseArgumentToken(2);
					peer_.addOptionImplementsOfNameForNameOutput(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), classNameToken.getStringValue(), methodNameToken.getStringValue(), methodNameToken.getLineNumber(), methodNameToken.getCharacterNumber());
				}
			}
			if(index == 1) {
				TargetTypeListPatternPeer child_1 = peer_.addTargetTypeListForExtensionList();
				if(child_1 != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeListDecoder(child_1));
					child_1.end();
				}
			}
			if(index == 2) {
				TargetTypeListPatternPeer child_2 = peer_.addTargetTypeListForImplementsList();
				if(child_2 != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeListDecoder(child_2));
					child_2.end();
				}
			}
			if(index == 3) {
				SetsListPatternPeer child_3 = peer_.addSetsListForClassSet();
				if(child_3 != null) {
					element.updateConstruction(new AllDecodersSkeleton.SetsListDecoder(child_3));
					child_3.end();
				}
			}
			if(index == 4) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					JavaClassInterfaceElementPeer.Indirect indirect = peer_.getJavaClassInterfaceElementForElements();
					if(indirect != null) {
						JavaClassInterfaceElementPeer.PrototypePatternPeer child_4 = indirect.createPrototype();
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrototypeDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type_1 == 1) {
					JavaClassInterfaceElementPeer.Indirect indirect_1 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_1 != null) {
						JavaClassInterfaceElementPeer.MethodPatternPeer child_5 = indirect_1.createMethod();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MethodDecoder_1(child_5));
							child_5.end();
						}
					}
				}
				if(type_1 == 2) {
					JavaClassInterfaceElementPeer.Indirect indirect_2 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_2 != null) {
						JavaClassInterfaceElementPeer.ConstructorPatternPeer child_6 = indirect_2.createConstructor();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type_1 == 3) {
					JavaClassInterfaceElementPeer.Indirect indirect_3 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_3 != null) {
						JavaClassInterfaceElementPeer.InstanceVariablePatternPeer child_7 = indirect_3.createInstanceVariable();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.InstanceVariableDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type_1 == 4) {
					JavaClassInterfaceElementPeer.Indirect indirect_4 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_4 != null) {
						JavaClassInterfaceElementPeer.ClassPatternPeer child_8 = indirect_4.createClass();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ClassDecoder_1(child_8));
							child_8.end();
						}
					}
				}
				if(type_1 == 5) {
					JavaClassInterfaceElementPeer.Indirect indirect_5 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_5 != null) {
						JavaClassInterfaceElementPeer.InterfacePatternPeer child_9 = indirect_5.createInterface();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.InterfaceDecoder_1(child_9));
							child_9.end();
						}
					}
				}
				if(type_1 == 6) {
					JavaClassInterfaceElementPeer.Indirect indirect_6 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_6 != null) {
						JavaClassInterfaceElementPeer.MacroDefPatternPeer child_10 = indirect_6.createMacroDef();
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroDefDecoder_1(child_10));
							child_10.end();
						}
					}
				}
				if(type_1 == 7) {
					JavaClassInterfaceElementPeer.Indirect indirect_7 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_7 != null) {
						JavaClassInterfaceElementPeer.MacroCallPatternPeer child_11 = indirect_7.createMacroCall();
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroCallDecoder_1(child_11));
							child_11.end();
						}
					}
				}
				if(type_1 == 8) {
					JavaClassInterfaceElementPeer.Indirect indirect_8 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_8 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaClassInterfaceElementPeer.LinkPatternPeer child_12 = indirect_8.createLink(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkDecoder_1(child_12));
							child_12.end();
						}
					}
				}
				if(type_1 == 9) {
					JavaClassInterfaceElementPeer.Indirect indirect_9 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_9 != null) {
						JavaClassInterfaceElementPeer.FindPatternPeer child_13 = indirect_9.createFind();
						if(child_13 != null) {
							element.updateConstruction(new AllDecodersSkeleton.FindDecoder_1(child_13));
							child_13.end();
						}
					}
				}
				if(type_1 == 10) {
					JavaClassInterfaceElementPeer.Indirect indirect_10 = peer_.getJavaClassInterfaceElementForElements();
					if(indirect_10 != null) {
						JavaClassInterfaceElementPeer.GlobalClassPatternPeer child_14 = indirect_10.createGlobalClass();
						if(child_14 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GlobalClassDecoder_1(child_14));
							child_14.end();
						}
					}
				}
			}
		}
	}
	public static final class ChainHookListDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ChainHookListPatternPeer peer_;
		public ChainHookListDecoder(ChainHookListPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken chainNameToken = element.getBaseArgumentToken(0);
				org.ffd2.austenx.runtime.BaseToken linkNameToken = element.getBaseArgumentToken(1);
				peer_.addChainHookElementForE(chainNameToken.getStringValue(), linkNameToken.getStringValue(), linkNameToken.getLineNumber(), linkNameToken.getCharacterNumber());
			}
		}
	}
	public static final class PrototypeDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaClassInterfaceElementPeer.PrototypePatternPeer peer_;
		public PrototypeDecoder(JavaClassInterfaceElementPeer.PrototypePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
				org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(3);
				JavaPrototypePatternPeer child = peer_.addJavaPrototypeForValue(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), nameToken.getStringValue());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaPrototypeDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class MethodDecoder_1 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaClassInterfaceElementPeer.MethodPatternPeer peer_;
		public MethodDecoder_1(JavaClassInterfaceElementPeer.MethodPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(4);
				JavaMethodPatternPeer child = peer_.addJavaMethodForValue(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaMethodDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class ConstructorDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaClassInterfaceElementPeer.ConstructorPatternPeer peer_;
		public ConstructorDecoder(JavaClassInterfaceElementPeer.ConstructorPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
				JavaConstructorPatternPeer child = peer_.addJavaConstructorForValue(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaConstructorDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class InstanceVariableDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaClassInterfaceElementPeer.InstanceVariablePatternPeer peer_;
		public InstanceVariableDecoder(JavaClassInterfaceElementPeer.InstanceVariablePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(4);
				JavaInstanceVariablePatternPeer child = peer_.addJavaInstanceVariableForVariable(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaInstanceVariableDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class ClassDecoder_1 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaClassInterfaceElementPeer.ClassPatternPeer peer_;
		public ClassDecoder_1(JavaClassInterfaceElementPeer.ClassPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(4);
				org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(5);
				JavaClassPatternPeer child = peer_.addJavaClassForValue(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), nameToken.getStringValue());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaClassDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class InterfaceDecoder_1 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaClassInterfaceElementPeer.InterfacePatternPeer peer_;
		public InterfaceDecoder_1(JavaClassInterfaceElementPeer.InterfacePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(3);
				org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(4);
				JavaInterfacePatternPeer child = peer_.addJavaInterfaceForValue(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), nameToken.getStringValue());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaInterfaceDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class MacroDefDecoder_1 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaClassInterfaceElementPeer.MacroDefPatternPeer peer_;
		public MacroDefDecoder_1(JavaClassInterfaceElementPeer.MacroDefPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
				org.ffd2.austenx.runtime.BaseToken macronameToken = element.getBaseArgumentToken(1);
				JavaMacroBlockPatternPeer child = peer_.addJavaMacroBlockForMacroDef(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), macronameToken.getStringValue());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaMacroBlockDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class MacroCallDecoder_1 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaClassInterfaceElementPeer.MacroCallPatternPeer peer_;
		public MacroCallDecoder_1(JavaClassInterfaceElementPeer.MacroCallPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
				org.ffd2.austenx.runtime.BaseToken macroNameToken = element.getBaseArgumentToken(2);
				GeneralMacroCallPatternPeer child = peer_.addGeneralMacroCallForCall(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), macroNameToken.getStringValue());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.GeneralMacroCallDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class LinkDecoder_1 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaClassInterfaceElementPeer.LinkPatternPeer peer_;
		public LinkDecoder_1(JavaClassInterfaceElementPeer.LinkPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				LinkChainPatternPeer child = peer_.addLinkChainForSingleChain();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.LinkChainDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				DeferredJavaClassInterfaceElement tool = new DeferredJavaClassInterfaceElementImpl(element);
				peer_.setJavaClassInterfaceElementForElement(tool);
			}
		}
	}
	public static final class FindDecoder_1 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaClassInterfaceElementPeer.FindPatternPeer peer_;
		public FindDecoder_1(JavaClassInterfaceElementPeer.FindPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken varibleNameToken = element.getBaseArgumentToken(0);
				FindDefinitionPatternPeer child = peer_.addFindDefinitionForDefinition(varibleNameToken.getStringValue(), varibleNameToken.getLineNumber(), varibleNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.FindDefinitionDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class GlobalClassDecoder_1 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaClassInterfaceElementPeer.GlobalClassPatternPeer peer_;
		public GlobalClassDecoder_1(JavaClassInterfaceElementPeer.GlobalClassPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken classNameToken = element.getBaseArgumentToken(0);
				GlobalClassDefinitionPatternPeer child = peer_.addGlobalClassDefinitionForDefinition(classNameToken.getStringValue(), classNameToken.getLineNumber(), classNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.GlobalClassDefinitionDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class FindDefinitionDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final FindDefinitionPatternPeer peer_;
		public FindDefinitionDecoder(FindDefinitionPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					org.ffd2.austenx.runtime.BaseToken childNameToken = element.getBaseArgumentToken(0);
					FindTargetPeer.VariableBasedPatternPeer child = peer_.addOptionVariableBasedOfFindTargetForTarget(childNameToken.getStringValue(), childNameToken.getLineNumber(), childNameToken.getCharacterNumber());
					if(child != null) {
						element.updateConstruction(new AllDecodersSkeleton.VariableBasedDecoder(child));
						child.end();
					}
				}
				if(type == 1) {
					FindTargetPeer.RootBasedPatternPeer child_1 = peer_.addOptionRootBasedOfFindTargetForTarget();
					if(child_1 != null) {
						element.updateConstruction(new AllDecodersSkeleton.RootBasedDecoder(child_1));
						child_1.end();
					}
				}
				if(type == 2) {
					org.ffd2.austenx.runtime.BaseToken childNameToken_1 = element.getBaseArgumentToken(0);
					peer_.addOptionLocalBasedOfFindTargetForTarget(childNameToken_1.getStringValue(), childNameToken_1.getLineNumber(), childNameToken_1.getCharacterNumber());
				}
				if(type == 3) {
					org.ffd2.austenx.runtime.BaseToken nodeLayerNameToken = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken childNameToken_2 = element.getBaseArgumentToken(1);
					peer_.addOptionSimpleThreadBasedOfFindTargetForTarget(nodeLayerNameToken.getStringValue(), nodeLayerNameToken.getLineNumber(), nodeLayerNameToken.getCharacterNumber(), childNameToken_2.getStringValue(), childNameToken_2.getLineNumber(), childNameToken_2.getCharacterNumber());
				}
				if(type == 4) {
					org.ffd2.austenx.runtime.BaseToken nodeLayerNameToken_1 = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken childNameToken_3 = element.getBaseArgumentToken(1);
					FindTargetPeer.BackThreadBasedPatternPeer child_2 = peer_.addOptionBackThreadBasedOfFindTargetForTarget(nodeLayerNameToken_1.getStringValue(), nodeLayerNameToken_1.getLineNumber(), nodeLayerNameToken_1.getCharacterNumber(), childNameToken_3.getStringValue(), childNameToken_3.getLineNumber(), childNameToken_3.getCharacterNumber());
					if(child_2 != null) {
						element.updateConstruction(new AllDecodersSkeleton.BackThreadBasedDecoder(child_2));
						child_2.end();
					}
				}
				if(type == 5) {
					org.ffd2.austenx.runtime.BaseToken nodeLayerNameToken_2 = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken childNameToken_4 = element.getBaseArgumentToken(2);
					FindTargetPeer.ThreadBasedPatternPeer child_3 = peer_.addOptionThreadBasedOfFindTargetForTarget(nodeLayerNameToken_2.getStringValue(), nodeLayerNameToken_2.getLineNumber(), nodeLayerNameToken_2.getCharacterNumber(), childNameToken_4.getStringValue(), childNameToken_4.getLineNumber(), childNameToken_4.getCharacterNumber());
					if(child_3 != null) {
						element.updateConstruction(new AllDecodersSkeleton.ThreadBasedDecoder(child_3));
						child_3.end();
					}
				}
			}
			if(index == 1) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					SearchQueryPeer.Indirect indirect = peer_.getSearchQueryForQuery();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken resultFieldToken = element.getBaseArgumentToken(0);
						SearchQueryPeer.MatchVariablePatternPeer child_4 = indirect.createMatchVariable(resultFieldToken.getStringValue(), resultFieldToken.getLineNumber(), resultFieldToken.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MatchVariableDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type_1 == 1) {
					SearchQueryPeer.Indirect indirect_1 = peer_.getSearchQueryForQuery();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken resultFieldToken_1 = element.getBaseArgumentToken(0);
						indirect_1.createMatchThis(resultFieldToken_1.getStringValue(), resultFieldToken_1.getLineNumber(), resultFieldToken_1.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class VariableBasedDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final FindTargetPeer.VariableBasedPatternPeer peer_;
		public VariableBasedDecoder(FindTargetPeer.VariableBasedPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 1) {
				peer_.addVariableName(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
		}
	}
	public static final class RootBasedDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final FindTargetPeer.RootBasedPatternPeer peer_;
		public RootBasedDecoder(FindTargetPeer.RootBasedPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				DesignTypePatternPeer child = peer_.addDesignTypeForResultType();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.DesignTypeDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class BackThreadBasedDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final FindTargetPeer.BackThreadBasedPatternPeer peer_;
		public BackThreadBasedDecoder(FindTargetPeer.BackThreadBasedPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				BuilderVariableChainPatternPeer child = peer_.addBuilderVariableChainForVariableChain();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.BuilderVariableChainDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class ThreadBasedDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final FindTargetPeer.ThreadBasedPatternPeer peer_;
		public ThreadBasedDecoder(FindTargetPeer.ThreadBasedPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 1) {
				peer_.addVariableName(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
		}
	}
	public static final class MatchVariableDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final SearchQueryPeer.MatchVariablePatternPeer peer_;
		public MatchVariableDecoder(SearchQueryPeer.MatchVariablePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				BuilderVariableChainPatternPeer child = peer_.addBuilderVariableChainForVariable();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.BuilderVariableChainDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class LinkDecoder_2 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final GlobalElementPeer.LinkPatternPeer peer_;
		public LinkDecoder_2(GlobalElementPeer.LinkPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				LinkChainPatternPeer child = peer_.addLinkChainForSingleChain();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.LinkChainDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				DeferredGlobalElement tool = new DeferredGlobalElementImpl(element);
				peer_.setGlobalElementForElement(tool);
			}
		}
	}
	public static final class MethodDecoder_2 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final GlobalElementPeer.MethodPatternPeer peer_;
		public MethodDecoder_2(GlobalElementPeer.MethodPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(1);
				GlobalMethodDefinitionPatternPeer child = peer_.addGlobalMethodDefinitionForDefinition(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.GlobalMethodDefinitionDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class GlobalMethodDefinitionDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final GlobalMethodDefinitionPatternPeer peer_;
		public GlobalMethodDefinitionDecoder(GlobalMethodDefinitionPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addIsStatic();
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken typeNameToken = element.getBaseArgumentToken(0);
				TargetTypeReferencePatternPeer child = peer_.addTargetTypeReferenceForReturnType(typeNameToken.getStringValue(), typeNameToken.getLineNumber(), typeNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeReferenceDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				ChainHookListPatternPeer child_1 = peer_.addChainHookListForChainHookList();
				if(child_1 != null) {
					element.updateConstruction(new AllDecodersSkeleton.ChainHookListDecoder(child_1));
					child_1.end();
				}
			}
		}
	}
	public static final class GlobalClassDefinitionDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final GlobalClassDefinitionPatternPeer peer_;
		public GlobalClassDefinitionDecoder(GlobalClassDefinitionPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					GlobalElementPeer.Indirect indirect = peer_.getGlobalElementForElements();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						GlobalElementPeer.LinkPatternPeer child = indirect.createLink(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkDecoder_2(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					GlobalElementPeer.Indirect indirect_1 = peer_.getGlobalElementForElements();
					if(indirect_1 != null) {
						GlobalElementPeer.MethodPatternPeer child_1 = indirect_1.createMethod();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MethodDecoder_2(child_1));
							child_1.end();
						}
					}
				}
			}
		}
	}
	public static final class JavaPrototypeDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaPrototypePatternPeer peer_;
		public JavaPrototypeDecoder(JavaPrototypePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 1) {
				peer_.addIsFinal(token.getLineNumber(), token.getCharacterNumber());
			}
			if(index == 2) {
				peer_.addIsStatic(token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken typeNameToken = element.getBaseArgumentToken(0);
				TargetTypeReferencePatternPeer child = peer_.addTargetTypeReferenceForReturnType(typeNameToken.getStringValue(), typeNameToken.getLineNumber(), typeNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeReferenceDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				int type = element.getType();
				if(type == 0) {
					NamePeer.BasicPatternPeer child_1 = peer_.addOptionBasicOfNameForNameOutput();
					if(child_1 != null) {
						element.updateConstruction(new AllDecodersSkeleton.BasicDecoder_1(child_1));
						child_1.end();
					}
				}
				if(type == 1) {
					org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken classNameToken = element.getBaseArgumentToken(1);
					org.ffd2.austenx.runtime.BaseToken methodNameToken = element.getBaseArgumentToken(2);
					peer_.addOptionImplementsOfNameForNameOutput(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), classNameToken.getStringValue(), methodNameToken.getStringValue(), methodNameToken.getLineNumber(), methodNameToken.getCharacterNumber());
				}
			}
			if(index == 2) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					TargetParameterPeer.Indirect indirect = peer_.getTargetParameterForParameter();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
						TargetParameterPeer.SimplePatternPeer child_2 = indirect.createSimple(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SimpleDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type_1 == 1) {
					TargetParameterPeer.Indirect indirect_1 = peer_.getTargetParameterForParameter();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						TargetParameterPeer.LinkPatternPeer child_3 = indirect_1.createLink(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkDecoder_5(child_3));
							child_3.end();
						}
					}
				}
				if(type_1 == 2) {
					TargetParameterPeer.Indirect indirect_2 = peer_.getTargetParameterForParameter();
					if(indirect_2 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_2.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
			if(index == 3) {
				TargetTypeListPatternPeer child_4 = peer_.addTargetTypeListForThrowsList();
				if(child_4 != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeListDecoder(child_4));
					child_4.end();
				}
			}
			if(index == 4) {
				SetsListPatternPeer child_5 = peer_.addSetsListForMethodSets();
				if(child_5 != null) {
					element.updateConstruction(new AllDecodersSkeleton.SetsListDecoder(child_5));
					child_5.end();
				}
			}
		}
	}
	public static final class JavaMethodDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaMethodPatternPeer peer_;
		public JavaMethodDecoder(JavaMethodPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addIsPublic(token.getLineNumber(), token.getCharacterNumber());
			}
			if(index == 1) {
				peer_.addIsPrivate(token.getLineNumber(), token.getCharacterNumber());
			}
			if(index == 2) {
				peer_.addIsFinal(token.getLineNumber(), token.getCharacterNumber());
			}
			if(index == 3) {
				peer_.addIsStatic(token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken typeNameToken = element.getBaseArgumentToken(0);
				TargetTypeReferencePatternPeer child = peer_.addTargetTypeReferenceForReturnType(typeNameToken.getStringValue(), typeNameToken.getLineNumber(), typeNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeReferenceDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				ChainHookListPatternPeer child_1 = peer_.addChainHookListForChainHookList();
				if(child_1 != null) {
					element.updateConstruction(new AllDecodersSkeleton.ChainHookListDecoder(child_1));
					child_1.end();
				}
			}
			if(index == 2) {
				int type = element.getType();
				if(type == 0) {
					NamePeer.BasicPatternPeer child_2 = peer_.addOptionBasicOfNameForNameOutput();
					if(child_2 != null) {
						element.updateConstruction(new AllDecodersSkeleton.BasicDecoder_1(child_2));
						child_2.end();
					}
				}
				if(type == 1) {
					org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken classNameToken = element.getBaseArgumentToken(1);
					org.ffd2.austenx.runtime.BaseToken methodNameToken = element.getBaseArgumentToken(2);
					peer_.addOptionImplementsOfNameForNameOutput(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), classNameToken.getStringValue(), methodNameToken.getStringValue(), methodNameToken.getLineNumber(), methodNameToken.getCharacterNumber());
				}
			}
			if(index == 3) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					TargetParameterPeer.Indirect indirect = peer_.getTargetParameterForParameter();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
						TargetParameterPeer.SimplePatternPeer child_3 = indirect.createSimple(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SimpleDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type_1 == 1) {
					TargetParameterPeer.Indirect indirect_1 = peer_.getTargetParameterForParameter();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						TargetParameterPeer.LinkPatternPeer child_4 = indirect_1.createLink(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkDecoder_5(child_4));
							child_4.end();
						}
					}
				}
				if(type_1 == 2) {
					TargetParameterPeer.Indirect indirect_2 = peer_.getTargetParameterForParameter();
					if(indirect_2 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_2.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
			if(index == 4) {
				TargetTypeListPatternPeer child_5 = peer_.addTargetTypeListForThrowsList();
				if(child_5 != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeListDecoder(child_5));
					child_5.end();
				}
			}
			if(index == 5) {
				SetsListPatternPeer child_6 = peer_.addSetsListForMethodSets();
				if(child_6 != null) {
					element.updateConstruction(new AllDecodersSkeleton.SetsListDecoder(child_6));
					child_6.end();
				}
			}
			if(index == 6) {
				JavaCodeBlockPatternPeer child_7 = peer_.addJavaCodeBlockForCode();
				if(child_7 != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaCodeBlockDecoder(child_7));
					child_7.end();
				}
			}
		}
	}
	public static final class JavaConstructorDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaConstructorPatternPeer peer_;
		public JavaConstructorDecoder(JavaConstructorPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					TargetParameterPeer.Indirect indirect = peer_.getTargetParameterForParameter();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
						TargetParameterPeer.SimplePatternPeer child = indirect.createSimple(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.SimpleDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					TargetParameterPeer.Indirect indirect_1 = peer_.getTargetParameterForParameter();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						TargetParameterPeer.LinkPatternPeer child_1 = indirect_1.createLink(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkDecoder_5(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					TargetParameterPeer.Indirect indirect_2 = peer_.getTargetParameterForParameter();
					if(indirect_2 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_2.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
			if(index == 1) {
				TargetTypeListPatternPeer child_2 = peer_.addTargetTypeListForThrowsList();
				if(child_2 != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeListDecoder(child_2));
					child_2.end();
				}
			}
			if(index == 2) {
				JavaCodeBlockPatternPeer child_3 = peer_.addJavaCodeBlockForCode();
				if(child_3 != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaCodeBlockDecoder(child_3));
					child_3.end();
				}
			}
		}
	}
	public static final class JavaCodeBlockDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaCodeBlockPatternPeer peer_;
		public JavaCodeBlockDecoder(JavaCodeBlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaStatementPeer.Indirect indirect = peer_.getJavaStatementForStatement();
					if(indirect != null) {
						JavaStatementPeer.BlockPatternPeer child = indirect.createBlock();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.BlockDecoder_1(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaStatementPeer.Indirect indirect_1 = peer_.getJavaStatementForStatement();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(1);
						JavaStatementPeer.DeclarationPatternPeer child_1 = indirect_1.createDeclaration(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.DeclarationDecoder_1(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaStatementPeer.Indirect indirect_2 = peer_.getJavaStatementForStatement();
					if(indirect_2 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaStatementPeer.IfPatternPeer child_2 = indirect_2.createIf(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.IfDecoder_1(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaStatementPeer.Indirect indirect_3 = peer_.getJavaStatementForStatement();
					if(indirect_3 != null) {
						org.ffd2.austenx.runtime.BaseToken noteToken = element.getBaseArgumentToken(0);
						indirect_3.createNote(noteToken.getStringValue());
					}
				}
				if(type == 4) {
					JavaStatementPeer.Indirect indirect_4 = peer_.getJavaStatementForStatement();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ForPatternPeer child_3 = indirect_4.createFor(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ForDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 5) {
					JavaStatementPeer.Indirect indirect_5 = peer_.getJavaStatementForStatement();
					if(indirect_5 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaStatementPeer.WhilePatternPeer child_4 = indirect_5.createWhile(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.WhileDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 6) {
					JavaStatementPeer.Indirect indirect_6 = peer_.getJavaStatementForStatement();
					if(indirect_6 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_6.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
				if(type == 7) {
					JavaStatementPeer.Indirect indirect_7 = peer_.getJavaStatementForStatement();
					if(indirect_7 != null) {
						JavaStatementPeer.MacroCallPatternPeer child_5 = indirect_7.createMacroCall();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroCallDecoder_2(child_5));
							child_5.end();
						}
					}
				}
				if(type == 8) {
					JavaStatementPeer.Indirect indirect_8 = peer_.getJavaStatementForStatement();
					if(indirect_8 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken = element.getBaseArgumentToken(0);
						JavaStatementPeer.ExpressionVarPatternPeer child_6 = indirect_8.createExpressionVar(variableNameToken.getStringValue(), variableNameToken.getLineNumber(), variableNameToken.getCharacterNumber());
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ExpressionVarDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 9) {
					JavaStatementPeer.Indirect indirect_9 = peer_.getJavaStatementForStatement();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken_1 = element.getBaseArgumentToken(0);
						JavaStatementPeer.StatementVarPatternPeer child_7 = indirect_9.createStatementVar(variableNameToken_1.getStringValue(), variableNameToken_1.getLineNumber(), variableNameToken_1.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.StatementVarDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 10) {
					JavaStatementPeer.Indirect indirect_10 = peer_.getJavaStatementForStatement();
					if(indirect_10 != null) {
						JavaStatementPeer.FindPatternPeer child_8 = indirect_10.createFind();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.FindDecoder_2(child_8));
							child_8.end();
						}
					}
				}
				if(type == 11) {
					JavaStatementPeer.Indirect indirect_11 = peer_.getJavaStatementForStatement();
					if(indirect_11 != null) {
						JavaStatementPeer.LinkBlockPatternPeer child_9 = indirect_11.createLinkBlock();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkBlockDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 12) {
					JavaStatementPeer.Indirect indirect_12 = peer_.getJavaStatementForStatement();
					if(indirect_12 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						indirect_12.createReturnSimple(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
					}
				}
				if(type == 13) {
					JavaStatementPeer.Indirect indirect_13 = peer_.getJavaStatementForStatement();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ReturnPatternPeer child_10 = indirect_13.createReturn(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ReturnDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 14) {
					JavaStatementPeer.Indirect indirect_14 = peer_.getJavaStatementForStatement();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ThrowPatternPeer child_11 = indirect_14.createThrow(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ThrowDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 15) {
					JavaStatementPeer.Indirect indirect_15 = peer_.getJavaStatementForStatement();
					if(indirect_15 != null) {
						JavaStatementPeer.ExpressionPatternPeer child_12 = indirect_15.createExpression();
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ExpressionDecoder_1(child_12));
							child_12.end();
						}
					}
				}
				if(type == 16) {
					JavaStatementPeer.Indirect indirect_16 = peer_.getJavaStatementForStatement();
					if(indirect_16 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						JavaStatementPeer.SyncPatternPeer child_13 = indirect_16.createSync(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
						if(child_13 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SyncDecoder(child_13));
							child_13.end();
						}
					}
				}
				if(type == 17) {
					JavaStatementPeer.Indirect indirect_17 = peer_.getJavaStatementForStatement();
					if(indirect_17 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken_2 = element.getBaseArgumentToken(0);
						JavaStatementPeer.SetPatternPeer child_14 = indirect_17.createSet(variableNameToken_2.getStringValue(), variableNameToken_2.getLineNumber(), variableNameToken_2.getCharacterNumber());
						if(child_14 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SetDecoder(child_14));
							child_14.end();
						}
					}
				}
			}
		}
	}
	public static final class DeclarationDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ForInitialStatementPeer.DeclarationPatternPeer peer_;
		public DeclarationDecoder(ForInitialStatementPeer.DeclarationPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken typeNameToken = element.getBaseArgumentToken(0);
				TargetTypeReferencePatternPeer child = peer_.addTargetTypeReferenceForType(typeNameToken.getStringValue(), typeNameToken.getLineNumber(), typeNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeReferenceDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				int type = element.getType();
				if(type == 0) {
					NamePeer.BasicPatternPeer child_1 = peer_.addOptionBasicOfNameForNameOutput();
					if(child_1 != null) {
						element.updateConstruction(new AllDecodersSkeleton.BasicDecoder_1(child_1));
						child_1.end();
					}
				}
				if(type == 1) {
					org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken classNameToken = element.getBaseArgumentToken(1);
					org.ffd2.austenx.runtime.BaseToken methodNameToken = element.getBaseArgumentToken(2);
					peer_.addOptionImplementsOfNameForNameOutput(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), classNameToken.getStringValue(), methodNameToken.getStringValue(), methodNameToken.getLineNumber(), methodNameToken.getCharacterNumber());
				}
			}
			if(index == 2) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForInitialValue();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child_2 = indirect.createBinary();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type_1 == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForInitialValue();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_3 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type_1 == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForInitialValue();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_4 = indirect_2.createPostUnary();
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type_1 == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForInitialValue();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_5 = indirect_3.createPreUnary();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type_1 == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForInitialValue();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_6 = indirect_4.createAssignment(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type_1 == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForInitialValue();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_7 = indirect_5.createMappingVariableRef();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type_1 == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForInitialValue();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_8 = indirect_6.createCall();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type_1 == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForInitialValue();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_9 = indirect_7.createBracketed(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type_1 == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForInitialValue();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_10 = indirect_8.createBuilderVariableRef();
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type_1 == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForInitialValue();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_11 = indirect_9.createArrayConstructorCall(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type_1 == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForInitialValue();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_12 = indirect_10.createGivenArray(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_12));
							child_12.end();
						}
					}
				}
				if(type_1 == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForInitialValue();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_13 = indirect_11.createConstructorCall(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
						if(child_13 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_13));
							child_13.end();
						}
					}
				}
				if(type_1 == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForInitialValue();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_14 = indirect_12.createPrimitive();
						if(child_14 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_14));
							child_14.end();
						}
					}
				}
				if(type_1 == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForInitialValue();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type_1 == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForInitialValue();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_7 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_7.getLineNumber(), keywordToken_7.getCharacterNumber());
					}
				}
				if(type_1 == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForInitialValue();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class ExpressionDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ForInitialStatementPeer.ExpressionPatternPeer peer_;
		public ExpressionDecoder(ForInitialStatementPeer.ExpressionPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForValue();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child = indirect.createBinary();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForValue();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_1 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForValue();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_2 = indirect_2.createPostUnary();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForValue();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_3 = indirect_3.createPreUnary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForValue();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_4 = indirect_4.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForValue();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_5 = indirect_5.createMappingVariableRef();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForValue();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_6 = indirect_6.createCall();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForValue();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_7 = indirect_7.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForValue();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_8 = indirect_8.createBuilderVariableRef();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForValue();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_9 = indirect_9.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForValue();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_10 = indirect_10.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForValue();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_11 = indirect_11.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForValue();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_12 = indirect_12.createPrimitive();
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_12));
							child_12.end();
						}
					}
				}
				if(type == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForValue();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForValue();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForValue();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class BlockDecoder_1 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaStatementPeer.BlockPatternPeer peer_;
		public BlockDecoder_1(JavaStatementPeer.BlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				JavaCodeBlockPatternPeer child = peer_.addJavaCodeBlockForValue();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaCodeBlockDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class DeclarationDecoder_1 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaStatementPeer.DeclarationPatternPeer peer_;
		public DeclarationDecoder_1(JavaStatementPeer.DeclarationPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addIsFinal();
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken typeNameToken = element.getBaseArgumentToken(0);
				TargetTypeReferencePatternPeer child = peer_.addTargetTypeReferenceForType(typeNameToken.getStringValue(), typeNameToken.getLineNumber(), typeNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeReferenceDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				int type = element.getType();
				if(type == 0) {
					NamePeer.BasicPatternPeer child_1 = peer_.addOptionBasicOfNameForNameOutput();
					if(child_1 != null) {
						element.updateConstruction(new AllDecodersSkeleton.BasicDecoder_1(child_1));
						child_1.end();
					}
				}
				if(type == 1) {
					org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken classNameToken = element.getBaseArgumentToken(1);
					org.ffd2.austenx.runtime.BaseToken methodNameToken = element.getBaseArgumentToken(2);
					peer_.addOptionImplementsOfNameForNameOutput(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), classNameToken.getStringValue(), methodNameToken.getStringValue(), methodNameToken.getLineNumber(), methodNameToken.getCharacterNumber());
				}
			}
			if(index == 2) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForInitialValue();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child_2 = indirect.createBinary();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type_1 == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForInitialValue();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_3 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type_1 == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForInitialValue();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_4 = indirect_2.createPostUnary();
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type_1 == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForInitialValue();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_5 = indirect_3.createPreUnary();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type_1 == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForInitialValue();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_6 = indirect_4.createAssignment(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type_1 == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForInitialValue();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_7 = indirect_5.createMappingVariableRef();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type_1 == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForInitialValue();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_8 = indirect_6.createCall();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type_1 == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForInitialValue();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_9 = indirect_7.createBracketed(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type_1 == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForInitialValue();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_10 = indirect_8.createBuilderVariableRef();
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type_1 == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForInitialValue();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_11 = indirect_9.createArrayConstructorCall(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type_1 == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForInitialValue();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_12 = indirect_10.createGivenArray(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_12));
							child_12.end();
						}
					}
				}
				if(type_1 == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForInitialValue();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_13 = indirect_11.createConstructorCall(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
						if(child_13 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_13));
							child_13.end();
						}
					}
				}
				if(type_1 == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForInitialValue();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_14 = indirect_12.createPrimitive();
						if(child_14 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_14));
							child_14.end();
						}
					}
				}
				if(type_1 == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForInitialValue();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type_1 == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForInitialValue();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_7 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_7.getLineNumber(), keywordToken_7.getCharacterNumber());
					}
				}
				if(type_1 == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForInitialValue();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class IfDecoder_1 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaStatementPeer.IfPatternPeer peer_;
		public IfDecoder_1(JavaStatementPeer.IfPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForConditional();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child = indirect.createBinary();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForConditional();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_1 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForConditional();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_2 = indirect_2.createPostUnary();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForConditional();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_3 = indirect_3.createPreUnary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForConditional();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_4 = indirect_4.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForConditional();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_5 = indirect_5.createMappingVariableRef();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForConditional();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_6 = indirect_6.createCall();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForConditional();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_7 = indirect_7.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForConditional();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_8 = indirect_8.createBuilderVariableRef();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForConditional();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_9 = indirect_9.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForConditional();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_10 = indirect_10.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForConditional();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_11 = indirect_11.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForConditional();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_12 = indirect_12.createPrimitive();
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_12));
							child_12.end();
						}
					}
				}
				if(type == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForConditional();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForConditional();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForConditional();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
			if(index == 1) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					JavaStatementPeer.Indirect indirect_16 = peer_.getJavaStatementForTrueStatement();
					if(indirect_16 != null) {
						JavaStatementPeer.BlockPatternPeer child_13 = indirect_16.createBlock();
						if(child_13 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BlockDecoder_1(child_13));
							child_13.end();
						}
					}
				}
				if(type_1 == 1) {
					JavaStatementPeer.Indirect indirect_17 = peer_.getJavaStatementForTrueStatement();
					if(indirect_17 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(1);
						JavaStatementPeer.DeclarationPatternPeer child_14 = indirect_17.createDeclaration(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
						if(child_14 != null) {
							element.updateConstruction(new AllDecodersSkeleton.DeclarationDecoder_1(child_14));
							child_14.end();
						}
					}
				}
				if(type_1 == 2) {
					JavaStatementPeer.Indirect indirect_18 = peer_.getJavaStatementForTrueStatement();
					if(indirect_18 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_7 = element.getBaseArgumentToken(0);
						JavaStatementPeer.IfPatternPeer child_15 = indirect_18.createIf(keywordToken_7.getLineNumber(), keywordToken_7.getCharacterNumber());
						if(child_15 != null) {
							element.updateConstruction(new AllDecodersSkeleton.IfDecoder_1(child_15));
							child_15.end();
						}
					}
				}
				if(type_1 == 3) {
					JavaStatementPeer.Indirect indirect_19 = peer_.getJavaStatementForTrueStatement();
					if(indirect_19 != null) {
						org.ffd2.austenx.runtime.BaseToken noteToken = element.getBaseArgumentToken(0);
						indirect_19.createNote(noteToken.getStringValue());
					}
				}
				if(type_1 == 4) {
					JavaStatementPeer.Indirect indirect_20 = peer_.getJavaStatementForTrueStatement();
					if(indirect_20 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_8 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ForPatternPeer child_16 = indirect_20.createFor(keywordToken_8.getLineNumber(), keywordToken_8.getCharacterNumber());
						if(child_16 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ForDecoder(child_16));
							child_16.end();
						}
					}
				}
				if(type_1 == 5) {
					JavaStatementPeer.Indirect indirect_21 = peer_.getJavaStatementForTrueStatement();
					if(indirect_21 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_9 = element.getBaseArgumentToken(0);
						JavaStatementPeer.WhilePatternPeer child_17 = indirect_21.createWhile(keywordToken_9.getLineNumber(), keywordToken_9.getCharacterNumber());
						if(child_17 != null) {
							element.updateConstruction(new AllDecodersSkeleton.WhileDecoder(child_17));
							child_17.end();
						}
					}
				}
				if(type_1 == 6) {
					JavaStatementPeer.Indirect indirect_22 = peer_.getJavaStatementForTrueStatement();
					if(indirect_22 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken_1 = element.getBaseArgumentToken(0);
						indirect_22.createMark(markNameToken_1.getStringValue(), markNameToken_1.getLineNumber(), markNameToken_1.getCharacterNumber());
					}
				}
				if(type_1 == 7) {
					JavaStatementPeer.Indirect indirect_23 = peer_.getJavaStatementForTrueStatement();
					if(indirect_23 != null) {
						JavaStatementPeer.MacroCallPatternPeer child_18 = indirect_23.createMacroCall();
						if(child_18 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroCallDecoder_2(child_18));
							child_18.end();
						}
					}
				}
				if(type_1 == 8) {
					JavaStatementPeer.Indirect indirect_24 = peer_.getJavaStatementForTrueStatement();
					if(indirect_24 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken = element.getBaseArgumentToken(0);
						JavaStatementPeer.ExpressionVarPatternPeer child_19 = indirect_24.createExpressionVar(variableNameToken.getStringValue(), variableNameToken.getLineNumber(), variableNameToken.getCharacterNumber());
						if(child_19 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ExpressionVarDecoder(child_19));
							child_19.end();
						}
					}
				}
				if(type_1 == 9) {
					JavaStatementPeer.Indirect indirect_25 = peer_.getJavaStatementForTrueStatement();
					if(indirect_25 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken_1 = element.getBaseArgumentToken(0);
						JavaStatementPeer.StatementVarPatternPeer child_20 = indirect_25.createStatementVar(variableNameToken_1.getStringValue(), variableNameToken_1.getLineNumber(), variableNameToken_1.getCharacterNumber());
						if(child_20 != null) {
							element.updateConstruction(new AllDecodersSkeleton.StatementVarDecoder(child_20));
							child_20.end();
						}
					}
				}
				if(type_1 == 10) {
					JavaStatementPeer.Indirect indirect_26 = peer_.getJavaStatementForTrueStatement();
					if(indirect_26 != null) {
						JavaStatementPeer.FindPatternPeer child_21 = indirect_26.createFind();
						if(child_21 != null) {
							element.updateConstruction(new AllDecodersSkeleton.FindDecoder_2(child_21));
							child_21.end();
						}
					}
				}
				if(type_1 == 11) {
					JavaStatementPeer.Indirect indirect_27 = peer_.getJavaStatementForTrueStatement();
					if(indirect_27 != null) {
						JavaStatementPeer.LinkBlockPatternPeer child_22 = indirect_27.createLinkBlock();
						if(child_22 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkBlockDecoder(child_22));
							child_22.end();
						}
					}
				}
				if(type_1 == 12) {
					JavaStatementPeer.Indirect indirect_28 = peer_.getJavaStatementForTrueStatement();
					if(indirect_28 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_10 = element.getBaseArgumentToken(0);
						indirect_28.createReturnSimple(keywordToken_10.getLineNumber(), keywordToken_10.getCharacterNumber());
					}
				}
				if(type_1 == 13) {
					JavaStatementPeer.Indirect indirect_29 = peer_.getJavaStatementForTrueStatement();
					if(indirect_29 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_11 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ReturnPatternPeer child_23 = indirect_29.createReturn(keywordToken_11.getLineNumber(), keywordToken_11.getCharacterNumber());
						if(child_23 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ReturnDecoder(child_23));
							child_23.end();
						}
					}
				}
				if(type_1 == 14) {
					JavaStatementPeer.Indirect indirect_30 = peer_.getJavaStatementForTrueStatement();
					if(indirect_30 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_12 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ThrowPatternPeer child_24 = indirect_30.createThrow(keywordToken_12.getLineNumber(), keywordToken_12.getCharacterNumber());
						if(child_24 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ThrowDecoder(child_24));
							child_24.end();
						}
					}
				}
				if(type_1 == 15) {
					JavaStatementPeer.Indirect indirect_31 = peer_.getJavaStatementForTrueStatement();
					if(indirect_31 != null) {
						JavaStatementPeer.ExpressionPatternPeer child_25 = indirect_31.createExpression();
						if(child_25 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ExpressionDecoder_1(child_25));
							child_25.end();
						}
					}
				}
				if(type_1 == 16) {
					JavaStatementPeer.Indirect indirect_32 = peer_.getJavaStatementForTrueStatement();
					if(indirect_32 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_13 = element.getBaseArgumentToken(0);
						JavaStatementPeer.SyncPatternPeer child_26 = indirect_32.createSync(keywordToken_13.getLineNumber(), keywordToken_13.getCharacterNumber());
						if(child_26 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SyncDecoder(child_26));
							child_26.end();
						}
					}
				}
				if(type_1 == 17) {
					JavaStatementPeer.Indirect indirect_33 = peer_.getJavaStatementForTrueStatement();
					if(indirect_33 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken_2 = element.getBaseArgumentToken(0);
						JavaStatementPeer.SetPatternPeer child_27 = indirect_33.createSet(variableNameToken_2.getStringValue(), variableNameToken_2.getLineNumber(), variableNameToken_2.getCharacterNumber());
						if(child_27 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SetDecoder(child_27));
							child_27.end();
						}
					}
				}
			}
			if(index == 2) {
				int type_2 = element.getType();
				if(type_2 == 0) {
					JavaStatementPeer.Indirect indirect_34 = peer_.getJavaStatementForFalseStatement();
					if(indirect_34 != null) {
						JavaStatementPeer.BlockPatternPeer child_28 = indirect_34.createBlock();
						if(child_28 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BlockDecoder_1(child_28));
							child_28.end();
						}
					}
				}
				if(type_2 == 1) {
					JavaStatementPeer.Indirect indirect_35 = peer_.getJavaStatementForFalseStatement();
					if(indirect_35 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(1);
						JavaStatementPeer.DeclarationPatternPeer child_29 = indirect_35.createDeclaration(nameToken_1.getStringValue(), nameToken_1.getLineNumber(), nameToken_1.getCharacterNumber());
						if(child_29 != null) {
							element.updateConstruction(new AllDecodersSkeleton.DeclarationDecoder_1(child_29));
							child_29.end();
						}
					}
				}
				if(type_2 == 2) {
					JavaStatementPeer.Indirect indirect_36 = peer_.getJavaStatementForFalseStatement();
					if(indirect_36 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_14 = element.getBaseArgumentToken(0);
						JavaStatementPeer.IfPatternPeer child_30 = indirect_36.createIf(keywordToken_14.getLineNumber(), keywordToken_14.getCharacterNumber());
						if(child_30 != null) {
							element.updateConstruction(new AllDecodersSkeleton.IfDecoder_1(child_30));
							child_30.end();
						}
					}
				}
				if(type_2 == 3) {
					JavaStatementPeer.Indirect indirect_37 = peer_.getJavaStatementForFalseStatement();
					if(indirect_37 != null) {
						org.ffd2.austenx.runtime.BaseToken noteToken_1 = element.getBaseArgumentToken(0);
						indirect_37.createNote(noteToken_1.getStringValue());
					}
				}
				if(type_2 == 4) {
					JavaStatementPeer.Indirect indirect_38 = peer_.getJavaStatementForFalseStatement();
					if(indirect_38 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_15 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ForPatternPeer child_31 = indirect_38.createFor(keywordToken_15.getLineNumber(), keywordToken_15.getCharacterNumber());
						if(child_31 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ForDecoder(child_31));
							child_31.end();
						}
					}
				}
				if(type_2 == 5) {
					JavaStatementPeer.Indirect indirect_39 = peer_.getJavaStatementForFalseStatement();
					if(indirect_39 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_16 = element.getBaseArgumentToken(0);
						JavaStatementPeer.WhilePatternPeer child_32 = indirect_39.createWhile(keywordToken_16.getLineNumber(), keywordToken_16.getCharacterNumber());
						if(child_32 != null) {
							element.updateConstruction(new AllDecodersSkeleton.WhileDecoder(child_32));
							child_32.end();
						}
					}
				}
				if(type_2 == 6) {
					JavaStatementPeer.Indirect indirect_40 = peer_.getJavaStatementForFalseStatement();
					if(indirect_40 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken_2 = element.getBaseArgumentToken(0);
						indirect_40.createMark(markNameToken_2.getStringValue(), markNameToken_2.getLineNumber(), markNameToken_2.getCharacterNumber());
					}
				}
				if(type_2 == 7) {
					JavaStatementPeer.Indirect indirect_41 = peer_.getJavaStatementForFalseStatement();
					if(indirect_41 != null) {
						JavaStatementPeer.MacroCallPatternPeer child_33 = indirect_41.createMacroCall();
						if(child_33 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroCallDecoder_2(child_33));
							child_33.end();
						}
					}
				}
				if(type_2 == 8) {
					JavaStatementPeer.Indirect indirect_42 = peer_.getJavaStatementForFalseStatement();
					if(indirect_42 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken_3 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ExpressionVarPatternPeer child_34 = indirect_42.createExpressionVar(variableNameToken_3.getStringValue(), variableNameToken_3.getLineNumber(), variableNameToken_3.getCharacterNumber());
						if(child_34 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ExpressionVarDecoder(child_34));
							child_34.end();
						}
					}
				}
				if(type_2 == 9) {
					JavaStatementPeer.Indirect indirect_43 = peer_.getJavaStatementForFalseStatement();
					if(indirect_43 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken_4 = element.getBaseArgumentToken(0);
						JavaStatementPeer.StatementVarPatternPeer child_35 = indirect_43.createStatementVar(variableNameToken_4.getStringValue(), variableNameToken_4.getLineNumber(), variableNameToken_4.getCharacterNumber());
						if(child_35 != null) {
							element.updateConstruction(new AllDecodersSkeleton.StatementVarDecoder(child_35));
							child_35.end();
						}
					}
				}
				if(type_2 == 10) {
					JavaStatementPeer.Indirect indirect_44 = peer_.getJavaStatementForFalseStatement();
					if(indirect_44 != null) {
						JavaStatementPeer.FindPatternPeer child_36 = indirect_44.createFind();
						if(child_36 != null) {
							element.updateConstruction(new AllDecodersSkeleton.FindDecoder_2(child_36));
							child_36.end();
						}
					}
				}
				if(type_2 == 11) {
					JavaStatementPeer.Indirect indirect_45 = peer_.getJavaStatementForFalseStatement();
					if(indirect_45 != null) {
						JavaStatementPeer.LinkBlockPatternPeer child_37 = indirect_45.createLinkBlock();
						if(child_37 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkBlockDecoder(child_37));
							child_37.end();
						}
					}
				}
				if(type_2 == 12) {
					JavaStatementPeer.Indirect indirect_46 = peer_.getJavaStatementForFalseStatement();
					if(indirect_46 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_17 = element.getBaseArgumentToken(0);
						indirect_46.createReturnSimple(keywordToken_17.getLineNumber(), keywordToken_17.getCharacterNumber());
					}
				}
				if(type_2 == 13) {
					JavaStatementPeer.Indirect indirect_47 = peer_.getJavaStatementForFalseStatement();
					if(indirect_47 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_18 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ReturnPatternPeer child_38 = indirect_47.createReturn(keywordToken_18.getLineNumber(), keywordToken_18.getCharacterNumber());
						if(child_38 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ReturnDecoder(child_38));
							child_38.end();
						}
					}
				}
				if(type_2 == 14) {
					JavaStatementPeer.Indirect indirect_48 = peer_.getJavaStatementForFalseStatement();
					if(indirect_48 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_19 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ThrowPatternPeer child_39 = indirect_48.createThrow(keywordToken_19.getLineNumber(), keywordToken_19.getCharacterNumber());
						if(child_39 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ThrowDecoder(child_39));
							child_39.end();
						}
					}
				}
				if(type_2 == 15) {
					JavaStatementPeer.Indirect indirect_49 = peer_.getJavaStatementForFalseStatement();
					if(indirect_49 != null) {
						JavaStatementPeer.ExpressionPatternPeer child_40 = indirect_49.createExpression();
						if(child_40 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ExpressionDecoder_1(child_40));
							child_40.end();
						}
					}
				}
				if(type_2 == 16) {
					JavaStatementPeer.Indirect indirect_50 = peer_.getJavaStatementForFalseStatement();
					if(indirect_50 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_20 = element.getBaseArgumentToken(0);
						JavaStatementPeer.SyncPatternPeer child_41 = indirect_50.createSync(keywordToken_20.getLineNumber(), keywordToken_20.getCharacterNumber());
						if(child_41 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SyncDecoder(child_41));
							child_41.end();
						}
					}
				}
				if(type_2 == 17) {
					JavaStatementPeer.Indirect indirect_51 = peer_.getJavaStatementForFalseStatement();
					if(indirect_51 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken_5 = element.getBaseArgumentToken(0);
						JavaStatementPeer.SetPatternPeer child_42 = indirect_51.createSet(variableNameToken_5.getStringValue(), variableNameToken_5.getLineNumber(), variableNameToken_5.getCharacterNumber());
						if(child_42 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SetDecoder(child_42));
							child_42.end();
						}
					}
				}
			}
		}
	}
	public static final class ForDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaStatementPeer.ForPatternPeer peer_;
		public ForDecoder(JavaStatementPeer.ForPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					ForInitialStatementPeer.Indirect indirect = peer_.getForInitialStatementForInitialStatement();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
						ForInitialStatementPeer.DeclarationPatternPeer child = indirect.createDeclaration(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.DeclarationDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					ForInitialStatementPeer.Indirect indirect_1 = peer_.getForInitialStatementForInitialStatement();
					if(indirect_1 != null) {
						ForInitialStatementPeer.ExpressionPatternPeer child_1 = indirect_1.createExpression();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ExpressionDecoder(child_1));
							child_1.end();
						}
					}
				}
			}
			if(index == 1) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForConditionalExpression();
					if(indirect_2 != null) {
						JavaExpressionPeer.BinaryPatternPeer child_2 = indirect_2.createBinary();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type_1 == 1) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForConditionalExpression();
					if(indirect_3 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_3 = indirect_3.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type_1 == 2) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForConditionalExpression();
					if(indirect_4 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_4 = indirect_4.createPostUnary();
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type_1 == 3) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForConditionalExpression();
					if(indirect_5 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_5 = indirect_5.createPreUnary();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type_1 == 4) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForConditionalExpression();
					if(indirect_6 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_6 = indirect_6.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type_1 == 5) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForConditionalExpression();
					if(indirect_7 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_7 = indirect_7.createMappingVariableRef();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type_1 == 6) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForConditionalExpression();
					if(indirect_8 != null) {
						JavaExpressionPeer.CallPatternPeer child_8 = indirect_8.createCall();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type_1 == 7) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForConditionalExpression();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_9 = indirect_9.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type_1 == 8) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForConditionalExpression();
					if(indirect_10 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_10 = indirect_10.createBuilderVariableRef();
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type_1 == 9) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForConditionalExpression();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_11 = indirect_11.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type_1 == 10) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForConditionalExpression();
					if(indirect_12 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_12 = indirect_12.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_12));
							child_12.end();
						}
					}
				}
				if(type_1 == 11) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForConditionalExpression();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_13 = indirect_13.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_13 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_13));
							child_13.end();
						}
					}
				}
				if(type_1 == 12) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForConditionalExpression();
					if(indirect_14 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_14 = indirect_14.createPrimitive();
						if(child_14 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_14));
							child_14.end();
						}
					}
				}
				if(type_1 == 13) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForConditionalExpression();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_15.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type_1 == 14) {
					JavaExpressionPeer.Indirect indirect_16 = peer_.getJavaExpressionForConditionalExpression();
					if(indirect_16 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_16.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type_1 == 15) {
					JavaExpressionPeer.Indirect indirect_17 = peer_.getJavaExpressionForConditionalExpression();
					if(indirect_17 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_17.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
			if(index == 2) {
				int type_2 = element.getType();
				if(type_2 == 0) {
					JavaExpressionPeer.Indirect indirect_18 = peer_.getJavaExpressionForRoundExpression();
					if(indirect_18 != null) {
						JavaExpressionPeer.BinaryPatternPeer child_15 = indirect_18.createBinary();
						if(child_15 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child_15));
							child_15.end();
						}
					}
				}
				if(type_2 == 1) {
					JavaExpressionPeer.Indirect indirect_19 = peer_.getJavaExpressionForRoundExpression();
					if(indirect_19 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_16 = indirect_19.createGeneralBinary(symbolToken_1.getLineNumber(), symbolToken_1.getCharacterNumber());
						if(child_16 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_16));
							child_16.end();
						}
					}
				}
				if(type_2 == 2) {
					JavaExpressionPeer.Indirect indirect_20 = peer_.getJavaExpressionForRoundExpression();
					if(indirect_20 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_17 = indirect_20.createPostUnary();
						if(child_17 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_17));
							child_17.end();
						}
					}
				}
				if(type_2 == 3) {
					JavaExpressionPeer.Indirect indirect_21 = peer_.getJavaExpressionForRoundExpression();
					if(indirect_21 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_18 = indirect_21.createPreUnary();
						if(child_18 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_18));
							child_18.end();
						}
					}
				}
				if(type_2 == 4) {
					JavaExpressionPeer.Indirect indirect_22 = peer_.getJavaExpressionForRoundExpression();
					if(indirect_22 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_7 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_19 = indirect_22.createAssignment(keywordToken_7.getLineNumber(), keywordToken_7.getCharacterNumber());
						if(child_19 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_19));
							child_19.end();
						}
					}
				}
				if(type_2 == 5) {
					JavaExpressionPeer.Indirect indirect_23 = peer_.getJavaExpressionForRoundExpression();
					if(indirect_23 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_20 = indirect_23.createMappingVariableRef();
						if(child_20 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_20));
							child_20.end();
						}
					}
				}
				if(type_2 == 6) {
					JavaExpressionPeer.Indirect indirect_24 = peer_.getJavaExpressionForRoundExpression();
					if(indirect_24 != null) {
						JavaExpressionPeer.CallPatternPeer child_21 = indirect_24.createCall();
						if(child_21 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_21));
							child_21.end();
						}
					}
				}
				if(type_2 == 7) {
					JavaExpressionPeer.Indirect indirect_25 = peer_.getJavaExpressionForRoundExpression();
					if(indirect_25 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_8 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_22 = indirect_25.createBracketed(keywordToken_8.getLineNumber(), keywordToken_8.getCharacterNumber());
						if(child_22 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_22));
							child_22.end();
						}
					}
				}
				if(type_2 == 8) {
					JavaExpressionPeer.Indirect indirect_26 = peer_.getJavaExpressionForRoundExpression();
					if(indirect_26 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_23 = indirect_26.createBuilderVariableRef();
						if(child_23 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_23));
							child_23.end();
						}
					}
				}
				if(type_2 == 9) {
					JavaExpressionPeer.Indirect indirect_27 = peer_.getJavaExpressionForRoundExpression();
					if(indirect_27 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_9 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_24 = indirect_27.createArrayConstructorCall(keywordToken_9.getLineNumber(), keywordToken_9.getCharacterNumber());
						if(child_24 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_24));
							child_24.end();
						}
					}
				}
				if(type_2 == 10) {
					JavaExpressionPeer.Indirect indirect_28 = peer_.getJavaExpressionForRoundExpression();
					if(indirect_28 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_10 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_25 = indirect_28.createGivenArray(keywordToken_10.getLineNumber(), keywordToken_10.getCharacterNumber());
						if(child_25 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_25));
							child_25.end();
						}
					}
				}
				if(type_2 == 11) {
					JavaExpressionPeer.Indirect indirect_29 = peer_.getJavaExpressionForRoundExpression();
					if(indirect_29 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_11 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_26 = indirect_29.createConstructorCall(keywordToken_11.getLineNumber(), keywordToken_11.getCharacterNumber());
						if(child_26 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_26));
							child_26.end();
						}
					}
				}
				if(type_2 == 12) {
					JavaExpressionPeer.Indirect indirect_30 = peer_.getJavaExpressionForRoundExpression();
					if(indirect_30 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_27 = indirect_30.createPrimitive();
						if(child_27 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_27));
							child_27.end();
						}
					}
				}
				if(type_2 == 13) {
					JavaExpressionPeer.Indirect indirect_31 = peer_.getJavaExpressionForRoundExpression();
					if(indirect_31 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_12 = element.getBaseArgumentToken(0);
						indirect_31.createThis(keywordToken_12.getLineNumber(), keywordToken_12.getCharacterNumber());
					}
				}
				if(type_2 == 14) {
					JavaExpressionPeer.Indirect indirect_32 = peer_.getJavaExpressionForRoundExpression();
					if(indirect_32 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_13 = element.getBaseArgumentToken(0);
						indirect_32.createNull(keywordToken_13.getLineNumber(), keywordToken_13.getCharacterNumber());
					}
				}
				if(type_2 == 15) {
					JavaExpressionPeer.Indirect indirect_33 = peer_.getJavaExpressionForRoundExpression();
					if(indirect_33 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken_1 = element.getBaseArgumentToken(0);
						indirect_33.createMark(markNameToken_1.getStringValue(), markNameToken_1.getLineNumber(), markNameToken_1.getCharacterNumber());
					}
				}
			}
			if(index == 3) {
				int type_3 = element.getType();
				if(type_3 == 0) {
					JavaStatementPeer.Indirect indirect_34 = peer_.getJavaStatementForLoopStatement();
					if(indirect_34 != null) {
						JavaStatementPeer.BlockPatternPeer child_28 = indirect_34.createBlock();
						if(child_28 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BlockDecoder_1(child_28));
							child_28.end();
						}
					}
				}
				if(type_3 == 1) {
					JavaStatementPeer.Indirect indirect_35 = peer_.getJavaStatementForLoopStatement();
					if(indirect_35 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(1);
						JavaStatementPeer.DeclarationPatternPeer child_29 = indirect_35.createDeclaration(nameToken_1.getStringValue(), nameToken_1.getLineNumber(), nameToken_1.getCharacterNumber());
						if(child_29 != null) {
							element.updateConstruction(new AllDecodersSkeleton.DeclarationDecoder_1(child_29));
							child_29.end();
						}
					}
				}
				if(type_3 == 2) {
					JavaStatementPeer.Indirect indirect_36 = peer_.getJavaStatementForLoopStatement();
					if(indirect_36 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_14 = element.getBaseArgumentToken(0);
						JavaStatementPeer.IfPatternPeer child_30 = indirect_36.createIf(keywordToken_14.getLineNumber(), keywordToken_14.getCharacterNumber());
						if(child_30 != null) {
							element.updateConstruction(new AllDecodersSkeleton.IfDecoder_1(child_30));
							child_30.end();
						}
					}
				}
				if(type_3 == 3) {
					JavaStatementPeer.Indirect indirect_37 = peer_.getJavaStatementForLoopStatement();
					if(indirect_37 != null) {
						org.ffd2.austenx.runtime.BaseToken noteToken = element.getBaseArgumentToken(0);
						indirect_37.createNote(noteToken.getStringValue());
					}
				}
				if(type_3 == 4) {
					JavaStatementPeer.Indirect indirect_38 = peer_.getJavaStatementForLoopStatement();
					if(indirect_38 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_15 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ForPatternPeer child_31 = indirect_38.createFor(keywordToken_15.getLineNumber(), keywordToken_15.getCharacterNumber());
						if(child_31 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ForDecoder(child_31));
							child_31.end();
						}
					}
				}
				if(type_3 == 5) {
					JavaStatementPeer.Indirect indirect_39 = peer_.getJavaStatementForLoopStatement();
					if(indirect_39 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_16 = element.getBaseArgumentToken(0);
						JavaStatementPeer.WhilePatternPeer child_32 = indirect_39.createWhile(keywordToken_16.getLineNumber(), keywordToken_16.getCharacterNumber());
						if(child_32 != null) {
							element.updateConstruction(new AllDecodersSkeleton.WhileDecoder(child_32));
							child_32.end();
						}
					}
				}
				if(type_3 == 6) {
					JavaStatementPeer.Indirect indirect_40 = peer_.getJavaStatementForLoopStatement();
					if(indirect_40 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken_2 = element.getBaseArgumentToken(0);
						indirect_40.createMark(markNameToken_2.getStringValue(), markNameToken_2.getLineNumber(), markNameToken_2.getCharacterNumber());
					}
				}
				if(type_3 == 7) {
					JavaStatementPeer.Indirect indirect_41 = peer_.getJavaStatementForLoopStatement();
					if(indirect_41 != null) {
						JavaStatementPeer.MacroCallPatternPeer child_33 = indirect_41.createMacroCall();
						if(child_33 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroCallDecoder_2(child_33));
							child_33.end();
						}
					}
				}
				if(type_3 == 8) {
					JavaStatementPeer.Indirect indirect_42 = peer_.getJavaStatementForLoopStatement();
					if(indirect_42 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken = element.getBaseArgumentToken(0);
						JavaStatementPeer.ExpressionVarPatternPeer child_34 = indirect_42.createExpressionVar(variableNameToken.getStringValue(), variableNameToken.getLineNumber(), variableNameToken.getCharacterNumber());
						if(child_34 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ExpressionVarDecoder(child_34));
							child_34.end();
						}
					}
				}
				if(type_3 == 9) {
					JavaStatementPeer.Indirect indirect_43 = peer_.getJavaStatementForLoopStatement();
					if(indirect_43 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken_1 = element.getBaseArgumentToken(0);
						JavaStatementPeer.StatementVarPatternPeer child_35 = indirect_43.createStatementVar(variableNameToken_1.getStringValue(), variableNameToken_1.getLineNumber(), variableNameToken_1.getCharacterNumber());
						if(child_35 != null) {
							element.updateConstruction(new AllDecodersSkeleton.StatementVarDecoder(child_35));
							child_35.end();
						}
					}
				}
				if(type_3 == 10) {
					JavaStatementPeer.Indirect indirect_44 = peer_.getJavaStatementForLoopStatement();
					if(indirect_44 != null) {
						JavaStatementPeer.FindPatternPeer child_36 = indirect_44.createFind();
						if(child_36 != null) {
							element.updateConstruction(new AllDecodersSkeleton.FindDecoder_2(child_36));
							child_36.end();
						}
					}
				}
				if(type_3 == 11) {
					JavaStatementPeer.Indirect indirect_45 = peer_.getJavaStatementForLoopStatement();
					if(indirect_45 != null) {
						JavaStatementPeer.LinkBlockPatternPeer child_37 = indirect_45.createLinkBlock();
						if(child_37 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkBlockDecoder(child_37));
							child_37.end();
						}
					}
				}
				if(type_3 == 12) {
					JavaStatementPeer.Indirect indirect_46 = peer_.getJavaStatementForLoopStatement();
					if(indirect_46 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_17 = element.getBaseArgumentToken(0);
						indirect_46.createReturnSimple(keywordToken_17.getLineNumber(), keywordToken_17.getCharacterNumber());
					}
				}
				if(type_3 == 13) {
					JavaStatementPeer.Indirect indirect_47 = peer_.getJavaStatementForLoopStatement();
					if(indirect_47 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_18 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ReturnPatternPeer child_38 = indirect_47.createReturn(keywordToken_18.getLineNumber(), keywordToken_18.getCharacterNumber());
						if(child_38 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ReturnDecoder(child_38));
							child_38.end();
						}
					}
				}
				if(type_3 == 14) {
					JavaStatementPeer.Indirect indirect_48 = peer_.getJavaStatementForLoopStatement();
					if(indirect_48 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_19 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ThrowPatternPeer child_39 = indirect_48.createThrow(keywordToken_19.getLineNumber(), keywordToken_19.getCharacterNumber());
						if(child_39 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ThrowDecoder(child_39));
							child_39.end();
						}
					}
				}
				if(type_3 == 15) {
					JavaStatementPeer.Indirect indirect_49 = peer_.getJavaStatementForLoopStatement();
					if(indirect_49 != null) {
						JavaStatementPeer.ExpressionPatternPeer child_40 = indirect_49.createExpression();
						if(child_40 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ExpressionDecoder_1(child_40));
							child_40.end();
						}
					}
				}
				if(type_3 == 16) {
					JavaStatementPeer.Indirect indirect_50 = peer_.getJavaStatementForLoopStatement();
					if(indirect_50 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_20 = element.getBaseArgumentToken(0);
						JavaStatementPeer.SyncPatternPeer child_41 = indirect_50.createSync(keywordToken_20.getLineNumber(), keywordToken_20.getCharacterNumber());
						if(child_41 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SyncDecoder(child_41));
							child_41.end();
						}
					}
				}
				if(type_3 == 17) {
					JavaStatementPeer.Indirect indirect_51 = peer_.getJavaStatementForLoopStatement();
					if(indirect_51 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken_2 = element.getBaseArgumentToken(0);
						JavaStatementPeer.SetPatternPeer child_42 = indirect_51.createSet(variableNameToken_2.getStringValue(), variableNameToken_2.getLineNumber(), variableNameToken_2.getCharacterNumber());
						if(child_42 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SetDecoder(child_42));
							child_42.end();
						}
					}
				}
			}
		}
	}
	public static final class WhileDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaStatementPeer.WhilePatternPeer peer_;
		public WhileDecoder(JavaStatementPeer.WhilePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForConditional();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child = indirect.createBinary();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForConditional();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_1 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForConditional();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_2 = indirect_2.createPostUnary();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForConditional();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_3 = indirect_3.createPreUnary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForConditional();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_4 = indirect_4.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForConditional();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_5 = indirect_5.createMappingVariableRef();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForConditional();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_6 = indirect_6.createCall();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForConditional();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_7 = indirect_7.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForConditional();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_8 = indirect_8.createBuilderVariableRef();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForConditional();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_9 = indirect_9.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForConditional();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_10 = indirect_10.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForConditional();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_11 = indirect_11.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForConditional();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_12 = indirect_12.createPrimitive();
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_12));
							child_12.end();
						}
					}
				}
				if(type == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForConditional();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForConditional();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForConditional();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
			if(index == 1) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					JavaStatementPeer.Indirect indirect_16 = peer_.getJavaStatementForLoopStatement();
					if(indirect_16 != null) {
						JavaStatementPeer.BlockPatternPeer child_13 = indirect_16.createBlock();
						if(child_13 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BlockDecoder_1(child_13));
							child_13.end();
						}
					}
				}
				if(type_1 == 1) {
					JavaStatementPeer.Indirect indirect_17 = peer_.getJavaStatementForLoopStatement();
					if(indirect_17 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(1);
						JavaStatementPeer.DeclarationPatternPeer child_14 = indirect_17.createDeclaration(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
						if(child_14 != null) {
							element.updateConstruction(new AllDecodersSkeleton.DeclarationDecoder_1(child_14));
							child_14.end();
						}
					}
				}
				if(type_1 == 2) {
					JavaStatementPeer.Indirect indirect_18 = peer_.getJavaStatementForLoopStatement();
					if(indirect_18 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_7 = element.getBaseArgumentToken(0);
						JavaStatementPeer.IfPatternPeer child_15 = indirect_18.createIf(keywordToken_7.getLineNumber(), keywordToken_7.getCharacterNumber());
						if(child_15 != null) {
							element.updateConstruction(new AllDecodersSkeleton.IfDecoder_1(child_15));
							child_15.end();
						}
					}
				}
				if(type_1 == 3) {
					JavaStatementPeer.Indirect indirect_19 = peer_.getJavaStatementForLoopStatement();
					if(indirect_19 != null) {
						org.ffd2.austenx.runtime.BaseToken noteToken = element.getBaseArgumentToken(0);
						indirect_19.createNote(noteToken.getStringValue());
					}
				}
				if(type_1 == 4) {
					JavaStatementPeer.Indirect indirect_20 = peer_.getJavaStatementForLoopStatement();
					if(indirect_20 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_8 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ForPatternPeer child_16 = indirect_20.createFor(keywordToken_8.getLineNumber(), keywordToken_8.getCharacterNumber());
						if(child_16 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ForDecoder(child_16));
							child_16.end();
						}
					}
				}
				if(type_1 == 5) {
					JavaStatementPeer.Indirect indirect_21 = peer_.getJavaStatementForLoopStatement();
					if(indirect_21 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_9 = element.getBaseArgumentToken(0);
						JavaStatementPeer.WhilePatternPeer child_17 = indirect_21.createWhile(keywordToken_9.getLineNumber(), keywordToken_9.getCharacterNumber());
						if(child_17 != null) {
							element.updateConstruction(new AllDecodersSkeleton.WhileDecoder(child_17));
							child_17.end();
						}
					}
				}
				if(type_1 == 6) {
					JavaStatementPeer.Indirect indirect_22 = peer_.getJavaStatementForLoopStatement();
					if(indirect_22 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken_1 = element.getBaseArgumentToken(0);
						indirect_22.createMark(markNameToken_1.getStringValue(), markNameToken_1.getLineNumber(), markNameToken_1.getCharacterNumber());
					}
				}
				if(type_1 == 7) {
					JavaStatementPeer.Indirect indirect_23 = peer_.getJavaStatementForLoopStatement();
					if(indirect_23 != null) {
						JavaStatementPeer.MacroCallPatternPeer child_18 = indirect_23.createMacroCall();
						if(child_18 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroCallDecoder_2(child_18));
							child_18.end();
						}
					}
				}
				if(type_1 == 8) {
					JavaStatementPeer.Indirect indirect_24 = peer_.getJavaStatementForLoopStatement();
					if(indirect_24 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken = element.getBaseArgumentToken(0);
						JavaStatementPeer.ExpressionVarPatternPeer child_19 = indirect_24.createExpressionVar(variableNameToken.getStringValue(), variableNameToken.getLineNumber(), variableNameToken.getCharacterNumber());
						if(child_19 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ExpressionVarDecoder(child_19));
							child_19.end();
						}
					}
				}
				if(type_1 == 9) {
					JavaStatementPeer.Indirect indirect_25 = peer_.getJavaStatementForLoopStatement();
					if(indirect_25 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken_1 = element.getBaseArgumentToken(0);
						JavaStatementPeer.StatementVarPatternPeer child_20 = indirect_25.createStatementVar(variableNameToken_1.getStringValue(), variableNameToken_1.getLineNumber(), variableNameToken_1.getCharacterNumber());
						if(child_20 != null) {
							element.updateConstruction(new AllDecodersSkeleton.StatementVarDecoder(child_20));
							child_20.end();
						}
					}
				}
				if(type_1 == 10) {
					JavaStatementPeer.Indirect indirect_26 = peer_.getJavaStatementForLoopStatement();
					if(indirect_26 != null) {
						JavaStatementPeer.FindPatternPeer child_21 = indirect_26.createFind();
						if(child_21 != null) {
							element.updateConstruction(new AllDecodersSkeleton.FindDecoder_2(child_21));
							child_21.end();
						}
					}
				}
				if(type_1 == 11) {
					JavaStatementPeer.Indirect indirect_27 = peer_.getJavaStatementForLoopStatement();
					if(indirect_27 != null) {
						JavaStatementPeer.LinkBlockPatternPeer child_22 = indirect_27.createLinkBlock();
						if(child_22 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkBlockDecoder(child_22));
							child_22.end();
						}
					}
				}
				if(type_1 == 12) {
					JavaStatementPeer.Indirect indirect_28 = peer_.getJavaStatementForLoopStatement();
					if(indirect_28 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_10 = element.getBaseArgumentToken(0);
						indirect_28.createReturnSimple(keywordToken_10.getLineNumber(), keywordToken_10.getCharacterNumber());
					}
				}
				if(type_1 == 13) {
					JavaStatementPeer.Indirect indirect_29 = peer_.getJavaStatementForLoopStatement();
					if(indirect_29 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_11 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ReturnPatternPeer child_23 = indirect_29.createReturn(keywordToken_11.getLineNumber(), keywordToken_11.getCharacterNumber());
						if(child_23 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ReturnDecoder(child_23));
							child_23.end();
						}
					}
				}
				if(type_1 == 14) {
					JavaStatementPeer.Indirect indirect_30 = peer_.getJavaStatementForLoopStatement();
					if(indirect_30 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_12 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ThrowPatternPeer child_24 = indirect_30.createThrow(keywordToken_12.getLineNumber(), keywordToken_12.getCharacterNumber());
						if(child_24 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ThrowDecoder(child_24));
							child_24.end();
						}
					}
				}
				if(type_1 == 15) {
					JavaStatementPeer.Indirect indirect_31 = peer_.getJavaStatementForLoopStatement();
					if(indirect_31 != null) {
						JavaStatementPeer.ExpressionPatternPeer child_25 = indirect_31.createExpression();
						if(child_25 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ExpressionDecoder_1(child_25));
							child_25.end();
						}
					}
				}
				if(type_1 == 16) {
					JavaStatementPeer.Indirect indirect_32 = peer_.getJavaStatementForLoopStatement();
					if(indirect_32 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_13 = element.getBaseArgumentToken(0);
						JavaStatementPeer.SyncPatternPeer child_26 = indirect_32.createSync(keywordToken_13.getLineNumber(), keywordToken_13.getCharacterNumber());
						if(child_26 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SyncDecoder(child_26));
							child_26.end();
						}
					}
				}
				if(type_1 == 17) {
					JavaStatementPeer.Indirect indirect_33 = peer_.getJavaStatementForLoopStatement();
					if(indirect_33 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken_2 = element.getBaseArgumentToken(0);
						JavaStatementPeer.SetPatternPeer child_27 = indirect_33.createSet(variableNameToken_2.getStringValue(), variableNameToken_2.getLineNumber(), variableNameToken_2.getCharacterNumber());
						if(child_27 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SetDecoder(child_27));
							child_27.end();
						}
					}
				}
			}
		}
	}
	public static final class MacroCallDecoder_2 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaStatementPeer.MacroCallPatternPeer peer_;
		public MacroCallDecoder_2(JavaStatementPeer.MacroCallPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
				org.ffd2.austenx.runtime.BaseToken macroNameToken = element.getBaseArgumentToken(2);
				GeneralMacroCallPatternPeer child = peer_.addGeneralMacroCallForCall(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), macroNameToken.getStringValue());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.GeneralMacroCallDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class ExpressionVarDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaStatementPeer.ExpressionVarPatternPeer peer_;
		public ExpressionVarDecoder(JavaStatementPeer.ExpressionVarPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForValue();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child = indirect.createBinary();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForValue();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_1 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForValue();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_2 = indirect_2.createPostUnary();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForValue();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_3 = indirect_3.createPreUnary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForValue();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_4 = indirect_4.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForValue();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_5 = indirect_5.createMappingVariableRef();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForValue();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_6 = indirect_6.createCall();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForValue();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_7 = indirect_7.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForValue();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_8 = indirect_8.createBuilderVariableRef();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForValue();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_9 = indirect_9.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForValue();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_10 = indirect_10.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForValue();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_11 = indirect_11.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForValue();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_12 = indirect_12.createPrimitive();
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_12));
							child_12.end();
						}
					}
				}
				if(type == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForValue();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForValue();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForValue();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class StatementVarDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaStatementPeer.StatementVarPatternPeer peer_;
		public StatementVarDecoder(JavaStatementPeer.StatementVarPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaStatementPeer.Indirect indirect = peer_.getJavaStatementForValue();
					if(indirect != null) {
						JavaStatementPeer.BlockPatternPeer child = indirect.createBlock();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.BlockDecoder_1(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaStatementPeer.Indirect indirect_1 = peer_.getJavaStatementForValue();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(1);
						JavaStatementPeer.DeclarationPatternPeer child_1 = indirect_1.createDeclaration(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.DeclarationDecoder_1(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaStatementPeer.Indirect indirect_2 = peer_.getJavaStatementForValue();
					if(indirect_2 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaStatementPeer.IfPatternPeer child_2 = indirect_2.createIf(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.IfDecoder_1(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaStatementPeer.Indirect indirect_3 = peer_.getJavaStatementForValue();
					if(indirect_3 != null) {
						org.ffd2.austenx.runtime.BaseToken noteToken = element.getBaseArgumentToken(0);
						indirect_3.createNote(noteToken.getStringValue());
					}
				}
				if(type == 4) {
					JavaStatementPeer.Indirect indirect_4 = peer_.getJavaStatementForValue();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ForPatternPeer child_3 = indirect_4.createFor(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ForDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 5) {
					JavaStatementPeer.Indirect indirect_5 = peer_.getJavaStatementForValue();
					if(indirect_5 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaStatementPeer.WhilePatternPeer child_4 = indirect_5.createWhile(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.WhileDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 6) {
					JavaStatementPeer.Indirect indirect_6 = peer_.getJavaStatementForValue();
					if(indirect_6 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_6.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
				if(type == 7) {
					JavaStatementPeer.Indirect indirect_7 = peer_.getJavaStatementForValue();
					if(indirect_7 != null) {
						JavaStatementPeer.MacroCallPatternPeer child_5 = indirect_7.createMacroCall();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroCallDecoder_2(child_5));
							child_5.end();
						}
					}
				}
				if(type == 8) {
					JavaStatementPeer.Indirect indirect_8 = peer_.getJavaStatementForValue();
					if(indirect_8 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken = element.getBaseArgumentToken(0);
						JavaStatementPeer.ExpressionVarPatternPeer child_6 = indirect_8.createExpressionVar(variableNameToken.getStringValue(), variableNameToken.getLineNumber(), variableNameToken.getCharacterNumber());
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ExpressionVarDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 9) {
					JavaStatementPeer.Indirect indirect_9 = peer_.getJavaStatementForValue();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken_1 = element.getBaseArgumentToken(0);
						JavaStatementPeer.StatementVarPatternPeer child_7 = indirect_9.createStatementVar(variableNameToken_1.getStringValue(), variableNameToken_1.getLineNumber(), variableNameToken_1.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.StatementVarDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 10) {
					JavaStatementPeer.Indirect indirect_10 = peer_.getJavaStatementForValue();
					if(indirect_10 != null) {
						JavaStatementPeer.FindPatternPeer child_8 = indirect_10.createFind();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.FindDecoder_2(child_8));
							child_8.end();
						}
					}
				}
				if(type == 11) {
					JavaStatementPeer.Indirect indirect_11 = peer_.getJavaStatementForValue();
					if(indirect_11 != null) {
						JavaStatementPeer.LinkBlockPatternPeer child_9 = indirect_11.createLinkBlock();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkBlockDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 12) {
					JavaStatementPeer.Indirect indirect_12 = peer_.getJavaStatementForValue();
					if(indirect_12 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						indirect_12.createReturnSimple(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
					}
				}
				if(type == 13) {
					JavaStatementPeer.Indirect indirect_13 = peer_.getJavaStatementForValue();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ReturnPatternPeer child_10 = indirect_13.createReturn(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ReturnDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 14) {
					JavaStatementPeer.Indirect indirect_14 = peer_.getJavaStatementForValue();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ThrowPatternPeer child_11 = indirect_14.createThrow(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ThrowDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 15) {
					JavaStatementPeer.Indirect indirect_15 = peer_.getJavaStatementForValue();
					if(indirect_15 != null) {
						JavaStatementPeer.ExpressionPatternPeer child_12 = indirect_15.createExpression();
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ExpressionDecoder_1(child_12));
							child_12.end();
						}
					}
				}
				if(type == 16) {
					JavaStatementPeer.Indirect indirect_16 = peer_.getJavaStatementForValue();
					if(indirect_16 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						JavaStatementPeer.SyncPatternPeer child_13 = indirect_16.createSync(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
						if(child_13 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SyncDecoder(child_13));
							child_13.end();
						}
					}
				}
				if(type == 17) {
					JavaStatementPeer.Indirect indirect_17 = peer_.getJavaStatementForValue();
					if(indirect_17 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken_2 = element.getBaseArgumentToken(0);
						JavaStatementPeer.SetPatternPeer child_14 = indirect_17.createSet(variableNameToken_2.getStringValue(), variableNameToken_2.getLineNumber(), variableNameToken_2.getCharacterNumber());
						if(child_14 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SetDecoder(child_14));
							child_14.end();
						}
					}
				}
			}
		}
	}
	public static final class FindDecoder_2 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaStatementPeer.FindPatternPeer peer_;
		public FindDecoder_2(JavaStatementPeer.FindPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken varibleNameToken = element.getBaseArgumentToken(0);
				FindDefinitionPatternPeer child = peer_.addFindDefinitionForDefinition(varibleNameToken.getStringValue(), varibleNameToken.getLineNumber(), varibleNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.FindDefinitionDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class LinkBlockDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaStatementPeer.LinkBlockPatternPeer peer_;
		public LinkBlockDecoder(JavaStatementPeer.LinkBlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addIsWithSubBlock();
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				LinkChainPatternPeer child = peer_.addLinkChainForSingleChain();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.LinkChainDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				DeferredJavaStatement tool = new DeferredJavaStatementImpl(element);
				peer_.setJavaStatementForStatement(tool);
			}
		}
	}
	public static final class ReturnDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaStatementPeer.ReturnPatternPeer peer_;
		public ReturnDecoder(JavaStatementPeer.ReturnPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForResult();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child = indirect.createBinary();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForResult();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_1 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForResult();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_2 = indirect_2.createPostUnary();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForResult();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_3 = indirect_3.createPreUnary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForResult();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_4 = indirect_4.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForResult();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_5 = indirect_5.createMappingVariableRef();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForResult();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_6 = indirect_6.createCall();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForResult();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_7 = indirect_7.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForResult();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_8 = indirect_8.createBuilderVariableRef();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForResult();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_9 = indirect_9.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForResult();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_10 = indirect_10.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForResult();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_11 = indirect_11.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForResult();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_12 = indirect_12.createPrimitive();
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_12));
							child_12.end();
						}
					}
				}
				if(type == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForResult();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForResult();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForResult();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class ThrowDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaStatementPeer.ThrowPatternPeer peer_;
		public ThrowDecoder(JavaStatementPeer.ThrowPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForResult();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child = indirect.createBinary();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForResult();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_1 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForResult();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_2 = indirect_2.createPostUnary();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForResult();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_3 = indirect_3.createPreUnary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForResult();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_4 = indirect_4.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForResult();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_5 = indirect_5.createMappingVariableRef();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForResult();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_6 = indirect_6.createCall();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForResult();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_7 = indirect_7.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForResult();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_8 = indirect_8.createBuilderVariableRef();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForResult();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_9 = indirect_9.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForResult();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_10 = indirect_10.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForResult();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_11 = indirect_11.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForResult();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_12 = indirect_12.createPrimitive();
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_12));
							child_12.end();
						}
					}
				}
				if(type == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForResult();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForResult();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForResult();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class ExpressionDecoder_1 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaStatementPeer.ExpressionPatternPeer peer_;
		public ExpressionDecoder_1(JavaStatementPeer.ExpressionPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForValue();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child = indirect.createBinary();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForValue();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_1 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForValue();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_2 = indirect_2.createPostUnary();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForValue();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_3 = indirect_3.createPreUnary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForValue();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_4 = indirect_4.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForValue();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_5 = indirect_5.createMappingVariableRef();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForValue();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_6 = indirect_6.createCall();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForValue();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_7 = indirect_7.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForValue();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_8 = indirect_8.createBuilderVariableRef();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForValue();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_9 = indirect_9.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForValue();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_10 = indirect_10.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForValue();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_11 = indirect_11.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForValue();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_12 = indirect_12.createPrimitive();
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_12));
							child_12.end();
						}
					}
				}
				if(type == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForValue();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForValue();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForValue();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class SyncDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaStatementPeer.SyncPatternPeer peer_;
		public SyncDecoder(JavaStatementPeer.SyncPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForSyncObject();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child = indirect.createBinary();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForSyncObject();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_1 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForSyncObject();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_2 = indirect_2.createPostUnary();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForSyncObject();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_3 = indirect_3.createPreUnary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForSyncObject();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_4 = indirect_4.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForSyncObject();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_5 = indirect_5.createMappingVariableRef();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForSyncObject();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_6 = indirect_6.createCall();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForSyncObject();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_7 = indirect_7.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForSyncObject();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_8 = indirect_8.createBuilderVariableRef();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForSyncObject();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_9 = indirect_9.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForSyncObject();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_10 = indirect_10.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForSyncObject();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_11 = indirect_11.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForSyncObject();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_12 = indirect_12.createPrimitive();
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_12));
							child_12.end();
						}
					}
				}
				if(type == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForSyncObject();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForSyncObject();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForSyncObject();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
			if(index == 1) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					JavaStatementPeer.Indirect indirect_16 = peer_.getJavaStatementForStatement();
					if(indirect_16 != null) {
						JavaStatementPeer.BlockPatternPeer child_13 = indirect_16.createBlock();
						if(child_13 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BlockDecoder_1(child_13));
							child_13.end();
						}
					}
				}
				if(type_1 == 1) {
					JavaStatementPeer.Indirect indirect_17 = peer_.getJavaStatementForStatement();
					if(indirect_17 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(1);
						JavaStatementPeer.DeclarationPatternPeer child_14 = indirect_17.createDeclaration(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
						if(child_14 != null) {
							element.updateConstruction(new AllDecodersSkeleton.DeclarationDecoder_1(child_14));
							child_14.end();
						}
					}
				}
				if(type_1 == 2) {
					JavaStatementPeer.Indirect indirect_18 = peer_.getJavaStatementForStatement();
					if(indirect_18 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_7 = element.getBaseArgumentToken(0);
						JavaStatementPeer.IfPatternPeer child_15 = indirect_18.createIf(keywordToken_7.getLineNumber(), keywordToken_7.getCharacterNumber());
						if(child_15 != null) {
							element.updateConstruction(new AllDecodersSkeleton.IfDecoder_1(child_15));
							child_15.end();
						}
					}
				}
				if(type_1 == 3) {
					JavaStatementPeer.Indirect indirect_19 = peer_.getJavaStatementForStatement();
					if(indirect_19 != null) {
						org.ffd2.austenx.runtime.BaseToken noteToken = element.getBaseArgumentToken(0);
						indirect_19.createNote(noteToken.getStringValue());
					}
				}
				if(type_1 == 4) {
					JavaStatementPeer.Indirect indirect_20 = peer_.getJavaStatementForStatement();
					if(indirect_20 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_8 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ForPatternPeer child_16 = indirect_20.createFor(keywordToken_8.getLineNumber(), keywordToken_8.getCharacterNumber());
						if(child_16 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ForDecoder(child_16));
							child_16.end();
						}
					}
				}
				if(type_1 == 5) {
					JavaStatementPeer.Indirect indirect_21 = peer_.getJavaStatementForStatement();
					if(indirect_21 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_9 = element.getBaseArgumentToken(0);
						JavaStatementPeer.WhilePatternPeer child_17 = indirect_21.createWhile(keywordToken_9.getLineNumber(), keywordToken_9.getCharacterNumber());
						if(child_17 != null) {
							element.updateConstruction(new AllDecodersSkeleton.WhileDecoder(child_17));
							child_17.end();
						}
					}
				}
				if(type_1 == 6) {
					JavaStatementPeer.Indirect indirect_22 = peer_.getJavaStatementForStatement();
					if(indirect_22 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken_1 = element.getBaseArgumentToken(0);
						indirect_22.createMark(markNameToken_1.getStringValue(), markNameToken_1.getLineNumber(), markNameToken_1.getCharacterNumber());
					}
				}
				if(type_1 == 7) {
					JavaStatementPeer.Indirect indirect_23 = peer_.getJavaStatementForStatement();
					if(indirect_23 != null) {
						JavaStatementPeer.MacroCallPatternPeer child_18 = indirect_23.createMacroCall();
						if(child_18 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MacroCallDecoder_2(child_18));
							child_18.end();
						}
					}
				}
				if(type_1 == 8) {
					JavaStatementPeer.Indirect indirect_24 = peer_.getJavaStatementForStatement();
					if(indirect_24 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken = element.getBaseArgumentToken(0);
						JavaStatementPeer.ExpressionVarPatternPeer child_19 = indirect_24.createExpressionVar(variableNameToken.getStringValue(), variableNameToken.getLineNumber(), variableNameToken.getCharacterNumber());
						if(child_19 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ExpressionVarDecoder(child_19));
							child_19.end();
						}
					}
				}
				if(type_1 == 9) {
					JavaStatementPeer.Indirect indirect_25 = peer_.getJavaStatementForStatement();
					if(indirect_25 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken_1 = element.getBaseArgumentToken(0);
						JavaStatementPeer.StatementVarPatternPeer child_20 = indirect_25.createStatementVar(variableNameToken_1.getStringValue(), variableNameToken_1.getLineNumber(), variableNameToken_1.getCharacterNumber());
						if(child_20 != null) {
							element.updateConstruction(new AllDecodersSkeleton.StatementVarDecoder(child_20));
							child_20.end();
						}
					}
				}
				if(type_1 == 10) {
					JavaStatementPeer.Indirect indirect_26 = peer_.getJavaStatementForStatement();
					if(indirect_26 != null) {
						JavaStatementPeer.FindPatternPeer child_21 = indirect_26.createFind();
						if(child_21 != null) {
							element.updateConstruction(new AllDecodersSkeleton.FindDecoder_2(child_21));
							child_21.end();
						}
					}
				}
				if(type_1 == 11) {
					JavaStatementPeer.Indirect indirect_27 = peer_.getJavaStatementForStatement();
					if(indirect_27 != null) {
						JavaStatementPeer.LinkBlockPatternPeer child_22 = indirect_27.createLinkBlock();
						if(child_22 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkBlockDecoder(child_22));
							child_22.end();
						}
					}
				}
				if(type_1 == 12) {
					JavaStatementPeer.Indirect indirect_28 = peer_.getJavaStatementForStatement();
					if(indirect_28 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_10 = element.getBaseArgumentToken(0);
						indirect_28.createReturnSimple(keywordToken_10.getLineNumber(), keywordToken_10.getCharacterNumber());
					}
				}
				if(type_1 == 13) {
					JavaStatementPeer.Indirect indirect_29 = peer_.getJavaStatementForStatement();
					if(indirect_29 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_11 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ReturnPatternPeer child_23 = indirect_29.createReturn(keywordToken_11.getLineNumber(), keywordToken_11.getCharacterNumber());
						if(child_23 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ReturnDecoder(child_23));
							child_23.end();
						}
					}
				}
				if(type_1 == 14) {
					JavaStatementPeer.Indirect indirect_30 = peer_.getJavaStatementForStatement();
					if(indirect_30 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_12 = element.getBaseArgumentToken(0);
						JavaStatementPeer.ThrowPatternPeer child_24 = indirect_30.createThrow(keywordToken_12.getLineNumber(), keywordToken_12.getCharacterNumber());
						if(child_24 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ThrowDecoder(child_24));
							child_24.end();
						}
					}
				}
				if(type_1 == 15) {
					JavaStatementPeer.Indirect indirect_31 = peer_.getJavaStatementForStatement();
					if(indirect_31 != null) {
						JavaStatementPeer.ExpressionPatternPeer child_25 = indirect_31.createExpression();
						if(child_25 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ExpressionDecoder_1(child_25));
							child_25.end();
						}
					}
				}
				if(type_1 == 16) {
					JavaStatementPeer.Indirect indirect_32 = peer_.getJavaStatementForStatement();
					if(indirect_32 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_13 = element.getBaseArgumentToken(0);
						JavaStatementPeer.SyncPatternPeer child_26 = indirect_32.createSync(keywordToken_13.getLineNumber(), keywordToken_13.getCharacterNumber());
						if(child_26 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SyncDecoder(child_26));
							child_26.end();
						}
					}
				}
				if(type_1 == 17) {
					JavaStatementPeer.Indirect indirect_33 = peer_.getJavaStatementForStatement();
					if(indirect_33 != null) {
						org.ffd2.austenx.runtime.BaseToken variableNameToken_2 = element.getBaseArgumentToken(0);
						JavaStatementPeer.SetPatternPeer child_27 = indirect_33.createSet(variableNameToken_2.getStringValue(), variableNameToken_2.getLineNumber(), variableNameToken_2.getCharacterNumber());
						if(child_27 != null) {
							element.updateConstruction(new AllDecodersSkeleton.SetDecoder(child_27));
							child_27.end();
						}
					}
				}
			}
		}
	}
	public static final class SetDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaStatementPeer.SetPatternPeer peer_;
		public SetDecoder(JavaStatementPeer.SetPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForValue();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child = indirect.createBinary();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForValue();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_1 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForValue();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_2 = indirect_2.createPostUnary();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForValue();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_3 = indirect_3.createPreUnary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForValue();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_4 = indirect_4.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForValue();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_5 = indirect_5.createMappingVariableRef();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForValue();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_6 = indirect_6.createCall();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForValue();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_7 = indirect_7.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForValue();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_8 = indirect_8.createBuilderVariableRef();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForValue();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_9 = indirect_9.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForValue();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_10 = indirect_10.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForValue();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_11 = indirect_11.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForValue();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_12 = indirect_12.createPrimitive();
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_12));
							child_12.end();
						}
					}
				}
				if(type == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForValue();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForValue();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForValue();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class GeneralMacroCallDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final GeneralMacroCallPatternPeer peer_;
		public GeneralMacroCallDecoder(GeneralMacroCallPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 1) {
				peer_.addVariableName(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				MacroCallParameterBlockPatternPeer child = peer_.addMacroCallParameterBlockForParameters();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.MacroCallParameterBlockDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class GeneralSymbolDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final GeneralSymbolPatternPeer peer_;
		public GeneralSymbolDecoder(GeneralSymbolPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addOther(token.getStringValue());
			}
			if(index == 1) {
				peer_.addPlus();
			}
			if(index == 2) {
				peer_.addMinus();
			}
			if(index == 3) {
				peer_.addStar();
			}
			if(index == 4) {
				peer_.addSlash();
			}
			if(index == 5) {
				peer_.addExclamationMark();
			}
			if(index == 6) {
				peer_.addLessThan(token.getLineNumber(), token.getCharacterNumber());
			}
			if(index == 7) {
				peer_.addGreaterThan(token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
		}
	}
	public static final class BinaryDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaExpressionPeer.BinaryPatternPeer peer_;
		public BinaryDecoder(JavaExpressionPeer.BinaryPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForLeft();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child = indirect.createBinary();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForLeft();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_1 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForLeft();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_2 = indirect_2.createPostUnary();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForLeft();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_3 = indirect_3.createPreUnary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForLeft();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_4 = indirect_4.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForLeft();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_5 = indirect_5.createMappingVariableRef();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForLeft();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_6 = indirect_6.createCall();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForLeft();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_7 = indirect_7.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForLeft();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_8 = indirect_8.createBuilderVariableRef();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForLeft();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_9 = indirect_9.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForLeft();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_10 = indirect_10.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForLeft();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_11 = indirect_11.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForLeft();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_12 = indirect_12.createPrimitive();
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_12));
							child_12.end();
						}
					}
				}
				if(type == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForLeft();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForLeft();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForLeft();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
			if(index == 1) {
				GeneralSymbolPatternPeer child_13 = peer_.addGeneralSymbolForSymbol();
				if(child_13 != null) {
					element.updateConstruction(new AllDecodersSkeleton.GeneralSymbolDecoder(child_13));
					child_13.end();
				}
			}
			if(index == 2) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					JavaExpressionPeer.Indirect indirect_16 = peer_.getJavaExpressionForRight();
					if(indirect_16 != null) {
						JavaExpressionPeer.BinaryPatternPeer child_14 = indirect_16.createBinary();
						if(child_14 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child_14));
							child_14.end();
						}
					}
				}
				if(type_1 == 1) {
					JavaExpressionPeer.Indirect indirect_17 = peer_.getJavaExpressionForRight();
					if(indirect_17 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_15 = indirect_17.createGeneralBinary(symbolToken_1.getLineNumber(), symbolToken_1.getCharacterNumber());
						if(child_15 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_15));
							child_15.end();
						}
					}
				}
				if(type_1 == 2) {
					JavaExpressionPeer.Indirect indirect_18 = peer_.getJavaExpressionForRight();
					if(indirect_18 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_16 = indirect_18.createPostUnary();
						if(child_16 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_16));
							child_16.end();
						}
					}
				}
				if(type_1 == 3) {
					JavaExpressionPeer.Indirect indirect_19 = peer_.getJavaExpressionForRight();
					if(indirect_19 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_17 = indirect_19.createPreUnary();
						if(child_17 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_17));
							child_17.end();
						}
					}
				}
				if(type_1 == 4) {
					JavaExpressionPeer.Indirect indirect_20 = peer_.getJavaExpressionForRight();
					if(indirect_20 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_7 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_18 = indirect_20.createAssignment(keywordToken_7.getLineNumber(), keywordToken_7.getCharacterNumber());
						if(child_18 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_18));
							child_18.end();
						}
					}
				}
				if(type_1 == 5) {
					JavaExpressionPeer.Indirect indirect_21 = peer_.getJavaExpressionForRight();
					if(indirect_21 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_19 = indirect_21.createMappingVariableRef();
						if(child_19 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_19));
							child_19.end();
						}
					}
				}
				if(type_1 == 6) {
					JavaExpressionPeer.Indirect indirect_22 = peer_.getJavaExpressionForRight();
					if(indirect_22 != null) {
						JavaExpressionPeer.CallPatternPeer child_20 = indirect_22.createCall();
						if(child_20 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_20));
							child_20.end();
						}
					}
				}
				if(type_1 == 7) {
					JavaExpressionPeer.Indirect indirect_23 = peer_.getJavaExpressionForRight();
					if(indirect_23 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_8 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_21 = indirect_23.createBracketed(keywordToken_8.getLineNumber(), keywordToken_8.getCharacterNumber());
						if(child_21 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_21));
							child_21.end();
						}
					}
				}
				if(type_1 == 8) {
					JavaExpressionPeer.Indirect indirect_24 = peer_.getJavaExpressionForRight();
					if(indirect_24 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_22 = indirect_24.createBuilderVariableRef();
						if(child_22 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_22));
							child_22.end();
						}
					}
				}
				if(type_1 == 9) {
					JavaExpressionPeer.Indirect indirect_25 = peer_.getJavaExpressionForRight();
					if(indirect_25 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_9 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_23 = indirect_25.createArrayConstructorCall(keywordToken_9.getLineNumber(), keywordToken_9.getCharacterNumber());
						if(child_23 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_23));
							child_23.end();
						}
					}
				}
				if(type_1 == 10) {
					JavaExpressionPeer.Indirect indirect_26 = peer_.getJavaExpressionForRight();
					if(indirect_26 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_10 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_24 = indirect_26.createGivenArray(keywordToken_10.getLineNumber(), keywordToken_10.getCharacterNumber());
						if(child_24 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_24));
							child_24.end();
						}
					}
				}
				if(type_1 == 11) {
					JavaExpressionPeer.Indirect indirect_27 = peer_.getJavaExpressionForRight();
					if(indirect_27 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_11 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_25 = indirect_27.createConstructorCall(keywordToken_11.getLineNumber(), keywordToken_11.getCharacterNumber());
						if(child_25 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_25));
							child_25.end();
						}
					}
				}
				if(type_1 == 12) {
					JavaExpressionPeer.Indirect indirect_28 = peer_.getJavaExpressionForRight();
					if(indirect_28 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_26 = indirect_28.createPrimitive();
						if(child_26 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_26));
							child_26.end();
						}
					}
				}
				if(type_1 == 13) {
					JavaExpressionPeer.Indirect indirect_29 = peer_.getJavaExpressionForRight();
					if(indirect_29 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_12 = element.getBaseArgumentToken(0);
						indirect_29.createThis(keywordToken_12.getLineNumber(), keywordToken_12.getCharacterNumber());
					}
				}
				if(type_1 == 14) {
					JavaExpressionPeer.Indirect indirect_30 = peer_.getJavaExpressionForRight();
					if(indirect_30 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_13 = element.getBaseArgumentToken(0);
						indirect_30.createNull(keywordToken_13.getLineNumber(), keywordToken_13.getCharacterNumber());
					}
				}
				if(type_1 == 15) {
					JavaExpressionPeer.Indirect indirect_31 = peer_.getJavaExpressionForRight();
					if(indirect_31 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken_1 = element.getBaseArgumentToken(0);
						indirect_31.createMark(markNameToken_1.getStringValue(), markNameToken_1.getLineNumber(), markNameToken_1.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class GeneralBinaryDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaExpressionPeer.GeneralBinaryPatternPeer peer_;
		public GeneralBinaryDecoder(JavaExpressionPeer.GeneralBinaryPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForLeft();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child = indirect.createBinary();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForLeft();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_1 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForLeft();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_2 = indirect_2.createPostUnary();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForLeft();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_3 = indirect_3.createPreUnary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForLeft();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_4 = indirect_4.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForLeft();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_5 = indirect_5.createMappingVariableRef();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForLeft();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_6 = indirect_6.createCall();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForLeft();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_7 = indirect_7.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForLeft();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_8 = indirect_8.createBuilderVariableRef();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForLeft();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_9 = indirect_9.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForLeft();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_10 = indirect_10.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForLeft();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_11 = indirect_11.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForLeft();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_12 = indirect_12.createPrimitive();
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_12));
							child_12.end();
						}
					}
				}
				if(type == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForLeft();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForLeft();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForLeft();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
			if(index == 1) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					JavaExpressionPeer.Indirect indirect_16 = peer_.getJavaExpressionForSymbol();
					if(indirect_16 != null) {
						JavaExpressionPeer.BinaryPatternPeer child_13 = indirect_16.createBinary();
						if(child_13 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child_13));
							child_13.end();
						}
					}
				}
				if(type_1 == 1) {
					JavaExpressionPeer.Indirect indirect_17 = peer_.getJavaExpressionForSymbol();
					if(indirect_17 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_14 = indirect_17.createGeneralBinary(symbolToken_1.getLineNumber(), symbolToken_1.getCharacterNumber());
						if(child_14 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_14));
							child_14.end();
						}
					}
				}
				if(type_1 == 2) {
					JavaExpressionPeer.Indirect indirect_18 = peer_.getJavaExpressionForSymbol();
					if(indirect_18 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_15 = indirect_18.createPostUnary();
						if(child_15 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_15));
							child_15.end();
						}
					}
				}
				if(type_1 == 3) {
					JavaExpressionPeer.Indirect indirect_19 = peer_.getJavaExpressionForSymbol();
					if(indirect_19 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_16 = indirect_19.createPreUnary();
						if(child_16 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_16));
							child_16.end();
						}
					}
				}
				if(type_1 == 4) {
					JavaExpressionPeer.Indirect indirect_20 = peer_.getJavaExpressionForSymbol();
					if(indirect_20 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_7 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_17 = indirect_20.createAssignment(keywordToken_7.getLineNumber(), keywordToken_7.getCharacterNumber());
						if(child_17 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_17));
							child_17.end();
						}
					}
				}
				if(type_1 == 5) {
					JavaExpressionPeer.Indirect indirect_21 = peer_.getJavaExpressionForSymbol();
					if(indirect_21 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_18 = indirect_21.createMappingVariableRef();
						if(child_18 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_18));
							child_18.end();
						}
					}
				}
				if(type_1 == 6) {
					JavaExpressionPeer.Indirect indirect_22 = peer_.getJavaExpressionForSymbol();
					if(indirect_22 != null) {
						JavaExpressionPeer.CallPatternPeer child_19 = indirect_22.createCall();
						if(child_19 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_19));
							child_19.end();
						}
					}
				}
				if(type_1 == 7) {
					JavaExpressionPeer.Indirect indirect_23 = peer_.getJavaExpressionForSymbol();
					if(indirect_23 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_8 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_20 = indirect_23.createBracketed(keywordToken_8.getLineNumber(), keywordToken_8.getCharacterNumber());
						if(child_20 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_20));
							child_20.end();
						}
					}
				}
				if(type_1 == 8) {
					JavaExpressionPeer.Indirect indirect_24 = peer_.getJavaExpressionForSymbol();
					if(indirect_24 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_21 = indirect_24.createBuilderVariableRef();
						if(child_21 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_21));
							child_21.end();
						}
					}
				}
				if(type_1 == 9) {
					JavaExpressionPeer.Indirect indirect_25 = peer_.getJavaExpressionForSymbol();
					if(indirect_25 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_9 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_22 = indirect_25.createArrayConstructorCall(keywordToken_9.getLineNumber(), keywordToken_9.getCharacterNumber());
						if(child_22 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_22));
							child_22.end();
						}
					}
				}
				if(type_1 == 10) {
					JavaExpressionPeer.Indirect indirect_26 = peer_.getJavaExpressionForSymbol();
					if(indirect_26 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_10 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_23 = indirect_26.createGivenArray(keywordToken_10.getLineNumber(), keywordToken_10.getCharacterNumber());
						if(child_23 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_23));
							child_23.end();
						}
					}
				}
				if(type_1 == 11) {
					JavaExpressionPeer.Indirect indirect_27 = peer_.getJavaExpressionForSymbol();
					if(indirect_27 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_11 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_24 = indirect_27.createConstructorCall(keywordToken_11.getLineNumber(), keywordToken_11.getCharacterNumber());
						if(child_24 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_24));
							child_24.end();
						}
					}
				}
				if(type_1 == 12) {
					JavaExpressionPeer.Indirect indirect_28 = peer_.getJavaExpressionForSymbol();
					if(indirect_28 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_25 = indirect_28.createPrimitive();
						if(child_25 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_25));
							child_25.end();
						}
					}
				}
				if(type_1 == 13) {
					JavaExpressionPeer.Indirect indirect_29 = peer_.getJavaExpressionForSymbol();
					if(indirect_29 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_12 = element.getBaseArgumentToken(0);
						indirect_29.createThis(keywordToken_12.getLineNumber(), keywordToken_12.getCharacterNumber());
					}
				}
				if(type_1 == 14) {
					JavaExpressionPeer.Indirect indirect_30 = peer_.getJavaExpressionForSymbol();
					if(indirect_30 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_13 = element.getBaseArgumentToken(0);
						indirect_30.createNull(keywordToken_13.getLineNumber(), keywordToken_13.getCharacterNumber());
					}
				}
				if(type_1 == 15) {
					JavaExpressionPeer.Indirect indirect_31 = peer_.getJavaExpressionForSymbol();
					if(indirect_31 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken_1 = element.getBaseArgumentToken(0);
						indirect_31.createMark(markNameToken_1.getStringValue(), markNameToken_1.getLineNumber(), markNameToken_1.getCharacterNumber());
					}
				}
			}
			if(index == 2) {
				int type_2 = element.getType();
				if(type_2 == 0) {
					JavaExpressionPeer.Indirect indirect_32 = peer_.getJavaExpressionForRight();
					if(indirect_32 != null) {
						JavaExpressionPeer.BinaryPatternPeer child_26 = indirect_32.createBinary();
						if(child_26 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child_26));
							child_26.end();
						}
					}
				}
				if(type_2 == 1) {
					JavaExpressionPeer.Indirect indirect_33 = peer_.getJavaExpressionForRight();
					if(indirect_33 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_27 = indirect_33.createGeneralBinary(symbolToken_2.getLineNumber(), symbolToken_2.getCharacterNumber());
						if(child_27 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_27));
							child_27.end();
						}
					}
				}
				if(type_2 == 2) {
					JavaExpressionPeer.Indirect indirect_34 = peer_.getJavaExpressionForRight();
					if(indirect_34 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_28 = indirect_34.createPostUnary();
						if(child_28 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_28));
							child_28.end();
						}
					}
				}
				if(type_2 == 3) {
					JavaExpressionPeer.Indirect indirect_35 = peer_.getJavaExpressionForRight();
					if(indirect_35 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_29 = indirect_35.createPreUnary();
						if(child_29 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_29));
							child_29.end();
						}
					}
				}
				if(type_2 == 4) {
					JavaExpressionPeer.Indirect indirect_36 = peer_.getJavaExpressionForRight();
					if(indirect_36 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_14 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_30 = indirect_36.createAssignment(keywordToken_14.getLineNumber(), keywordToken_14.getCharacterNumber());
						if(child_30 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_30));
							child_30.end();
						}
					}
				}
				if(type_2 == 5) {
					JavaExpressionPeer.Indirect indirect_37 = peer_.getJavaExpressionForRight();
					if(indirect_37 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_31 = indirect_37.createMappingVariableRef();
						if(child_31 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_31));
							child_31.end();
						}
					}
				}
				if(type_2 == 6) {
					JavaExpressionPeer.Indirect indirect_38 = peer_.getJavaExpressionForRight();
					if(indirect_38 != null) {
						JavaExpressionPeer.CallPatternPeer child_32 = indirect_38.createCall();
						if(child_32 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_32));
							child_32.end();
						}
					}
				}
				if(type_2 == 7) {
					JavaExpressionPeer.Indirect indirect_39 = peer_.getJavaExpressionForRight();
					if(indirect_39 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_15 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_33 = indirect_39.createBracketed(keywordToken_15.getLineNumber(), keywordToken_15.getCharacterNumber());
						if(child_33 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_33));
							child_33.end();
						}
					}
				}
				if(type_2 == 8) {
					JavaExpressionPeer.Indirect indirect_40 = peer_.getJavaExpressionForRight();
					if(indirect_40 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_34 = indirect_40.createBuilderVariableRef();
						if(child_34 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_34));
							child_34.end();
						}
					}
				}
				if(type_2 == 9) {
					JavaExpressionPeer.Indirect indirect_41 = peer_.getJavaExpressionForRight();
					if(indirect_41 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_16 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_35 = indirect_41.createArrayConstructorCall(keywordToken_16.getLineNumber(), keywordToken_16.getCharacterNumber());
						if(child_35 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_35));
							child_35.end();
						}
					}
				}
				if(type_2 == 10) {
					JavaExpressionPeer.Indirect indirect_42 = peer_.getJavaExpressionForRight();
					if(indirect_42 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_17 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_36 = indirect_42.createGivenArray(keywordToken_17.getLineNumber(), keywordToken_17.getCharacterNumber());
						if(child_36 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_36));
							child_36.end();
						}
					}
				}
				if(type_2 == 11) {
					JavaExpressionPeer.Indirect indirect_43 = peer_.getJavaExpressionForRight();
					if(indirect_43 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_18 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_37 = indirect_43.createConstructorCall(keywordToken_18.getLineNumber(), keywordToken_18.getCharacterNumber());
						if(child_37 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_37));
							child_37.end();
						}
					}
				}
				if(type_2 == 12) {
					JavaExpressionPeer.Indirect indirect_44 = peer_.getJavaExpressionForRight();
					if(indirect_44 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_38 = indirect_44.createPrimitive();
						if(child_38 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_38));
							child_38.end();
						}
					}
				}
				if(type_2 == 13) {
					JavaExpressionPeer.Indirect indirect_45 = peer_.getJavaExpressionForRight();
					if(indirect_45 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_19 = element.getBaseArgumentToken(0);
						indirect_45.createThis(keywordToken_19.getLineNumber(), keywordToken_19.getCharacterNumber());
					}
				}
				if(type_2 == 14) {
					JavaExpressionPeer.Indirect indirect_46 = peer_.getJavaExpressionForRight();
					if(indirect_46 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_20 = element.getBaseArgumentToken(0);
						indirect_46.createNull(keywordToken_20.getLineNumber(), keywordToken_20.getCharacterNumber());
					}
				}
				if(type_2 == 15) {
					JavaExpressionPeer.Indirect indirect_47 = peer_.getJavaExpressionForRight();
					if(indirect_47 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken_2 = element.getBaseArgumentToken(0);
						indirect_47.createMark(markNameToken_2.getStringValue(), markNameToken_2.getLineNumber(), markNameToken_2.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class PostUnaryDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaExpressionPeer.PostUnaryPatternPeer peer_;
		public PostUnaryDecoder(JavaExpressionPeer.PostUnaryPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForValue();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child = indirect.createBinary();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForValue();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_1 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForValue();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_2 = indirect_2.createPostUnary();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForValue();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_3 = indirect_3.createPreUnary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForValue();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_4 = indirect_4.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForValue();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_5 = indirect_5.createMappingVariableRef();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForValue();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_6 = indirect_6.createCall();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForValue();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_7 = indirect_7.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForValue();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_8 = indirect_8.createBuilderVariableRef();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForValue();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_9 = indirect_9.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForValue();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_10 = indirect_10.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForValue();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_11 = indirect_11.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForValue();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_12 = indirect_12.createPrimitive();
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_12));
							child_12.end();
						}
					}
				}
				if(type == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForValue();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForValue();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForValue();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
			if(index == 1) {
				GeneralSymbolPatternPeer child_13 = peer_.addGeneralSymbolForSymbol();
				if(child_13 != null) {
					element.updateConstruction(new AllDecodersSkeleton.GeneralSymbolDecoder(child_13));
					child_13.end();
				}
			}
		}
	}
	public static final class PreUnaryDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaExpressionPeer.PreUnaryPatternPeer peer_;
		public PreUnaryDecoder(JavaExpressionPeer.PreUnaryPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				GeneralSymbolPatternPeer child = peer_.addGeneralSymbolForSymbol();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.GeneralSymbolDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				int type = element.getType();
				if(type == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForValue();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child_1 = indirect.createBinary();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForValue();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_2 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForValue();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_3 = indirect_2.createPostUnary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForValue();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_4 = indirect_3.createPreUnary();
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForValue();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_5 = indirect_4.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForValue();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_6 = indirect_5.createMappingVariableRef();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForValue();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_7 = indirect_6.createCall();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForValue();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_8 = indirect_7.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForValue();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_9 = indirect_8.createBuilderVariableRef();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForValue();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_10 = indirect_9.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForValue();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_11 = indirect_10.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForValue();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_12 = indirect_11.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_12));
							child_12.end();
						}
					}
				}
				if(type == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForValue();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_13 = indirect_12.createPrimitive();
						if(child_13 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_13));
							child_13.end();
						}
					}
				}
				if(type == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForValue();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForValue();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForValue();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class AssignmentDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaExpressionPeer.AssignmentPatternPeer peer_;
		public AssignmentDecoder(JavaExpressionPeer.AssignmentPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				JavaCallChainPatternPeer child = peer_.addJavaCallChainForVariable();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaCallChainDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				int type = element.getType();
				if(type == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForValue();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child_1 = indirect.createBinary();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForValue();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_2 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForValue();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_3 = indirect_2.createPostUnary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForValue();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_4 = indirect_3.createPreUnary();
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForValue();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_5 = indirect_4.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForValue();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_6 = indirect_5.createMappingVariableRef();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForValue();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_7 = indirect_6.createCall();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForValue();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_8 = indirect_7.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForValue();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_9 = indirect_8.createBuilderVariableRef();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForValue();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_10 = indirect_9.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForValue();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_11 = indirect_10.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForValue();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_12 = indirect_11.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_12));
							child_12.end();
						}
					}
				}
				if(type == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForValue();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_13 = indirect_12.createPrimitive();
						if(child_13 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_13));
							child_13.end();
						}
					}
				}
				if(type == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForValue();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForValue();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForValue();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class MappingVariableRefDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaExpressionPeer.MappingVariableRefPatternPeer peer_;
		public MappingVariableRefDecoder(JavaExpressionPeer.MappingVariableRefPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				BuilderVariableChainPatternPeer child = peer_.addBuilderVariableChainForMappingChain();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.BuilderVariableChainDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				BuilderVariableChainPatternPeer child_1 = peer_.addBuilderVariableChainForSourceVariable();
				if(child_1 != null) {
					element.updateConstruction(new AllDecodersSkeleton.BuilderVariableChainDecoder(child_1));
					child_1.end();
				}
			}
		}
	}
	public static final class CallDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaExpressionPeer.CallPatternPeer peer_;
		public CallDecoder(JavaExpressionPeer.CallPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				JavaCallChainPatternPeer child = peer_.addJavaCallChainForValue();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaCallChainDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class BracketedDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaExpressionPeer.BracketedPatternPeer peer_;
		public BracketedDecoder(JavaExpressionPeer.BracketedPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForValue();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child = indirect.createBinary();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForValue();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_1 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForValue();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_2 = indirect_2.createPostUnary();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForValue();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_3 = indirect_3.createPreUnary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForValue();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_4 = indirect_4.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForValue();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_5 = indirect_5.createMappingVariableRef();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForValue();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_6 = indirect_6.createCall();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForValue();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_7 = indirect_7.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForValue();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_8 = indirect_8.createBuilderVariableRef();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForValue();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_9 = indirect_9.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForValue();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_10 = indirect_10.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForValue();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_11 = indirect_11.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForValue();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_12 = indirect_12.createPrimitive();
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_12));
							child_12.end();
						}
					}
				}
				if(type == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForValue();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForValue();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForValue();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class BuilderVariableRefDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaExpressionPeer.BuilderVariableRefPatternPeer peer_;
		public BuilderVariableRefDecoder(JavaExpressionPeer.BuilderVariableRefPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				BuilderVariableChainPatternPeer child = peer_.addBuilderVariableChainForChain();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.BuilderVariableChainDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class ArrayConstructorCallDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaExpressionPeer.ArrayConstructorCallPatternPeer peer_;
		public ArrayConstructorCallDecoder(JavaExpressionPeer.ArrayConstructorCallPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken typeNameToken = element.getBaseArgumentToken(0);
				TargetTypeReferenceWithoutArrayPatternPeer child = peer_.addTargetTypeReferenceWithoutArrayForTypeName(typeNameToken.getStringValue(), typeNameToken.getLineNumber(), typeNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeReferenceWithoutArrayDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				int type = element.getType();
				if(type == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForDimensionExpression();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child_1 = indirect.createBinary();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForDimensionExpression();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_2 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForDimensionExpression();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_3 = indirect_2.createPostUnary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForDimensionExpression();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_4 = indirect_3.createPreUnary();
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForDimensionExpression();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_5 = indirect_4.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForDimensionExpression();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_6 = indirect_5.createMappingVariableRef();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForDimensionExpression();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_7 = indirect_6.createCall();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForDimensionExpression();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_8 = indirect_7.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForDimensionExpression();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_9 = indirect_8.createBuilderVariableRef();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForDimensionExpression();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_10 = indirect_9.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForDimensionExpression();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_11 = indirect_10.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForDimensionExpression();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_12 = indirect_11.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_12));
							child_12.end();
						}
					}
				}
				if(type == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForDimensionExpression();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_13 = indirect_12.createPrimitive();
						if(child_13 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_13));
							child_13.end();
						}
					}
				}
				if(type == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForDimensionExpression();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForDimensionExpression();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForDimensionExpression();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class GivenArrayDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaExpressionPeer.GivenArrayPatternPeer peer_;
		public GivenArrayDecoder(JavaExpressionPeer.GivenArrayPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken typeNameToken = element.getBaseArgumentToken(0);
				TargetTypeReferenceWithoutArrayPatternPeer child = peer_.addTargetTypeReferenceWithoutArrayForTypeName(typeNameToken.getStringValue(), typeNameToken.getLineNumber(), typeNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeReferenceWithoutArrayDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				TargetCallArgumentsPatternPeer child_1 = peer_.addTargetCallArgumentsForValues();
				if(child_1 != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetCallArgumentsDecoder(child_1));
					child_1.end();
				}
			}
		}
	}
	public static final class ConstructorCallDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaExpressionPeer.ConstructorCallPatternPeer peer_;
		public ConstructorCallDecoder(JavaExpressionPeer.ConstructorCallPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken typeNameToken = element.getBaseArgumentToken(0);
				TargetTypeReferenceWithoutArrayPatternPeer child = peer_.addTargetTypeReferenceWithoutArrayForTypeName(typeNameToken.getStringValue(), typeNameToken.getLineNumber(), typeNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeReferenceWithoutArrayDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				TargetCallArgumentsPatternPeer child_1 = peer_.addTargetCallArgumentsForArguments();
				if(child_1 != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetCallArgumentsDecoder(child_1));
					child_1.end();
				}
			}
		}
	}
	public static final class PrimitiveDecoder_1 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaExpressionPeer.PrimitivePatternPeer peer_;
		public PrimitiveDecoder_1(JavaExpressionPeer.PrimitivePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addCharValue(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
			if(index == 1) {
				peer_.addString(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
			if(index == 2) {
				peer_.addInteger(token.getIntValue(), token.getLineNumber(), token.getCharacterNumber());
			}
			if(index == 3) {
				peer_.addBooleanValue(token.getBooleanValue(), token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
		}
	}
	public static final class JavaInstanceVariableDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaInstanceVariablePatternPeer peer_;
		public JavaInstanceVariableDecoder(JavaInstanceVariablePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addPublic();
			}
			if(index == 1) {
				peer_.addPrivate();
			}
			if(index == 2) {
				peer_.addIsFinal();
			}
			if(index == 3) {
				peer_.addIsStatic();
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken typeNameToken = element.getBaseArgumentToken(0);
				TargetTypeReferencePatternPeer child = peer_.addTargetTypeReferenceForType(typeNameToken.getStringValue(), typeNameToken.getLineNumber(), typeNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeReferenceDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				ChainHookListPatternPeer child_1 = peer_.addChainHookListForChainHookList();
				if(child_1 != null) {
					element.updateConstruction(new AllDecodersSkeleton.ChainHookListDecoder(child_1));
					child_1.end();
				}
			}
			if(index == 2) {
				int type = element.getType();
				if(type == 0) {
					NamePeer.BasicPatternPeer child_2 = peer_.addOptionBasicOfNameForNameOutput();
					if(child_2 != null) {
						element.updateConstruction(new AllDecodersSkeleton.BasicDecoder_1(child_2));
						child_2.end();
					}
				}
				if(type == 1) {
					org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken classNameToken = element.getBaseArgumentToken(1);
					org.ffd2.austenx.runtime.BaseToken methodNameToken = element.getBaseArgumentToken(2);
					peer_.addOptionImplementsOfNameForNameOutput(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), classNameToken.getStringValue(), methodNameToken.getStringValue(), methodNameToken.getLineNumber(), methodNameToken.getCharacterNumber());
				}
			}
			if(index == 3) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForInitialValue();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child_3 = indirect.createBinary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type_1 == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForInitialValue();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_4 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type_1 == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForInitialValue();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_5 = indirect_2.createPostUnary();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type_1 == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForInitialValue();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_6 = indirect_3.createPreUnary();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type_1 == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForInitialValue();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_7 = indirect_4.createAssignment(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type_1 == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForInitialValue();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_8 = indirect_5.createMappingVariableRef();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type_1 == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForInitialValue();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_9 = indirect_6.createCall();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type_1 == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForInitialValue();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_10 = indirect_7.createBracketed(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type_1 == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForInitialValue();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_11 = indirect_8.createBuilderVariableRef();
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type_1 == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForInitialValue();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_12 = indirect_9.createArrayConstructorCall(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_12));
							child_12.end();
						}
					}
				}
				if(type_1 == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForInitialValue();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_13 = indirect_10.createGivenArray(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_13 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_13));
							child_13.end();
						}
					}
				}
				if(type_1 == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForInitialValue();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_14 = indirect_11.createConstructorCall(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
						if(child_14 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_14));
							child_14.end();
						}
					}
				}
				if(type_1 == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForInitialValue();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_15 = indirect_12.createPrimitive();
						if(child_15 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_15));
							child_15.end();
						}
					}
				}
				if(type_1 == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForInitialValue();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type_1 == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForInitialValue();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_7 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_7.getLineNumber(), keywordToken_7.getCharacterNumber());
					}
				}
				if(type_1 == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForInitialValue();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class TargetTypeReferenceDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final TargetTypeReferencePatternPeer peer_;
		public TargetTypeReferenceDecoder(TargetTypeReferencePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 1) {
				peer_.addArrayCount(token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				BuilderVariableChainPatternPeer child = peer_.addBuilderVariableChainForBuilderVariableChain();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.BuilderVariableChainDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				org.ffd2.austenx.runtime.BaseToken typeNameToken = element.getBaseArgumentToken(0);
				TargetTypeReferencePatternPeer child_1 = peer_.addTargetTypeReferenceForGenericTypes(typeNameToken.getStringValue(), typeNameToken.getLineNumber(), typeNameToken.getCharacterNumber());
				if(child_1 != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeReferenceDecoder(child_1));
					child_1.end();
				}
			}
		}
	}
	public static final class TargetTypeReferenceWithoutArrayDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final TargetTypeReferenceWithoutArrayPatternPeer peer_;
		public TargetTypeReferenceWithoutArrayDecoder(TargetTypeReferenceWithoutArrayPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				BuilderVariableChainPatternPeer child = peer_.addBuilderVariableChainForBuilderVariableChain();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.BuilderVariableChainDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				org.ffd2.austenx.runtime.BaseToken typeNameToken = element.getBaseArgumentToken(0);
				TargetTypeReferencePatternPeer child_1 = peer_.addTargetTypeReferenceForGenericTypes(typeNameToken.getStringValue(), typeNameToken.getLineNumber(), typeNameToken.getCharacterNumber());
				if(child_1 != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeReferenceDecoder(child_1));
					child_1.end();
				}
			}
		}
	}
	public static final class BaseTargetTypeReferenceDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final BaseTargetTypeReferencePatternPeer peer_;
		public BaseTargetTypeReferenceDecoder(BaseTargetTypeReferencePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				BuilderVariableChainPatternPeer child = peer_.addBuilderVariableChainForBuilderVariableChain();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.BuilderVariableChainDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class JavaCallChainDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaCallChainPatternPeer peer_;
		public JavaCallChainDecoder(JavaCallChainPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addHasThis();
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaCallChainSectionPeer.ViaPatternPeer child = peer_.addOptionViaOfJavaCallChainSectionForSection();
					if(child != null) {
						element.updateConstruction(new AllDecodersSkeleton.ViaDecoder(child));
						child.end();
					}
				}
				if(type == 1) {
					JavaCallChainSectionPeer.LocalPatternPeer child_1 = peer_.addOptionLocalOfJavaCallChainSectionForSection();
					if(child_1 != null) {
						element.updateConstruction(new AllDecodersSkeleton.LocalDecoder(child_1));
						child_1.end();
					}
				}
				if(type == 2) {
					JavaCallChainSectionPeer.VariablePatternPeer child_2 = peer_.addOptionVariableOfJavaCallChainSectionForSection();
					if(child_2 != null) {
						element.updateConstruction(new AllDecodersSkeleton.VariableDecoder(child_2));
						child_2.end();
					}
				}
			}
			if(index == 1) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForIndexValue();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child_3 = indirect.createBinary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type_1 == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForIndexValue();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_4 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type_1 == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForIndexValue();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_5 = indirect_2.createPostUnary();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type_1 == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForIndexValue();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_6 = indirect_3.createPreUnary();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type_1 == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForIndexValue();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_7 = indirect_4.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type_1 == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForIndexValue();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_8 = indirect_5.createMappingVariableRef();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type_1 == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForIndexValue();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_9 = indirect_6.createCall();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type_1 == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForIndexValue();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_10 = indirect_7.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type_1 == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForIndexValue();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_11 = indirect_8.createBuilderVariableRef();
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type_1 == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForIndexValue();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_12 = indirect_9.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_12));
							child_12.end();
						}
					}
				}
				if(type_1 == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForIndexValue();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_13 = indirect_10.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_13 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_13));
							child_13.end();
						}
					}
				}
				if(type_1 == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForIndexValue();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_14 = indirect_11.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_14 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_14));
							child_14.end();
						}
					}
				}
				if(type_1 == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForIndexValue();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_15 = indirect_12.createPrimitive();
						if(child_15 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_15));
							child_15.end();
						}
					}
				}
				if(type_1 == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForIndexValue();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type_1 == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForIndexValue();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type_1 == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForIndexValue();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class ViaDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaCallChainSectionPeer.ViaPatternPeer peer_;
		public ViaDecoder(JavaCallChainSectionPeer.ViaPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addSpecificClassName(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
			if(index == 1) {
				peer_.addVariable(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				BuilderVariableChainPatternPeer child = peer_.addBuilderVariableChainForBuilderVariableChain();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.BuilderVariableChainDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
				JavaMethodCallPatternPeer child_1 = peer_.addJavaMethodCallForMethod(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
				if(child_1 != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaMethodCallDecoder(child_1));
					child_1.end();
				}
			}
		}
	}
	public static final class LocalDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaCallChainSectionPeer.LocalPatternPeer peer_;
		public LocalDecoder(JavaCallChainSectionPeer.LocalPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addSpecificClassName(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
			if(index == 1) {
				peer_.addVariable(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
				JavaMethodCallPatternPeer child = peer_.addJavaMethodCallForMethod(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaMethodCallDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class VariableDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaCallChainSectionPeer.VariablePatternPeer peer_;
		public VariableDecoder(JavaCallChainSectionPeer.VariablePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				BuilderVariableChainPatternPeer child = peer_.addBuilderVariableChainForBuilderVariableChain();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.BuilderVariableChainDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class JavaMethodCallDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final JavaMethodCallPatternPeer peer_;
		public JavaMethodCallDecoder(JavaMethodCallPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				TargetCallArgumentsPatternPeer child = peer_.addTargetCallArgumentsForArguments();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetCallArgumentsDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class TargetCallArgumentsDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final TargetCallArgumentsPatternPeer peer_;
		public TargetCallArgumentsDecoder(TargetCallArgumentsPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
					peer_.addOptionMarkOfTargetCallComponentForArgument(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
				}
				if(type == 1) {
					TargetCallComponentPeer.BasicPatternPeer child = peer_.addOptionBasicOfTargetCallComponentForArgument();
					if(child != null) {
						element.updateConstruction(new AllDecodersSkeleton.BasicDecoder(child));
						child.end();
					}
				}
				if(type == 2) {
					org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
					TargetCallComponentPeer.LinkPatternPeer child_1 = peer_.addOptionLinkOfTargetCallComponentForArgument(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
					if(child_1 != null) {
						element.updateConstruction(new AllDecodersSkeleton.LinkDecoder_3(child_1));
						child_1.end();
					}
				}
			}
		}
	}
	public static final class BasicDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final TargetCallComponentPeer.BasicPatternPeer peer_;
		public BasicDecoder(TargetCallComponentPeer.BasicPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					JavaExpressionPeer.Indirect indirect = peer_.getJavaExpressionForArgument();
					if(indirect != null) {
						JavaExpressionPeer.BinaryPatternPeer child = indirect.createBinary();
						if(child != null) {
							element.updateConstruction(new AllDecodersSkeleton.BinaryDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					JavaExpressionPeer.Indirect indirect_1 = peer_.getJavaExpressionForArgument();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken symbolToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GeneralBinaryPatternPeer child_1 = indirect_1.createGeneralBinary(symbolToken.getLineNumber(), symbolToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GeneralBinaryDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					JavaExpressionPeer.Indirect indirect_2 = peer_.getJavaExpressionForArgument();
					if(indirect_2 != null) {
						JavaExpressionPeer.PostUnaryPatternPeer child_2 = indirect_2.createPostUnary();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PostUnaryDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					JavaExpressionPeer.Indirect indirect_3 = peer_.getJavaExpressionForArgument();
					if(indirect_3 != null) {
						JavaExpressionPeer.PreUnaryPatternPeer child_3 = indirect_3.createPreUnary();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					JavaExpressionPeer.Indirect indirect_4 = peer_.getJavaExpressionForArgument();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						JavaExpressionPeer.AssignmentPatternPeer child_4 = indirect_4.createAssignment(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersSkeleton.AssignmentDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					JavaExpressionPeer.Indirect indirect_5 = peer_.getJavaExpressionForArgument();
					if(indirect_5 != null) {
						JavaExpressionPeer.MappingVariableRefPatternPeer child_5 = indirect_5.createMappingVariableRef();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersSkeleton.MappingVariableRefDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type == 6) {
					JavaExpressionPeer.Indirect indirect_6 = peer_.getJavaExpressionForArgument();
					if(indirect_6 != null) {
						JavaExpressionPeer.CallPatternPeer child_6 = indirect_6.createCall();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersSkeleton.CallDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type == 7) {
					JavaExpressionPeer.Indirect indirect_7 = peer_.getJavaExpressionForArgument();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.BracketedPatternPeer child_7 = indirect_7.createBracketed(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BracketedDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type == 8) {
					JavaExpressionPeer.Indirect indirect_8 = peer_.getJavaExpressionForArgument();
					if(indirect_8 != null) {
						JavaExpressionPeer.BuilderVariableRefPatternPeer child_8 = indirect_8.createBuilderVariableRef();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersSkeleton.BuilderVariableRefDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type == 9) {
					JavaExpressionPeer.Indirect indirect_9 = peer_.getJavaExpressionForArgument();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ArrayConstructorCallPatternPeer child_9 = indirect_9.createArrayConstructorCall(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ArrayConstructorCallDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type == 10) {
					JavaExpressionPeer.Indirect indirect_10 = peer_.getJavaExpressionForArgument();
					if(indirect_10 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.GivenArrayPatternPeer child_10 = indirect_10.createGivenArray(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersSkeleton.GivenArrayDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type == 11) {
					JavaExpressionPeer.Indirect indirect_11 = peer_.getJavaExpressionForArgument();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
						JavaExpressionPeer.ConstructorCallPatternPeer child_11 = indirect_11.createConstructorCall(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersSkeleton.ConstructorCallDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type == 12) {
					JavaExpressionPeer.Indirect indirect_12 = peer_.getJavaExpressionForArgument();
					if(indirect_12 != null) {
						JavaExpressionPeer.PrimitivePatternPeer child_12 = indirect_12.createPrimitive();
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PrimitiveDecoder_1(child_12));
							child_12.end();
						}
					}
				}
				if(type == 13) {
					JavaExpressionPeer.Indirect indirect_13 = peer_.getJavaExpressionForArgument();
					if(indirect_13 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
						indirect_13.createThis(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
					}
				}
				if(type == 14) {
					JavaExpressionPeer.Indirect indirect_14 = peer_.getJavaExpressionForArgument();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
						indirect_14.createNull(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
					}
				}
				if(type == 15) {
					JavaExpressionPeer.Indirect indirect_15 = peer_.getJavaExpressionForArgument();
					if(indirect_15 != null) {
						org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
						indirect_15.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class LinkDecoder_3 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final TargetCallComponentPeer.LinkPatternPeer peer_;
		public LinkDecoder_3(TargetCallComponentPeer.LinkPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				LinkChainPatternPeer child = peer_.addLinkChainForSingleChain();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.LinkChainDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				DeferredTargetCallComponent tool = new DeferredTargetCallComponentImpl(element);
				peer_.setTargetCallComponentForArgument(tool);
			}
		}
	}
	public static final class BasicDecoder_1 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final NamePeer.BasicPatternPeer peer_;
		public BasicDecoder_1(NamePeer.BasicPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					org.ffd2.austenx.runtime.BaseToken valueToken = element.getBaseArgumentToken(0);
					peer_.addOptionStraightOfNameValueForComponent(valueToken.getStringValue(), valueToken.getLineNumber(), valueToken.getCharacterNumber());
				}
				if(type == 1) {
					NameValuePeer.VariablePatternPeer child = peer_.addOptionVariableOfNameValueForComponent();
					if(child != null) {
						element.updateConstruction(new AllDecodersSkeleton.VariableDecoder_1(child));
						child.end();
					}
				}
				if(type == 2) {
					org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
					NameValuePeer.LinkPatternPeer child_1 = peer_.addOptionLinkOfNameValueForComponent(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
					if(child_1 != null) {
						element.updateConstruction(new AllDecodersSkeleton.LinkDecoder_4(child_1));
						child_1.end();
					}
				}
			}
		}
	}
	public static final class VariableDecoder_1 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final NameValuePeer.VariablePatternPeer peer_;
		public VariableDecoder_1(NameValuePeer.VariablePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				BuilderVariableChainPatternPeer child = peer_.addBuilderVariableChainForRef();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.BuilderVariableChainDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class LinkDecoder_4 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final NameValuePeer.LinkPatternPeer peer_;
		public LinkDecoder_4(NameValuePeer.LinkPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				LinkChainPatternPeer child = peer_.addLinkChainForChain();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.LinkChainDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				int type = element.getType();
				if(type == 0) {
					NameValuePeer.Indirect indirect = peer_.getNameValueForComponent();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken valueToken = element.getBaseArgumentToken(0);
						indirect.createStraight(valueToken.getStringValue(), valueToken.getLineNumber(), valueToken.getCharacterNumber());
					}
				}
				if(type == 1) {
					NameValuePeer.Indirect indirect_1 = peer_.getNameValueForComponent();
					if(indirect_1 != null) {
						NameValuePeer.VariablePatternPeer child_1 = indirect_1.createVariable();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.VariableDecoder_1(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					NameValuePeer.Indirect indirect_2 = peer_.getNameValueForComponent();
					if(indirect_2 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						NameValuePeer.LinkPatternPeer child_2 = indirect_2.createLink(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.LinkDecoder_4(child_2));
							child_2.end();
						}
					}
				}
			}
		}
	}
	public static final class BuilderVariableChainDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final BuilderVariableChainPatternPeer peer_;
		public BuilderVariableChainDecoder(BuilderVariableChainPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addValue(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
		}
	}
	public static final class LinkChainDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final LinkChainPatternPeer peer_;
		public LinkChainDecoder(LinkChainPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addVariableName(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
			if(index == 1) {
				peer_.addIsNotNodeName(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
			if(index == 2) {
				peer_.addNodeName(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
		}
	}
	public static final class PreUnaryDecoder_1 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final BuilderExpressionPeer.PreUnaryPatternPeer peer_;
		public PreUnaryDecoder_1(BuilderExpressionPeer.PreUnaryPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				GeneralSymbolPatternPeer child = peer_.addGeneralSymbolForSymboll();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.GeneralSymbolDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				int type = element.getType();
				if(type == 0) {
					BuilderExpressionPeer.Indirect indirect = peer_.getBuilderExpressionForValue();
					if(indirect != null) {
						BuilderExpressionPeer.PreUnaryPatternPeer child_1 = indirect.createPreUnary();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersSkeleton.PreUnaryDecoder_1(child_1));
							child_1.end();
						}
					}
				}
				if(type == 1) {
					BuilderExpressionPeer.Indirect indirect_1 = peer_.getBuilderExpressionForValue();
					if(indirect_1 != null) {
						BuilderExpressionPeer.VariablePatternPeer child_2 = indirect_1.createVariable();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersSkeleton.VariableDecoder_2(child_2));
							child_2.end();
						}
					}
				}
			}
		}
	}
	public static final class VariableDecoder_2 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final BuilderExpressionPeer.VariablePatternPeer peer_;
		public VariableDecoder_2(BuilderExpressionPeer.VariablePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				BuilderVariableChainPatternPeer child = peer_.addBuilderVariableChainForRef();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.BuilderVariableChainDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class SimpleDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final TargetParameterPeer.SimplePatternPeer peer_;
		public SimpleDecoder(TargetParameterPeer.SimplePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken typeNameToken = element.getBaseArgumentToken(0);
				TargetTypeReferencePatternPeer child = peer_.addTargetTypeReferenceForType(typeNameToken.getStringValue(), typeNameToken.getLineNumber(), typeNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeReferenceDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				int type = element.getType();
				if(type == 0) {
					NamePeer.BasicPatternPeer child_1 = peer_.addOptionBasicOfNameForNameOutput();
					if(child_1 != null) {
						element.updateConstruction(new AllDecodersSkeleton.BasicDecoder_1(child_1));
						child_1.end();
					}
				}
				if(type == 1) {
					org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken classNameToken = element.getBaseArgumentToken(1);
					org.ffd2.austenx.runtime.BaseToken methodNameToken = element.getBaseArgumentToken(2);
					peer_.addOptionImplementsOfNameForNameOutput(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), classNameToken.getStringValue(), methodNameToken.getStringValue(), methodNameToken.getLineNumber(), methodNameToken.getCharacterNumber());
				}
			}
		}
	}
	public static final class LinkDecoder_5 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final TargetParameterPeer.LinkPatternPeer peer_;
		public LinkDecoder_5(TargetParameterPeer.LinkPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				LinkChainPatternPeer child = peer_.addLinkChainForSingleChain();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.LinkChainDecoder(child));
					child.end();
				}
			}
			if(index == 1) {
				DeferredTargetParameter tool = new DeferredTargetParameterImpl(element);
				peer_.setTargetParameterForParameters(tool);
			}
		}
	}
	public static final class ParameterBlockDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ParameterBlockPatternPeer peer_;
		public ParameterBlockDecoder(ParameterBlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(1);
					ParameterPeer.BlockPatternPeer child = peer_.addOptionBlockOfParameterForParameter(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
					if(child != null) {
						element.updateConstruction(new AllDecodersSkeleton.BlockDecoder_2(child));
						child.end();
					}
				}
				if(type == 1) {
					org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken chainNameToken = element.getBaseArgumentToken(1);
					org.ffd2.austenx.runtime.BaseToken variableNameToken = element.getBaseArgumentToken(2);
					peer_.addOptionChainOfParameterForParameter(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), chainNameToken.getStringValue(), variableNameToken.getStringValue());
				}
				if(type == 2) {
					org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken mappingNameToken = element.getBaseArgumentToken(1);
					org.ffd2.austenx.runtime.BaseToken variableNameToken_1 = element.getBaseArgumentToken(2);
					peer_.addOptionMappingOfParameterForParameter(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber(), mappingNameToken.getStringValue(), variableNameToken_1.getStringValue());
				}
				if(type == 3) {
					org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken keyNameToken = element.getBaseArgumentToken(1);
					org.ffd2.austenx.runtime.BaseToken variableNameToken_2 = element.getBaseArgumentToken(2);
					peer_.addOptionKeyOfParameterForParameter(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber(), keyNameToken.getStringValue(), variableNameToken_2.getStringValue());
				}
			}
		}
	}
	public static final class BlockDecoder_2 implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ParameterPeer.BlockPatternPeer peer_;
		public BlockDecoder_2(ParameterPeer.BlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addIsArray(token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				DesignTypePatternPeer child = peer_.addDesignTypeForType();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.DesignTypeDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class MacroParameterBlockDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final MacroParameterBlockPatternPeer peer_;
		public MacroParameterBlockDecoder(MacroParameterBlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(1);
					MacroParameterPeer.RecordPatternPeer child = peer_.addOptionRecordOfMacroParameterForParameter(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
					if(child != null) {
						element.updateConstruction(new AllDecodersSkeleton.RecordDecoder(child));
						child.end();
					}
				}
				if(type == 1) {
					org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(0);
					MacroParameterPeer.VarPatternPeer child_1 = peer_.addOptionVarOfMacroParameterForParameter(nameToken_1.getStringValue(), nameToken_1.getLineNumber(), nameToken_1.getCharacterNumber());
					if(child_1 != null) {
						element.updateConstruction(new AllDecodersSkeleton.VarDecoder(child_1));
						child_1.end();
					}
				}
				if(type == 2) {
					org.ffd2.austenx.runtime.BaseToken nameToken_2 = element.getBaseArgumentToken(0);
					MacroParameterPeer.TargetPatternPeer child_2 = peer_.addOptionTargetOfMacroParameterForParameter(nameToken_2.getStringValue(), nameToken_2.getLineNumber(), nameToken_2.getCharacterNumber());
					if(child_2 != null) {
						element.updateConstruction(new AllDecodersSkeleton.TargetDecoder(child_2));
						child_2.end();
					}
				}
				if(type == 3) {
					org.ffd2.austenx.runtime.BaseToken variableNameToken = element.getBaseArgumentToken(0);
					peer_.addOptionCodeReferenceOfMacroParameterForParameter(variableNameToken.getStringValue(), variableNameToken.getLineNumber(), variableNameToken.getCharacterNumber());
				}
				if(type == 4) {
					org.ffd2.austenx.runtime.BaseToken variableNameToken_1 = element.getBaseArgumentToken(0);
					peer_.addOptionArgValuesReferenceOfMacroParameterForParameter(variableNameToken_1.getStringValue(), variableNameToken_1.getLineNumber(), variableNameToken_1.getCharacterNumber());
				}
				if(type == 5) {
					org.ffd2.austenx.runtime.BaseToken variableNameToken_2 = element.getBaseArgumentToken(0);
					peer_.addOptionArgTypesReferenceOfMacroParameterForParameter(variableNameToken_2.getStringValue(), variableNameToken_2.getLineNumber(), variableNameToken_2.getCharacterNumber());
				}
				if(type == 6) {
					org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken chainNameToken = element.getBaseArgumentToken(1);
					org.ffd2.austenx.runtime.BaseToken variableNameToken_3 = element.getBaseArgumentToken(2);
					peer_.addOptionChainOfMacroParameterForParameter(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), chainNameToken.getStringValue(), variableNameToken_3.getStringValue());
				}
				if(type == 7) {
					org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken mappingNameToken = element.getBaseArgumentToken(1);
					org.ffd2.austenx.runtime.BaseToken variableNameToken_4 = element.getBaseArgumentToken(2);
					peer_.addOptionMappingOfMacroParameterForParameter(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber(), mappingNameToken.getStringValue(), variableNameToken_4.getStringValue());
				}
				if(type == 8) {
					org.ffd2.austenx.runtime.BaseToken nameToken_3 = element.getBaseArgumentToken(0);
					peer_.addOptionClassReferenceOfMacroParameterForParameter(nameToken_3.getStringValue(), nameToken_3.getLineNumber(), nameToken_3.getCharacterNumber());
				}
				if(type == 9) {
					org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken keyNameToken = element.getBaseArgumentToken(1);
					org.ffd2.austenx.runtime.BaseToken variableNameToken_5 = element.getBaseArgumentToken(2);
					peer_.addOptionKeyOfMacroParameterForParameter(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber(), keyNameToken.getStringValue(), variableNameToken_5.getStringValue());
				}
			}
		}
	}
	public static final class MacroCallParameterBlockDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final MacroCallParameterBlockPatternPeer peer_;
		public MacroCallParameterBlockDecoder(MacroCallParameterBlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
					MacroCallParameterPeer.TargetVariablePatternPeer child = peer_.addOptionTargetVariableOfMacroCallParameterForParameter(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
					if(child != null) {
						element.updateConstruction(new AllDecodersSkeleton.TargetVariableDecoder(child));
						child.end();
					}
				}
				if(type == 1) {
					org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(0);
					peer_.addOptionThisBasedOfMacroCallParameterForParameter(nameToken_1.getStringValue(), nameToken_1.getLineNumber(), nameToken_1.getCharacterNumber());
				}
				if(type == 2) {
					org.ffd2.austenx.runtime.BaseToken nameToken_2 = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken valueToken = element.getBaseArgumentToken(1);
					peer_.addOptionStringBasedOfMacroCallParameterForParameter(nameToken_2.getStringValue(), nameToken_2.getLineNumber(), nameToken_2.getCharacterNumber(), valueToken.getStringValue());
				}
				if(type == 3) {
					org.ffd2.austenx.runtime.BaseToken nameToken_3 = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken valueToken_1 = element.getBaseArgumentToken(1);
					peer_.addOptionIntBasedOfMacroCallParameterForParameter(nameToken_3.getStringValue(), nameToken_3.getLineNumber(), nameToken_3.getCharacterNumber(), valueToken_1.getIntValue());
				}
			}
		}
	}
	public static final class RecordDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final MacroParameterPeer.RecordPatternPeer peer_;
		public RecordDecoder(MacroParameterPeer.RecordPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addTypeElement(token.getStringValue(), token.getLineNumber(), token.getCharacterNumber());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
		}
	}
	public static final class VarDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final MacroParameterPeer.VarPatternPeer peer_;
		public VarDecoder(MacroParameterPeer.VarPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken typeNameToken = element.getBaseArgumentToken(0);
				TargetTypeReferencePatternPeer child = peer_.addTargetTypeReferenceForType(typeNameToken.getStringValue(), typeNameToken.getLineNumber(), typeNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeReferenceDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class TargetDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final MacroParameterPeer.TargetPatternPeer peer_;
		public TargetDecoder(MacroParameterPeer.TargetPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken typeNameToken = element.getBaseArgumentToken(0);
				TargetTypeReferencePatternPeer child = peer_.addTargetTypeReferenceForType(typeNameToken.getStringValue(), typeNameToken.getLineNumber(), typeNameToken.getCharacterNumber());
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.TargetTypeReferenceDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class TargetVariableDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final MacroCallParameterPeer.TargetVariablePatternPeer peer_;
		public TargetVariableDecoder(MacroCallParameterPeer.TargetVariablePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				JavaCallChainPatternPeer child = peer_.addJavaCallChainForCallChain();
				if(child != null) {
					element.updateConstruction(new AllDecodersSkeleton.JavaCallChainDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class SimpleParameterDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final SimpleParameterPatternPeer peer_;
		public SimpleParameterDecoder(SimpleParameterPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 1) {
				peer_.addArrayDimension();
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
		}
	}
}
